Package: arrayQuality
Version: 1.89.0
Date: 2010-04-13
Title: Assessing array quality on spotted arrays
Depends: R (>= 2.2.0)
Imports: graphics, grDevices, grid, gridBase, hexbin, limma, marray,
        methods, RColorBrewer, stats, utils
biocViews: Microarray,TwoChannel,QualityControl,Visualization
Suggests: mclust, MEEBOdata, HEEBOdata
Author: Agnes Paquet and Jean Yee Hwa Yang <yeehwa@stat.berkeley.edu>
Maintainer: Agnes Paquet <paquetagnes@yahoo.com>
Description: Functions for performing print-run and array level
        quality assessment.
License: LGPL
URL: http://arrays.ucsf.edu/
git_url: https://git.bioconductor.org/packages/arrayQuality
git_branch: devel
git_last_commit: 354cf88
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 20:03:03 UTC; biocbuild

###################################################
## READ  Spot file .txt file, returns a list of measures
## extracted from the Agilent file
## source("~/Projects/madman/Rpacks/arrayQuality/R/spotQuality.R")
##
###################################################

## No background substraction
## No normalization
## Suppose that fnames is a .spot file.
## Returns a list of data needed for quality
## Combines read.marrayRaw, maQualityMain, spotTools
## One slide only!!!

## returns a list of vector containing info from grp file column
readSpot <- function (fnames = NULL, path= ".", galfile = NULL, DEBUG=FALSE, skip = 0,
                     sep ="\t", quote= "\"", controlId = "ID", ...)
  {
    if (DEBUG) print("Starting readSpot")
    if (DEBUG) print(path)
    controlId <- controlId[1]
    # Test if input data is OK
##    if (is.null(path))  path <- "."

    if(!is.null(galfile))
      galf <- file.path(path, galfile)
    else
      {
        galf <- dir(pattern = ".*\\.gal$")[1]
        if(is.na(galf))
          stop("Missing galfile information.")
        else
          cat("User did not specify a galfile name, reading in ", galf, " from current directory. \n")
      }

    opt <- list(...)
    defs <- list(galfile=galf, path = path, sep=sep, skip=skip,
                  quote = quote) 
    read.Galfile.defs <- maDotsMatch(maDotsDefaults(opt, defs),
                                     formals(read.Galfile))
    if (DEBUG) print("Calling read.Galfile")
    #read.Galfile.defs <- maDotsDefaults(opt, defs)
    galdata <- do.call(read.Galfile, read.Galfile.defs)
    
    #galdata <- read.Galfile(galf)

    if (missing(fnames) | is.null(fnames)) 
      fnames <- dir(path, pattern = ".*\\.spot$")
    fullfnames <- file.path(path, fnames)
    f <- fullfnames[1]
    opt <- list(...)
    
    # Search in the Spot file where are the colums starting
    if (DEBUG) print("Estimating number of lines to skip")
    y <- readLines(fullfnames[1], n = 100)
    skip <- grep("Gmedian", y)[1] - 1
    if (DEBUG) print(skip)

    # Read data in       
    name <- id <- c()
    block <- column <- row <- c()
    Date <- PMTR <- PMTG <- normMethod <- normCoef <- c()
    Gfmedian <- Gfmean <- Gfsd <- c()
    Gbmedian <- Gbmean <- Gbsd <- c()
    Rfmedian <- Rfmean <- Rfsd <- c()
    Rbmedian <- Rbmean <- Rbsd <- c()
    Gfsat <- Rfsat <- c()
    spotDia <- spotFArea <- spotBArea <- c()
    Flags <- c()

    if (DEBUG) print(paste("Reading", f))
    h <- strsplit(readLines(f, n = skip + 1), split = sep)
    h <- as.list(unlist(h[[length(h)]]))
    names(h) <- gsub("\"", "", unlist(h))
#    dat <- scan(f, quiet = TRUE, what = h, sep = sep, skip = skip + 
 #               1, quote = quote, ...)
    scan.defs <- list(file=f,quiet = TRUE, what = h, sep = sep, skip = skip + 
                1, quote = quote)
    scan.args <- maDotsMatch(maDotsMatch(opt, scan.defs),
                             formals(args("scan")))
    
    dat <- do.call(scan, scan.args[-grep("nmax", names(scan.args))])
    gc <- as.numeric(dat[["grid.r"]])
    gr <- as.numeric(dat[["grid.c"]])
    numcol <- max(gc)
    block <- cbind(block,  (gr-1) * numcol + gc)
    column <- cbind(column, as.numeric(dat[["spot.c"]]))
    row <- cbind(row, as.numeric(dat[["spot.r"]]))
    name <- cbind(name, galdata$gnames@maInfo[["Name"]])
    id <- cbind(id, galdata$gnames@maInfo[[controlId]])
    if (DEBUG)
      {
        print("cchecking id")
        print(class(id))
        print(length(id))
      }
    Gfmedian <- cbind(Gfmedian, as.numeric(dat[["Gmedian"]]))
    Gfmean <- cbind(Gfmean, as.numeric(dat[["Gmean"]]))        
    Gfsd <- cbind(Gfsd, as.numeric(dat[["GIQR"]]))
    Gbmedian <- cbind(Gbmedian, as.numeric(dat[["bgGmed"]]))
    Gbmean <- cbind(Gbmean, as.numeric(dat[["bgGmean"]]))        
    Gbsd <- cbind(Gbsd, as.numeric(dat[["bgGSD"]]))
    Rfmedian <- cbind(Rfmedian, as.numeric(dat[["Rmedian"]]))
    Rfmean <- cbind(Rfmean, as.numeric(dat[["Rmean"]]))
    Rfsd <- cbind(Rfsd, as.numeric(dat[["RIQR"]]))
    Rbmedian <- cbind(Rbmedian, as.numeric(dat[["bgRmed"]]))
    Rbmean <- cbind(Rbmean, as.numeric(dat[["bgRmean"]]))
    Rbsd <- cbind(Rbsd, as.numeric(dat[["bgRSD"]]))        
##    Gfsat <- cbind(Gfsat, as.numeric(dat[["gNumSatPix"]]))
##    Rfsat <- cbind(Rfsat, as.numeric(dat[["rNumSatPix"]]))
##    spotDia <- cbind(spotDia, as.numeric(dat[["Dia."]]))  Not used
    spotFArea <- cbind(spotFArea, as.numeric(dat[["area"]]))
##    spotBArea <- cbind(spotBArea, as.numeric(dat[["gBGNumPix"]]))
    Flags <- cbind(Flags, as.numeric(dat[["circularity"]]) < 0.5)
    gprData <- list(File = fnames[1], Date = NA, PmtR = NA, PmtG = NA,
                    Normalization = NA, NormCoefficient = NA,
                    Name = name, ID = id,
                    Block = block, Column = column, Row = row,
                    GfMedian = Gfmedian, GfMean = Gfmean, GfSD = Gfsd,
                    GbMedian = Gbmedian, GbMean = Gbmean, GbSD = Gbsd,
                    RfMedian = Rfmedian, RfMean = Rfmean, RfSD = Rfsd,
                    RbMedian = Rbmedian, RbMean = Rbmean, RbSD = Rbsd,
                    GfSaturation = NA, RfSaturation = NA,
                    SpotDiameter = NA, spotArea = spotFArea,
                    bgArea = NA, Flags = Flags)
    
    # Result
    return(gprData)
  }



###################################################
## Given a spot files
## Computes needed statistics to assess quality
###################################################

## Takes all .spot file into acccount
## Plot quality boxplot and diagnostic plots
## creates html report
## if output: writes quality and normalized data to file
## return quality measure and marrayRaw object in a list

#############
## Example:
## test <- gpQuality(path="C:/Mydoc/Projects/quality/DemoA/", resdir="QualPlot")


## Must be run on the same spot files

###########################################################################
##
##  Move controlCode and maGenControls from marrayTools to marrayClasses
##  May 7, 2003
##  Sept 21, 2004
## TO USE:
## 1. Create Reference slides
##    reference <- globalQuality(fnames, inputsource = "readSpot")
## 2. Run : some alternative
##        -- spotQuality(fnames, reference = reference)  ## Use what you have created
##        -- spotQuality(fnames, reference = reference, compBoxplot=FALSE)
##                                    ## Only generate qualitative plots
##        -- spotQuality(fnames)  ## Use exisiting reference info
###########################################################################

spotQuality <- function(fnames = NULL, path = ".", galfile = NULL,
                      organism=c("Mm", "Hs"),
                      compBoxplot = TRUE,
                      reference=NULL,
                      #scalingTable=NULL,
                      controlMatrix = controlCode,
                      controlId = c("ID"),
                      output=FALSE,
                      resdir=".",
                      dev="png", #set default to be png 
                      DEBUG = FALSE,...)
{

    print("Starting spotQuality...")
    
    # Check input arguments
    if (missing(path) | is.null(path))  path <- "."
    
    if (missing(fnames) | is.null(fnames))
      fnames <- dir(path, pattern = ".*\\.spot$")

    organism <- organism[1]
    controlId <- controlId[1]
    if (DEBUG) print(controlId)
    if (DEBUG) print(controlMatrix)
    opt <- list(...)


 ###################
 ## Setting up output device

    if (DEBUG) print("Name of output device")
    plotdef <- switch(dev,
                      "bmp" = list(dev=list(width=800, height=600, bg="white"), suffix="bmp"),
                      "jpeg" = list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      "postscript" = list(dev=list( bg="white"), suffix="ps"),
                      ##"jpg" =  list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      ##"postscript" = list(dev=list(paper="special", width=8, height=6, bg="white"), suffix="ps"),
                      "png" =  list(dev=list(width=800, height=600, bg="white"), suffix="png"),
                      list(dev=list(width=800, height=600,bg="white"), suffix="png"))
    if(!is.element(dev, c("bmp", "jpeg","png","postscript")))
      {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

    if (DEBUG) print(paste("compBoxplot = ",compBoxplot, sep=""))

    ##############################################################
    ## COMPBOXPLOT = TRUE
    ##############################################################
    
    if (compBoxplot)
      {
        if(DEBUG) print("Starting compBoxplot")

        ## Prepares results
        quality <- c()
        tmp <- c()
        QCp <- c()
        Dp <- c()
        
        curdir <- getwd()
        if (!file.exists(resdir))
          dir.create(resdir)
        if (DEBUG) print(getwd())
        
        #Allocation of matrix for marrayraw object
        if(!is.null(galfile))
          galf <- galfile
        else
          {
            galf <- dir(path=path, pattern = ".*\\.gal$")[1]
            if(is.na(galf))
              stop("Missing galfile information.")
            else
              cat("No specific galfile names, reading in ", galf, " from ", path,  "directory. \n")
          }
        
        read.Galfile.defs <- maDotsMatch(maDotsDefaults(opt, list(galfile=galf)), formals(read.Galfile))
        galdata <- do.call(read.Galfile, read.Galfile.defs)
 
        #galdata <- read.Galfile(galf, path=path)
        
        if(DEBUG) print(path)
        if(DEBUG) print(resdir)
        
        f <- fnames[1]
        gp <- readSpot(fnames=f, path=path, galfile=galfile, controlId=controlId,...)
        numrow <- length(gp[["GfMedian"]])
        numcol <- length(fnames)

        
        if(DEBUG) print("creating layout")
        mlayout <- galdata$layout
        gnames <- galdata$gnames
        ##read controls
        mlayout@maControls <- as.factor(maGenControls(gnames, controlcode = controlMatrix,
                                                      id=controlId))
        
        Rf <- Gf <- Rb <- Gb <- weight <- matrix(0,nrow=numrow, ncol=numcol)
        filenames <- c()
        nb <- c()
        rm(f, gp)
        
        # Call to slideQuality for each spot file
        if (DEBUG) print("Before loop")
        for (i in 1:length(fnames))
          {
            if (DEBUG) print("In the loop ")
            f <- fnames[i]
            gp <- readSpot(fnames = f, path=path, galfile=galfile,controlId = controlId, ...)
            restmp <- slideQuality(gp, controlMatrix = controlMatrix, DEBUG=DEBUG) #controlId = "ID"
                        
            ###start plot
            Gf[,i] <- gp[["GfMedian"]]; Gb[,i] <-gp[["GbMedian"]] 
            Rf[,i] <- gp[["RfMedian"]]; Rb[,i] <- gp[["RbMedian"]]
            weight[,i] <- gp[["Flags"]]
            filenames <- c(filenames, gp[["File"]])
        
            #qualBoxplot
            setwd(resdir)
            plotname <- paste("qualPlot",unlist(strsplit(f, ".spot")), plotdef$suffix, sep=".")
            plotdef <- c(plotdef, list(main=paste(f, ": Quantitative Diagnostic Plots")))

            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)),
                                       formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                       formals(args(dev))))

            par(mar=c(3,14,2,6))
            nbtmp <- qualBoxplot(restmp, reference=reference, organism=organism)
            dev.off()
            setwd(curdir)

            #nb = matrix ncol=2, nrow=length(fnames)
            nb <- rbind(nb, nbtmp)
            QCp <- c(QCp, plotname)
            if (DEBUG) print("End of plot")
            if (DEBUG) print(paste("save as ",plotname))
            if (DEBUG) print("Binding results")
            quality <- cbind(quality, restmp[,1])
            meas <- rownames(restmp)
          }
        
        print("Comparative plots done")
        
        #Create marrayRaw
        colnames(Gf) <- colnames(Gb) <- colnames(Rf) <- colnames(Rb) <- filenames
        if (DEBUG) print("building mraw")
        mraw <- new("marrayRaw", maRf=Rf, maGf=Gf, maRb=Rb,
                    maGb=Gb, maNotes="", maLayout=mlayout,
                    maW=weight, maGnames=gnames)
        #maQualityPlots
        setwd(resdir)
        print("Starting maQualityPlots")

        defs <- list(norm="p")
        norm.defs <- maDotsDefaults(opt, defs)     

        do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId, DEBUG=DEBUG, dev=dev),
                                    norm.defs))
        
        #get diagnostic plots names
        tmpname <- sub(".spot", "",colnames(mraw@maGf))
        pn <- paste("diagPlot", tmpname, sep=".")

        dirfiles <- dir(".")
        
        for(i in 1:length(pn))
          Dp <- c(Dp, dirfiles[grep(pn[i], dirfiles)[1]])
        
        if (DEBUG) print("After for loop")
        if (DEBUG) print(nb)
        quality2HTML(fnames=fnames,path=resdir, QCplot=QCp, DiagPlot=Dp,nbBelow=nb)
        
        colnames(quality) <- fnames
        rownames(quality) <- meas
        
        print("SpotQuality done")
        
       ####### Results
        
        if (output)
          {
            print("Printing results to file")
            write.table(quality, "quality.txt",sep="\t", col.names=NA)
            #colnames(mraw@maGnames@maInfo) <- c("Name", "ID")
            do.call(outputNormData, c(list(mraw=mraw, val=c("maM", "maA")), norm.defs))
          }

        setwd(curdir)
        return(list(mraw=mraw, quality=quality))
      }

    else {

      ##############################################################
      ## COMPBOXPLOT = FALSE
      ##############################################################
      
      curdir <- getwd()
      if (!file.exists(resdir))
        dir.create(resdir)
      if (DEBUG) print(getwd())

      if(!is.null(galfile))
        galf <- galfile
      else
        {
          galf <- dir(path=path, pattern = ".*\\.gal$")[1]
          if(is.na(galf))
            stop("Missing galfile information.")
          else
            cat("No specific galfile names, reading in ", galf, " from ", path,  "directory. \n")
        }
        read.Galfile.defs <- maDotsMatch(maDotsDefaults(opt, list(galfile=galf)), formals(read.Galfile))
        galdata <- do.call(read.Galfile, read.Galfile.defs)
      
      #galdata <- read.Galfile(galf, path=path)
      
      if(DEBUG) print(path)
      if(DEBUG) print(resdir)
      
      if(DEBUG) print("creating layout")
      mlayout <- galdata$layout
      gnames <- galdata$gnames
      mlayout@maControls <- as.factor(maGenControls(gnames, controlcode = controlMatrix,
                                                    id=controlId))
     
      mraw <- read.Spot(fnames, path, layout=mlayout, gnames=gnames)
      colnames(maGf(mraw)) <- fnames
     
      print("Starting maQualityPlots")
      defs <- list(norm="p")
      norm.defs <- maDotsDefaults(opt, defs)     

      setwd(resdir)
      do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId, DEBUG=DEBUG, dev=dev),
                                  norm.defs))
      
      if (output)
        {
          print("Printing results to file")
         # colnames(mraw@maGnames@maInfo) <- c("Name", "ID")
          do.call(outputNormData, c(list(mraw=mraw, val=c("maM", "maA")), norm.defs))
        }

      setwd(curdir)
      return(list(mraw=mraw))     
    }
  }

###################################################
## READ Agilent file .txt file, returns a list of measures
## extracted from the Agilent file
## source("~/Projects/madman/Rpacks/arrayQuality/R/agQuality.R")
##
###################################################

## No background substraction
## No normalization
## Suppose that fnames is a .gpr file.
## Returns a list of data needed for quality
## Combines read.marrayRaw, maQualityMain, gpTools
## One slide only!!!

## returns a list of vector containing info from grp file column
readAgilent <- function (fnames = NULL, path= ".", DEBUG=FALSE, skip = 0,
                     sep ="\t", quote= "\"", controlId = c("ProbeName"), ...)
  {
    if (DEBUG) print("Starting readAgilent")
    if (DEBUG) print(path)
    # Test if input data is OK
    if (is.null(path))
      path <- "."
 
    if (missing(fnames) | is.null(fnames)) 
      fnames <- dir(path, pattern = ".*\\.txt$")
    fullfnames <- file.path(path, fnames)
    f <- fullfnames[1]
    opt <- list(...)
    
    # Search in the Agilent file where are the colums starting
    y <- readLines(fullfnames[1], n = 100)
##    skip <- grep("gMedianSignal", y)[1] - 1
    skip <- grep("gMedianSignal", y)[1]
    
    if (DEBUG) print(skip)
  
    # Read data in       
    name <- id <- c()
    block <- column <- row <- c()
    Date <- PMTR <- PMTG <- normMethod <- normCoef <- c()
    Gfmedian <- Gfmean <- Gfsd <- c()
    Gbmedian <- Gbmean <- Gbsd <- c()
    Rfmedian <- Rfmean <- Rfsd <- c()
    Rbmedian <- Rbmean <- Rbsd <- c()
    Gfsat <- Rfsat <- c()
    spotDia <- spotFArea <- spotBArea <- c()
    Flags <- c()
    
    tmp <- readLines(f, n = 40)
    if (length(grep("DateTime", tmp)) != 0) 
      Date <- unlist(strsplit(readLines(f, n=3)[3], split="\t"))[4]
    if (length(grep("PMT", tmp)) != 0) {
      PMT <- gsub("\"", "",
                   strsplit(tmp[grep("PMT", tmp)], split = "=")[[1]][2])
      PMT <- strsplit(PMT, split="\t")
      PMTR <- PMT[[1]][1]
      PMTG <- PMT[[1]][2]
    }
    
##    if (length(grep("NormalizationMethod", tmp)) != 0)
##      normMethod <- gsub("\"", "",
##                        strsplit(tmp[grep("NormalizationMethod",tmp)],
##                                  split = "=")[[1]][2])
##    if (length(grep("NormalizationFactor", tmp)) != 0)
##        normCoef1 <- gsub("\"", "",
##                         strsplit(tmp[grep("NormalizationFactor", tmp)],
##                                  split = "=")[[1]][2])
##    normCoef <- gsub("\t", ",", normCoef1)

    if (DEBUG) print(paste("Reading", f))
    h <- strsplit(readLines(f, n = skip), split = sep)
    h <- as.list(unlist(h[[length(h)]]))
    names(h) <- gsub("\"", "", unlist(h))
##    dat <- scan(f, quiet = TRUE, what = h, sep = sep, skip = skip + 1,
##                quote = quote, ...)
    dat <- scan(f, quiet = TRUE, what = h, sep = sep, skip = skip,
                quote = quote, ...)

##    block <- cbind(block, as.numeric(dat[["Block"]]))
    column <- cbind(column, as.numeric(dat[["Col"]]))
    row <- cbind(row, as.numeric(dat[["Row"]]))
    name <- cbind(name, dat[["Description"]])
    id <- cbind(id, dat[[controlId]])
    Gfmedian <- cbind(Gfmedian, as.numeric(dat[["gMedianSignal"]]))
    Gfmean <- cbind(Gfmean, as.numeric(dat[["gMeanSignal"]]))        
    Gfsd <- cbind(Gfsd, as.numeric(dat[["gPixSDev"]]))
    Gbmedian <- cbind(Gbmedian, as.numeric(dat[["gBGMedianSignal"]]))
    Gbmean <- cbind(Gbmean, as.numeric(dat[["gBGMeanSignal"]]))        
    Gbsd <- cbind(Gbsd, as.numeric(dat[["gBGPixSDev"]]))
    Rfmedian <- cbind(Rfmedian, as.numeric(dat[["rMedianSignal"]]))
    Rfmean <- cbind(Rfmean, as.numeric(dat[["rMeanSignal"]]))
    Rfsd <- cbind(Rfsd, as.numeric(dat[["rPixSDev"]]))
    Rbmedian <- cbind(Rbmedian, as.numeric(dat[["rBGMedianSignal"]]))
    Rbmean <- cbind(Rbmean, as.numeric(dat[["rBGMeanSignal"]]))
    Rbsd <- cbind(Rbsd, as.numeric(dat[["rBGPixSDev"]]))        
    Gfsat <- cbind(Gfsat, as.numeric(dat[["gNumSatPix"]]))
    Rfsat <- cbind(Rfsat, as.numeric(dat[["rNumSatPix"]]))
##    spotDia <- cbind(spotDia, as.numeric(dat[["Dia."]]))  Not used
    spotFArea <- cbind(spotFArea, as.numeric(dat[["gNumPix"]]))
    spotBArea <- cbind(spotBArea, as.numeric(dat[["gBGNumPix"]]))
    Flags <- cbind(Flags, as.numeric(as.logical(dat[["gIsFeatNonUnifOL"]]) & as.logical(dat[["rIsFeatNonUnifOL"]]))) 
    gprData <- list(File = fnames[1], Date = Date, PmtR = PMTR, PmtG = PMTG,
                    Normalization = NA, NormCoefficient = NA,
                    Name = name, ID = id,
                    Block = 1, Column = column, Row = row,
                    GfMedian = Gfmedian, GfMean = Gfmean, GfSD = Gfsd,
                    GbMedian = Gbmedian, GbMean = Gbmean, GbSD = Gbsd,
                    RfMedian = Rfmedian, RfMean = Rfmean, RfSD = Rfsd,
                    RbMedian = Rbmedian, RbMean = Rbmean, RbSD = Rbsd,
                    GfSaturation = Gfsat, RfSaturation = Rfsat,
                    SpotDiameter = NA, spotArea = spotFArea,
                    bgArea = spotBArea, Flags = Flags)
    
    # Result
    return(gprData)
  }


###########################################################################
##
##  Move controlCode and maGenControls from marrayTools to marrayClasses
##  May 7, 2003
##  Sept 21, 2004
## TO USE:
## 1. Create Reference slides
##    reference <- globalQuality(fnames, inputsource = "readAgilent")
## 2. Run : some alternative
##        -- agQuality(fnames, reference = reference)  ## Use what you have created
##        -- agQuality(fnames, reference = reference, compBoxplot=FALSE)
##                                    ## Only generate qualitative plots
##        -- agQuality(fnames)  ## Use exisiting reference info
###########################################################################

agcontrolCode <-
structure(c("\\(+\\)*", "\\(-\\)*", "Positive", "Negative"),.Dim = c(2, 2), .Dimnames = list(c("1", "2"), c("Pattern", "Name")))

agQuality <- function(fnames = NULL, path = ".",
                      organism = c("Mm", "Hs"),
                      compBoxplot = TRUE,
                      reference = NULL,
                      controlMatrix = agcontrolCode,
                      controlId = c("ProbeName"),
                      output = FALSE,
                      resdir = ".",
                      dev = "png", #set default to be png 
                      DEBUG = FALSE,...)
{

    print("Starting agQuality...")
    
    # Check input arguments
    if (missing(path) | is.null(path))  path <- "."
    
    if (missing(fnames) | is.null(fnames))
      fnames <- dir(path, pattern = ".*\\.txt$")

    organism <- organism[1]
    controlId <- controlId[1]
    if (DEBUG) print(controlId)
    if (DEBUG) print(controlMatrix)
    opt <- list(...)

    #get Normalization method if any
    #norm.defs <- maDotsDefaults(opt, list(norm="p"))
    #defs <- list(norm="p")
    #norm.defs <- maDotsMatch(maDotsDefaults(opt, defs), formals(args("maNorm")))

 ###################
 ## Setting up output device

    if (DEBUG) print("Name of output device")
    plotdef <- switch(dev,
                      "bmp" = list(dev=list(width=800, height=600, bg="white"), suffix="bmp"),
                      "jpeg" = list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      #"jpg" =  list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      #"postscript" = list(dev=list(paper="special", width=8, height=6, bg="white"), suffix="ps"),
                      "postscript" = list(dev=list( bg="white"), suffix="ps"),
                      "png" =  list(dev=list(width=800, height=600, bg="white"), suffix="png"),
                      list(dev=list(width=800, height=600,bg="white"), suffix="png"))
    if(!is.element(dev, c("bmp", "jpeg","png","postscript","jpg")))
      {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

      # was print("Format error, format will be set to PNG")

    if (DEBUG) print(paste("compBoxplot = ", compBoxplot, sep=""))

    
##############################################################
    ## COMPBOXPLOT = TRUE
##############################################################
    
    if (compBoxplot)
      {

        if(DEBUG) print("Starting compBoxplot")
        
        # Prepares results
        quality <- c()  
        tmp <- c()
        QCp <- c()
        Dp <- c()
        
        curdir <- getwd()
        if (!file.exists(resdir))
          dir.create(resdir)
        if (DEBUG) print(getwd())
        
        #Allocation of matrix for marrayraw object

        if (DEBUG) print(path)
        if (DEBUG) print(resdir)
#        f <- fnames[1]

        ## Need to call read.Agilent here to take care of
        ## layout problem
        
        if (DEBUG) print("call read.Agilent")
        gp <- read.Agilent(fnames = fnames[1], path = path, DEBUG=DEBUG)
        numrow <- nrow(gp@maRf)
        numcol <- length(fnames)
        
        Rf <- Gf <- Rb <- Gb <- weight <- matrix(0,nrow=numrow, ncol=numcol)
        mlayout <- maLayout(gp)
        gnames <- maGnames(gp)
        mlayout@maControls <- as.factor(maGenControls(gnames, controlcode = controlMatrix,
                                                      id=controlId))
 
        nb <- filenames <- c()
        
        # Call to slideQuality for each Agilent txt file

        if (DEBUG) print("Starting loop for boxplot")
        for (i in 1:length(fnames))
          {
            if (DEBUG) print(i)
            if (DEBUG) print("In the loop ")
            f <- fnames[i]
            gp <- readAgilent(fnames = f, path=path)
            ##Warning: Here, controlId must be = to a name in readAgilent
            ##ProbeName IS NOT in the list (ID is!)
            restmp <- slideQuality(gp, controlMatrix = controlMatrix, #controlId = controlId,
                                   DEBUG=DEBUG)
                        
            ###start plot
            Gf[,i] <- gp[["GfMedian"]]; Gb[,i] <-gp[["GbMedian"]] 
            Rf[,i] <- gp[["RfMedian"]]; Rb[,i] <- gp[["RbMedian"]]
            weight[,i] <- gp[["Flags"]]
            filenames <- c(filenames, gp[["File"]])
        
            #qualBoxplot
            if (DEBUG) print("Ploting")
            setwd(resdir)
            plotname <- paste("qualPlot",unlist(strsplit(f, ".txt")), plotdef$suffix,sep=".")
            plotdef <- c(plotdef, list(main=paste(f, ": Quantitative Diagnostic Plots")))

            ##do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)),
             ##                        formals(args(dev))))
            
            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)), formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)), formals(args(dev))))

            
            par(mar=c(3,14,2,6))
            nbtmp <- qualBoxplot(restmp, reference=reference, organism=organism, DEBUG=DEBUG)
            dev.off()
            setwd(curdir)

            if (DEBUG) print("Done ploting")
            
            #nb = matrix ncol=2, nrow=length(fnames)
            nb <- rbind(nb, nbtmp)
            QCp <- c(QCp, plotname)
            if (DEBUG) print("End of plot")
            if (DEBUG) print(paste("save as ",plotname))
            if (DEBUG) print("Binding results")
            quality <- cbind(quality, restmp[,1])
            meas <- rownames(restmp)
          }
        
        print("Comparative plots done")
        
        #Create marrayRaw
        colnames(Gf) <- colnames(Gb) <- colnames(Rf) <- colnames(Rb) <- colnames(weight) <- filenames
        if (DEBUG) print("building mraw")
        mraw <- new("marrayRaw", maRf=Rf, maGf=Gf, maRb=Rb,
                    maGb=Gb, maNotes="", maLayout=mlayout,
                    maW=weight, maGnames=gnames)

        ##maQualityPlots
        setwd(resdir)
        print("Starting maQualityPlots")

        defs <- list(norm="l")
        norm.defs <- maDotsDefaults(opt, defs)     
        
        do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId,
                                         DEBUG=DEBUG, dev=dev),
                                    norm.defs))
                
        #get diagnostic plots names
        tmpname <- sub(".txt", "",colnames(mraw@maGf))
        pn <- paste("diagPlot", tmpname, sep=".")

        dirfiles <- dir(".")
        
        for(i in 1:length(pn))
          Dp <- c(Dp, dirfiles[grep(pn[i], dirfiles)[1]])
        
        if (DEBUG) print("After for loop")
        if (DEBUG) print(nb)
        quality2HTML(fnames=fnames,path=resdir, QCplot=QCp, DiagPlot=Dp,nbBelow=nb)
        
        colnames(quality) <- fnames
        rownames(quality) <- meas
        
        print("agQuality done")
        
       ####### Results
        
        if (output)
          {
            print("Printing results to file")
            write.table(quality, "quality.txt",sep="\t", col.names=NA)
            do.call(outputNormData, c(list(mraw=mraw, val=c("maM", "maA")), norm.defs))            
          }

        setwd(curdir)
        return(list(mraw=mraw, quality=quality))
      }

   else {

     ##############################################################
     ## COMPBOXPLOT = FALSE
     ##############################################################
     
     curdir <- getwd()
     if (!file.exists(resdir))
       dir.create(resdir)
     if (DEBUG) print(getwd())

     
     mraw <- read.Agilent(fnames, path)
     colnames(maGf(mraw)) <- fnames
     print("Starting maQualityPlots")
     defs <- list(norm="l")
     norm.defs <- maDotsDefaults(opt, defs)     
     setwd(resdir)
     do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId, DEBUG=DEBUG, dev=dev),
                                 norm.defs))

     print("agQuality done")
     
     if (output)
       {
         print("Printing results to file")
         do.call(outputNormData, c(list(mraw=mraw, val=c("maM", "maA")), norm.defs))
       }

     setwd(curdir)
     return(list(mraw=mraw))     
   }
  }

#################################################
## Separate control plot functions for MEEBO set
## Author: Agnes and Yuanyuan
## Date modified: 11/02/2005
##                06/28/2006
## Spike-ins plots -- Using limma functions
#################################################

##source("C:/MyDoc/Projects/madman/Rpacks/arrayQuality/R/SpikeIn.R")

###############################################################
## LOAD REQUIRED PACKAGES and OBJECTS

library(marray)
library(RColorBrewer)
##load("MEEBOset.RData")


###############################################################
## Spike parsing functions
###############################################################

## input: text file describing the spike-ins (names/cy3-cy5/seqID/Type)
## output: list of matrix containing info for each spike type

readSpikeTypes <- function(file="DopingTypeFile2.txt",path=NULL,cy5col="MassCy5",cy3col="MassCy3",...)
  {
    spikeTypes <- readSpotTypes(file=file,path=path,...)
    spikeTypes <- spikeTypes[!is.na(spikeTypes[,cy5col]),]
    if(length(grep("Type", as.character(colnames(spikeTypes))))>0)
      spikelist <- split(spikeTypes,spikeTypes[,"Type"])
    else
      stop("Wrong SpikeTypeFile")
    return(spikelist)
  }

## Examples:
#spikes <- readSpikeTypes() ##List of matrix by  different types of spikes
#spikes <- readSpikeTypes(file="StanfordDCV1.7complete.txt",
#                         cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7")

## -------------------------------------------------------------------------
## getSpikeIds
## Input: list of matrix, one for for each type of spike
## Output: list of list:
## For each spike-type: look at all individual spikes,
## if on array, find all replicates (using seqID) and return their MEEBO ids
## 
## Some spikes are not used- Remove from search

getSpikeIds <- function(spikeList, id="SeqID", annot=MEEBOset, namecol=c("Symbol","Name"))
  {
    SpikeIds <- c()
    if(length(namecol)>2)
      namecol=namecol[1]
    ## find all replicated sequences/probe_Name
    for(type in 1:length(spikeList))
      {
        usedSeq <- spikeList[[type]][!is.na(spikeList[[type]][,id]),id]
        TmpIds <- lapply(spikeList[[type]][,id],
                         function(x){as.character(annot[grep(as.character(x),as.character(annot[,id])),"uniqID"])})
        if(nchar(spikeList[[type]][1,namecol])>0)
          names(TmpIds) <- spikeList[[type]][,namecol]
        else
          names(TmpIds) <- spikeList[[type]][,"Probe_Name"]
        SpikeIds <- c(SpikeIds,list(TmpIds))
      }
    names(SpikeIds) <- names(spikeList)
    return(SpikeIds)
  }

## Example:
##test <- getSpikeIds(spikeList=spikes)

## ---------------------------------------------------------------------------
## getSpikeIndex
## Input: Input: list of matrix, one for for each type of spike
## Output: list of list:
## For each spike-type: look at all individual spikes,
## if on array, find all corresponding Meebo ids
## return index of each replicate in all-array index

getSpikeIndex <- function(spikeList,id="SeqID",annot=MEEBOset,gnames, namecol=c("Symbol","Name"))
  {
    if(length(namecol)>1)
      namecol=namecol[1]
    SpikeIds <- getSpikeIds(spikeList=spikeList,id=id,annot=annot, namecol=namecol)
    SpikeIndex <- lapply(SpikeIds,function(x){lapply(x,function(y){match(y,gnames)})})
  }

## Example:
##test2<- getSpikeIndex(spikes,gnames=maGeneTable(mnorm)[,"ID"])

## ---------------------------------------------------------------------------
## Get all spikes at once, no distinctions
## Input: spike type file
## Output: list of all spike-ins Meebo ids for each spike
readAllSpikes <- function(file="DopingTypeFileTest.txt",path=NULL,cy5col="MassCy5",
                          cy3col="MassCy3",id="SeqID",annot=MEEBOset,...)
  {
    ## read everything into a matrix
    spikesTypes <- readSpotTypes(file=file,path=path,...)
    ## remove missing data NA or ""
    spikesTypes <- spikesTypes[!is.na(spikesTypes[,cy5col]),]
    ## get all replicates on array using SeqId
    TmpIds <- sapply(spikesTypes[,id],
                     function(x){as.character(annot[grep(as.character(x),as.character(annot[,id])),"uniqID"])})
    ##
    return(TmpIds)
  }

## spikeids <- readAllSpikes()


###############################################################
## Individual Spike-type plotting functions
###############################################################

## Spike.MMplot: 
## Input: results of readSpikeTypes
## output: expected ratio vs. Observed ratios, log scale

Spike.MMplot <- function(mval,spikeList, id="SeqID", gnames=RG$genes[,"ID"],
                         annot=MEEBOset,cy5col="MassCy5",cy3col="MassCy3",namecol="Symbol")
  {
    SpikeIndex <- getSpikeIndex(spikeList,id=id,annot=annot,gnames=gnames,namecol=namecol)
##    print(SpikeIndex[[1]])
##    print(length(spikeList))
    for(type in 1:length(spikeList))
      {
 ##       print("here")
        expected <- log.na(as.numeric(spikeList[[type]][,cy5col]) / as.numeric(spikeList[[type]][,cy3col]),2)
        max <- max(expected,na.rm=TRUE)
        min <- min(expected,na.rm=TRUE)
        ##set the color
        ##separate MJ and Ambion/Strata
        
        if (length(SpikeIndex[[type]])>16)
          {
           print("More than 16 spikes") 
           colvect <- "blue"
           ##Plot dots
           plot((min-1):(max+1),(min-1):(max+1),type="n",xlab="expected ratios", ylab="observed ratios",
                main=spikeList[[type]][1,"Type"])
           for(i in 1:length(SpikeIndex[[type]]))
             {
               yy <- mval[SpikeIndex[[type]][[i]]]
               points(rep(expected[i],length(yy)),yy,col=colvect, pch=19,cex=1)
             }
           abline(0,1,lty=2)
           ##plot legend
           plot(rep(1,length(SpikeIndex[[type]])),1:length(SpikeIndex[[type]]),
                type="n", xlab="", ylab="", axes=FALSE, xlim=c(1,1))
         }
        else
          {
            colvect <- rep(brewer.pal(ceiling(length(SpikeIndex[[type]])/2),"Set1"),2)
            ##plot
            plot((min-1):(max+1),(min-1):(max+1),type="n",xlab="expected ratios", ylab="observed ratios",
                 main=spikeList[[type]][1,"Type"])
            for(i in 1:length(SpikeIndex[[type]]))
              {
                yy <- mval[SpikeIndex[[type]][[i]]]
                points(rep(expected[i],length(yy)),yy,col="black", pch=LETTERS[i],cex=1.5)
                if(length(grep("EC",as.character(spikeList[[type]][i,"Probe_Name"])))>0)
                  points(expected[i], median(yy,na.rm=TRUE), col=colvect[i], pch=19,cex=3)
                else
                  {
                    points(expected[i], median(yy,na.rm=TRUE), col=colvect[i], pch=17,cex=3)
                    ##print(median(yy,na.rm=TRUE))
                  }
              }
            
            abline(0,1,lty=2)
            op <- par(mar=c(5,2,5,10))
            plot(rep(1,length(SpikeIndex[[type]])),1:length(SpikeIndex[[type]]),
                 type="n", xlab="", ylab="", axes=FALSE, xlim=c(1,1))
            for(i in 1:length(SpikeIndex[[type]]))
              {
                points(1, i,col=colvect[i],
                       pch=ifelse(length(grep("EC",spikeList[[type]][i,"Probe_Name"]))>0,19,17),cex=3)
                axis(4,at=1:length(SpikeIndex[[type]]),
                     paste(LETTERS[1:length(SpikeIndex[[type]])], as.character(names(SpikeIndex[[type]])),sep=":"),
                     las=2,cex.axis=1.5,tick=FALSE,line=-3)
              }
            par(op)
          }
      }
  }

## Example
#png("testMMplot_MJs.png",width=1000,height=1000)
#par(mfrow=c(2,2),cex.main=2,cex.lab=1.5,oma=c(4,4,4,4))
#Spike.MMplot(Mval, spikes[1],cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7")
#Spike.MMplot(Mval, spikes[2],cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7")
#dev.off()

## --------------------------------------------------------------------------------

## Spike.Sensitivity
## concentration (mass) vs raw signal for each channel
## Input: output from read.SpikeTypes
## Output: boxplot of log raw signal / log concentration
## Bg sub or not depending on input

Spike.Sensitivity <- function(rawobj,spikeList, id="SeqID", gnames=RG$genes[,"ID"], annot=MEEBOset,cy5col="MassCy5",cy3col="MassCy3",namecol=c("Name","Symbol"))
  {
    if(length(namecol)>2)
      namecol <- namecol[1]
    
    SpikeIndex <- getSpikeIndex(spikeList,id=id,annot=annot,gnames=gnames,namecol=namecol)
    for(type in 1:length(spikeList))
      {
        expectedR <- log.na(as.numeric(spikeList[[type]][,cy5col]),2)
        expectedG <- log.na(as.numeric(spikeList[[type]][,cy3col]),2)
        max <- max(c(expectedR,expectedG),na.rm=TRUE)
        min <- min(c(expectedR,expectedG),na.rm=TRUE)
        Cy5 <- c()
        Cy3 <- c()
        massCy5 <- c()
        massCy3 <- c()
        for(i in 1:length(SpikeIndex[[type]]))
          {
            ##yy <- maLR(rawobj)[SpikeIndex[[type]][[i]]]
            yy <- log.na(rawobj$R[SpikeIndex[[type]][[i]]],2)
            Cy5 <- c(Cy5,yy)
            massCy5 <- c(massCy5,rep(expectedR[i],length(yy)))
            yy <- log.na(rawobj$G[SpikeIndex[[type]][[i]]],2)
            Cy3 <- c(Cy3,yy)
            massCy3 <- c(massCy3,rep(expectedG[i],length(yy)))
          }
        resCy5<- split(data.frame(cbind(massCy5,Cy5)),factor(massCy5))
        resCy3<- split(data.frame(cbind(massCy3,Cy3)),factor(massCy3))
        plot((min-1):(max+1),(min-1):(max+1),type="n",xlab="Log2 mass",
             ylab="Signal intensity",ylim=c(0,16),xlim=c(0,10),
             main=paste(spikeList[[type]][1,"Type"],"Cy5",sep=" "))
        for(i in 1:length(resCy5))
          {
            boxplot(resCy5[[i]][,2], at=resCy5[[i]][1,1],col="red",add=TRUE)
          }
        plot((min-1):(max+1),(min-1):(max+1),type="n",xlab="Log2 mass",
             ylab="Signal intensity",ylim=c(0,16),xlim=c(0,10),
             main=paste(spikeList[[type]][1,"Type"],"Cy3",sep=" "))
        for(i in 1:length(resCy3))
          {
            boxplot(resCy3[[i]][,2], at=resCy3[[i]][1,1],col="green",add=TRUE)
          } 
      }
  }

## Example
#png("Sensitivity.png", width=800,height=1000)
#par(mfrow=c(2,2))
#Spike.Sensitivity(nbg,spikes)
#dev.off()

## --------------------------------------------------------------------
## Spike.MM.Scatter
# MMplot: scatter plot + expected ratio superimposed
## Input: results from readSpikeTypes
## Output: scatter plot of observed ratio and expected ratio for each spike

Spike.MM.Scatter <- function(mval,spikeList, id="SeqID", gnames=RG$genes[,"ID"], annot=MEEBOset,
                             cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7",namecol=NULL)
  {
    SpikeIndex <- getSpikeIndex(spikeList,id=id,annot=annot,gnames=gnames,namecol=namecol)
    yrange <- range(mval[unlist(SpikeIndex)],na.rm=TRUE)
    for(type in 1:length(SpikeIndex))
      {
        expected <- log.na(as.numeric(spikeList[[type]][,cy5col]) / as.numeric(spikeList[[type]][,cy3col]),2)
        ##set the color
        #if (length(SpikeIndex[[type]])>16)
        #  colvect <- "blue"
        #else
        #  colvect <- rep(brewer.pal(ceiling(length(SpikeIndex[[type]])/2),"Set1"),2)
        ##plot
        yrange <- range(yrange,expected,na.rm=TRUE)
        plot(1:length(SpikeIndex[[type]]),1:length(SpikeIndex[[type]]),
             type="n",xlab="", ylab="Observed ratios",ylim=yrange,axes=FALSE,
             main=spikeList[[type]][1,"Type"])
        for(i in 1:length(SpikeIndex[[type]]))
          {
            yy <- mval[SpikeIndex[[type]][[i]]]
            points(rep(i,length(yy)),yy,col="black", pch=18,cex=1.5)
            points(i,expected[i],pch=19,cex=2,col="red")
          }
        abline(h=c(-2,-1,0,1,2),lty=2)
        axis(1,at=1:length(SpikeIndex[[type]]),labels=names(SpikeIndex[[type]]),las=2)
        axis(2,las=2);box()
      }
  }

## Example
#png("MM.scatter.png", width=600,height=800)
#par(mar=c(7,4,4,4),mfrow=c(2,1),oma=c(2,2,2,2))
#Spike.MM.Scatter(Mval,spikes)
#dev.off()

##-------------------------------------------------------------------------
## Cy3 vs Cy5 raw signal, linear scale
## Bg sub depends on input
## All spikes
## Input: spikeTypes: results of readSpotTypes
Spike.Cy5vsCy3 <- function(rawobj,spikesTypes, id="SeqID",
                           annot=MEEBOset,gnames=RG$genes[,"ID"],
                           cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7",...)
  {
    ## read everything into a matrix
##    spikesTypes <- readSpotTypes(file=file,path=path)
    ## remove missing data NA or ""
    spikesTypes <- spikesTypes[!is.na(spikesTypes[,cy5col]),]
    ## get all replicates on array using SeqId
    TmpIds <- sapply(spikesTypes[,id],
                     function(x){as.character(annot[grep(as.character(x),as.character(annot[,id])),"uniqID"])})
    ## Get the colors
   ## expectedRatio <- spikesTypes[,cy5col]/spikesTypes[,cy3col]
    expectedRatio <- as.numeric(spikesTypes[,cy5col])/as.numeric(spikesTypes[,cy3col])
    
    ratioSpiked <- sort(unique(expectedRatio))
    colvect <- rainbow(length(ratioSpiked))
    indexcol <- match(expectedRatio,ratioSpiked)

    ## Get the plot
    axisrange <- range(log.na(c(rawobj$R,rawobj$G),2),na.rm=TRUE)
    axisrange[2] <- axisrange[2]+1.5
    
    plot(1:length(TmpIds),1:length(TmpIds),type="n",xlim=axisrange,
         ylim=axisrange,xlab="Log2 Cy5 signal", ylab="Log2 Cy3 signal",
         main="Comparison of Cy5 and Cy3 raw signal intensity")      
    for(i in 1:length(TmpIds))
      {
        index <- match(TmpIds[[i]],as.character(gnames))
        points(log.na(rawobj$R[index,],2),log.na(rawobj$G[index,],2),
               ##pch=18,col=1)
        pch=18,col=colvect[indexcol[i]])

      }
    legend(axisrange[2]-2.2,axisrange[2]-0.5,"Expected log2 ratios",
           bty="n",cex=0.7)
    legend(axisrange[2]-1,axisrange[2]-1,pch=18,col=colvect,bty="o",
            as.character(log2(ratioSpiked)))
           

    abline(0,1,lty=2)
  }

##----------------------------------------------------------------     
## Spike.Sensitivity indivudual boxplots
## concentration (mass) vs raw signal for each channel
## Input: output from read.SpikeTypes
## Output: boxplot of log raw signal ordered by input mass
## Bg sub or not depending on input

##Example
#png("testIndiBplot.png",width=1000,height=1000)
#par(mfrow=c(2,2), oma=c(3,3,3,3),mar=c(5,4,5,4))
#Spike.Individual.Sensitivity(RGsub,spikeList,namecol="Symbol")
#dev.off()

Spike.Individual.Sensitivity <- function(rawobj,spikeList=NULL, id="SeqID", gnames=RG$genes[,"ID"], annot=MEEBOset,cy5col="MassCy5",cy3col="MassCy3",namecol=c("Name","Symbol"),ctllist=MEEBOctrl,DEBUG=FALSE)
  {
    if(DEBUG) print("Starting Spike.Individual.Sensitivity")
    if(length(namecol)>1)
      namecol <- namecol[1]
 #   Aval <- (log.na(rawobj$R,2) + log.na(rawobj$G,2))/2
    
    spikeIndex <- getSpikeIndex(spikeList,id=id,annot=annot,gnames=gnames,namecol=namecol)
    goodNegCtl <- ctllist[[11]][!is.na(match(ctllist[[11]], rownames(rawobj$R)))]
    negCtlCy5 <- log.na(rawobj$R[goodNegCtl,],2)
    negCtlCy3 <- log.na(rawobj$G[goodNegCtl,],2)
    for(type in 1:length(spikeIndex))
      {
        orderCy5 <- sort(as.numeric(spikeList[[type]][,cy5col]),index.return=TRUE)$ix
        orderCy3 <- sort(as.numeric(spikeList[[type]][,cy3col]),index.return=TRUE)$ix

        plot(1:(length(spikeIndex[[type]])+1),1:(length(spikeIndex[[type]])+1),
             type="n",ylim=c(0,16),xlab="",axes=FALSE,
             ylab="Log2 signal",main=paste(spikeList[[type]][1,"Type"]," : log2(Cy5) by increasing concentration",sep=" "))
        boxplot(negCtlCy5,add=TRUE,col="blue",at=1,axes=FALSE,na.rm=TRUE)
        for(j in 1:length(orderCy5))
          {
            boxplot(log.na(rawobj$R[spikeIndex[[type]][[orderCy5[j]]],],2),add=TRUE,col="red",
                    at=(j+1),axes=FALSE,na.rm=TRUE)
          }
        axis(1,at=1:(length(orderCy5)+1),labels=c("Neg Ctrl",spikeList[[type]][orderCy5,namecol]),las=2)
        axis(2,las=2, at=seq(0,16,2));box()
#        axis(4, at=quantile(Aval, c(0.25,0.5,0.75,0.9,1), na.rm=TRUE),
#             label=c(0.25,0.5,0.75,0.9,1), las= 2)
#        abline(h=quantile(Aval, c(0.25,0.5,0.75,0.9,1), na.rm=TRUE),lwd=2,lty=2)

        plot(1:(length(spikeIndex[[type]])+1),1:(length(spikeIndex[[type]])+1),
             type="n",ylim=c(0,16),xlab="",axes=FALSE,
             ylab="Log2 signal",main=paste(spikeList[[type]][1,"Type"]," : log2(Cy3) by increasing concentration",sep=" "))
        boxplot(negCtlCy3,add=TRUE,col="blue",at=1,axes=FALSE)
        for(j in 1:length(orderCy3))
          {
            boxplot(log.na(rawobj$G[spikeIndex[[type]][[orderCy3[j]]],],2),add=TRUE,col="green",
                    at=(j+1),axes=FALSE)
          }
        axis(1,at=1:(length(orderCy3)+1),labels=c("Neg Ctrl",spikeList[[type]][orderCy3,namecol]),las=2)
        axis(2,las=2,at=seq(0,16,2));box()
      }
  }
        
 
##Spike.Individual.Sensitivity(RGsub,spikeList[1],namecol="Symbol")

#####################################################
## Set of function written to estimate
## quality of microarray slides
##
## Author: Agnes Paquet
## Modified: 04/16/2004
##           09/21/2004
##           09/25/2004
##           06/27/2005
##           03/23/2008
## source("~/Projects/madman/Rpacks/arrayQuality/R/qualFunc.R")
#####################################################




###        TO DO  NEXT         ####
## 1) check that all call to HsRefenceDB are written properly
## 2) check boxplot if reference has Inf values
## 3) agQuality: pb when plotting, check isBelowLim and quality score
## 4) outputnormdata: allow choice of norm method


###################################################
## Given a gpr file
## Computes needed statistics to assess quality
###################################################

## Argument: result of readGPR
## Returns: matrix of numbers

slideQuality <- function(gprData=NULL, controlMatrix = controlCode, controlId = c("ID", "Name"), DEBUG=FALSE,...)
  {
    if (DEBUG) print("SlideQuality starting")
    
    # Check input argument
    if (is.null(gprData))
      stop("Slide information is missing:")
    
    # Read data in

    if (DEBUG) print("SlideQuality 1")

    controlId <- controlId[1]

    ############################################
    ## Channel specific data
    ############################################

    # Foreground and Background info

    Rf <- log.na(gprData[["RfMedian"]],2)
    Gf <- log.na(gprData[["GfMedian"]],2)
    Rb <- log.na(gprData[["RbMedian"]],2)
    Gb <- log.na(gprData[["GbMedian"]],2)

    rRf <- range(Rf, na.rm=TRUE)
    rangeRf <- rRf[2] - rRf[1]
    rGf <- range(Gf, na.rm=TRUE)
    rangeGf <- rGf[2] - rGf[1]
    rRb <- range(Rb, na.rm=TRUE)
    rangeRb <- rRb[2] - rRb[1]
    rGb <-range(Gb, na.rm=TRUE)
    rangeGb <- rGb[2] - rGb[1]

    RbMad <- mad(Rb, na.rm=TRUE)
    RbIqr <- IQR(Rb, na.rm=TRUE)
    GbMad <- mad(Gb, na.rm=TRUE)
    GbIqr <- IQR(Gb, na.rm=TRUE)
                                
    if (DEBUG) print("SlideQuality 3")
    
    # S2N ratios: summary of stat
    
    ifelse(length(gprData[["RfMean"]]) != 0,
           RS2N <- as.vector(log.na(gprData[["RfMean"]]/gprData[["RbMedian"]],2)),
           RS2N <- as.vector(log.na(gprData[["RfMean"]],2)))
    RS2Ninfo <- boxplot(RS2N, plot=FALSE)

    ifelse(length(gprData[["GfMean"]]) != 0,
           GS2N <- as.vector(log.na(gprData[["GfMean"]]/gprData[["GbMedian"]],2)),
           GS2N <- as.vector(log.na(gprData[["GfMean"]],2)))
    GS2Ninfo <- boxplot(GS2N, plot=FALSE)

    RS2Nmedian <- RS2Ninfo[[1]][3]
    GS2Nmedian <- GS2Ninfo[[1]][3]
    
    # Spots: summary of spot area
    spotArea <- median(gprData[["spotArea"]], na.rm=TRUE)
    spotRadius <- round(sqrt(spotArea) / pi)
    GBvar <- var(log.na(gprData[["GbMedian"]],2), na.rm=TRUE)
    RBvar <- var(log.na(gprData[["RbMedian"]],2), na.rm=TRUE)

    
    ############################################
    ## Combined Channel data
    ############################################    

    # M and A values (no background)
    if (DEBUG) print("SlideQuality 4")
    Mmean <- log.na(gprData[["RfMean"]],2) - log.na(gprData[["GfMean"]],2)
    Mmedian <- log.na(gprData[["RfMedian"]],2) - log.na(gprData[["GfMedian"]],2)

    Amean <- (log.na(gprData[["RfMean"]],2) + log.na(gprData[["GfMean"]],2))/2
    Amedian <- (log.na(gprData[["RfMedian"]],2) + log.na(gprData[["GfMedian"]],2))/2

    MmedInfo <- boxplot(Mmedian, plot=FALSE)
    AmedInfo <- boxplot(Amedian, plot=FALSE)

    
    # Comparison of mean(Mvalues) and median(Mvalues)
    # MMR amd mad

    goodM <- !(is.infinite(Mmean) | is.infinite(Mmedian) |
               is.na(Mmean) | is.na(Mmedian))
    
    MMR <- Mmean[goodM] - Mmedian[goodM]
    MMRmad <- mad(MMR, na.rm = TRUE)
    
    #number of spots with abs(mmr) > 0.5
    if (DEBUG) print("SlideQuality 5")
    numSpotOverMmrLim <- 0
    for(i in 1:length(MMR))
      {
        if (abs(MMR[i]) > 0.5)
          numSpotOverMmrLim <- numSpotOverMmrLim + 1
      }

    ifelse(length(MMR)!=0,
           percentSpotOverMmrLim <-  (numSpotOverMmrLim/length(MMR))*100,
           percentSpotOverMmrLim <- 0)
    
    #IQR(MMR)
    mmrIqr <- IQR(MMR, na.rm = TRUE)     
    
    # Normalization
    if (DEBUG) print("SlideQuality 6")

    goodAM <- !(is.infinite(Amedian) | is.infinite(Mmedian) |
                is.na(Amedian) | is.na(Mmedian))
    
    fit <- lowess(Amedian[goodAM], Mmedian[goodAM])

    MSE <- function(x, center) {
      if(missing(center))
        return(mean.na(x))
      else
        return(mean.na(sqrt(sum((x-center)^2))))
    }
    
    # MSE of lowess curve

    mseFit <- MSE(fit$y, center=0)

    # Print-tip information, mse by print-tip group
    if (DEBUG) print("SlideQuality 7")
    goodMed <-  !(is.infinite(Mmedian) | is.na(Mmedian))

    pt <- cbind(Block = as.vector(as.numeric(gprData[["Block"]])),
                M = Mmedian)
    #get the mean of Mvalues by print-tip group
    printTip <-  by(pt[,2],factor(pt[,1]), mean)
    goodPt <- !(is.infinite(printTip) | is.na(printTip))
    msePtip <- MSE(printTip[goodPt], center=0)


    if (DEBUG) print("SlideQuality 8")

    # Controls
    if (DEBUG) print("before arrayControls")

    Control <- arrayControls(gprData, SFGHControlcode = controlMatrix, id ="ID")
        numE <- numNeg <- numPos <- numProb <- 0
    emp <- neg <- pos <- NA

    for(i in 1:length(Control))
      {
        if (Control[i] == "Empty")
          {
            numE <- numE + 1
            emp <- c(emp, Amedian[i])
          }
        if (Control[i] == "Negative")
          {
            numNeg <- numNeg + 1
            neg <- c(neg, Amedian[i])
          }
        if (Control[i] == "Positive")
          {
            numPos <- numPos + 1
            pos <- c(pos, Amedian[i])
          }
      }

    EmptyMed <- median(as.numeric(emp), na.rm=TRUE)
    NegativeMed <- median(as.numeric(neg), na.rm=TRUE)
    PositiveMed <- median(as.numeric(pos), na.rm=TRUE)

    difEmptyNegative <- EmptyMed - NegativeMed
    difPositiveNegative <- PositiveMed - NegativeMed

    # Replicates
    if (DEBUG) print("SlideQuality 9")

    gId <- gprData[[controlId]]
    Replicates <- arrayReplicates(gprData, id = controlId)

    if (DEBUG) print(length(Replicates))

    ##Old code
    #index <- c()
    #for(r in Replicates){
    #  for(i in 1:length(gId)){
    #    if (r == gId[i]) index <- c(index,i)
    #  }
    #}

       
    #for(r in Replicates){
    #  ind <- grep(Replicates[r],gId)
    #  varvect <- c
    #}
    #if (length(index) == 0)
    #  repA <- NA
    #else 
    #  repA <- Amedian[index]
    
    #varRepA <- var(repA, na.rm=TRUE)

    ##Agnes
  

    #varvect <- c()
    #for(r in Replicates)
    #  {
    #    index <- c()
    #    for(i in 1:length(gId)){
    #      if (r == gId[i]) index <- c(index,i)
    #    }
    #    if(length(index)>0)
    #      varvect <- c(varvect,var(Amedian[index],na.rm=TRUE))
    #  }

    #if(length(varvect)>0)
    #  varRepA <- mean(varvect,na.rm=TRUE)
    # else
    #  varRepA <- NA

    ## Agnes: modified Mar 21, 08
##    varvect <- c()
##    varvect <- sapply(Replicates,function(x){return(var(Amedian[grep(x,gId)],na.rm=T))})
##    varRepA <- mean(varvect,na.rm=T)
    

    # Flags
    Flags <- gprData[["Flags"]]
    numFlag <- Flags[Flags !=0]
    ifelse((length(Flags)!=0),
           percentFlag <- (length(numFlag)/length(Flags))*100,
           percentFlag <- 0)

    # Prepare for output
    # We want a list of all numbers, returned as a matrix
    # Easier to compare later

    ## AP: modified on 4/07/2008 to match names on paper
    ## also removed the varRepA values from final results
    
    #sortedMeasures <- c("range RF", "range GF",
    #                    "\\- RB mad", "\\- GB mad",
    #                    "Median RS2N", "Median GS2N",
    #                    "\\- Median A for empty ctrl",
    #                    "\\- Median A for neg ctrl",
    #                    "Median A for positive ctrl",
    #                    "Pos ctl median A - Neg ctl median A",
    #                    "\\- Var replicated spots A values",
    #                    "\\- Mvalues MSE by print-tip",
    #                    "\\- MSE lowess",
    #                    "\\- % flagged spots",
    #                    "\\- Mvalues MMRmad",
    #                    "\\- % spots with Mvalues MMRmad>0.5"
    #                    )
        
  sortedMeasures <- c("rangeRf", "rangeGf",
                      "-madRb", "-madGb",
                      "medRS2N", "medGS2N",
                      "-medA_empty",
                      "-medA_negative",
                      "medA_positive",
                      "diffA_pos-neg",
                      "-msePTip",
                      "-mseFit",
                      "-percentFlag",
                      "-madMMR",
                      "-extremeMMR")
        

    sortedRes <- c(rangeRf, rangeGf,
                   -RbMad, -GbMad,
                   RS2Nmedian, GS2Nmedian,
                   -EmptyMed, -NegativeMed, PositiveMed,
                   difPositiveNegative,
                   ##-varRepA,
                   -msePtip, -mseFit,
                   -percentFlag,                                      
                   -MMRmad, -percentSpotOverMmrLim 
                   )
    ## Alice (ar 07): remove "," (typo from before)
    
    numResult <- as.matrix(sortedRes)
    rownames(numResult) <- sortedMeasures
    colnames(numResult) <- gprData[["File"]]
                
    if (DEBUG) print("SlideQuality done...")
    return(numResult)         
  }


##################################################
## scalRefTable: same as qualRefTable, but use
## reference table as is
## reference is a result from globalQuality
##################################################

scaleRefTable <- function(reference=NULL, organism=c("Mm", "Hs"))
  {
    
    organism <- organism[1]
    if(is.null(reference))
      {
        if(organism == "Mm")
          {
            if (!("MmReferenceDB" %in% ls(1)))
              data(MmReferenceDB)
            reference <- MmReferenceDB
          }
        else
          {
            if(!("HsReferenceDB" %in% ls(1)))
              data(HsReferenceDB)
            reference <- data(HsReferenceDB)
          }
      }

    ave <- apply(reference, 1, median, na.rm=TRUE)
    iqr <- apply(reference, 1, IQR, na.rm=TRUE)
    reftab <- cbind(median=ave,
                    iqr=iqr)
    return(reftab)
  }

## Takes a matrix/vector of numbers as argument
## Scales this matrix according to median and iqr of reference values
## if reference is missing, use reference values (Mm by default, or Hs)
## (globalQuality result)

arrayScal <- function(numMat, reference=NULL, organism=c("Mm", "Hs"))
{
  organism=organism[1]

  if(missing(numMat))
    stop("Input error, matrix to scale missing")
  else
    {
      if(is.null(reference))
        {
          if(organism == "Mm")
            {
              if (!("MmReferenceDB" %in% ls(1)))
                data(MmReferenceDB)
              reference <- MmReferenceDB
            }
          else
            {
              if(!("HsReferenceDB" %in% ls(1)))
                data(HsReferenceDB)
              reference <- data(HsReferenceDB)
            }
        }

      reftab <- scaleRefTable(reference=reference, organism=organism)
      
      ## Determine dimensions
      if(!is.null(dim(numMat)))
        {
          ncol <- dim(numMat)[2]
          nrow <- dim(numMat)[1]
        }
      else
        {
          ncol <- 1
          nrow <- length(numMat) ## numMat is a vector
        }
 
      #Check dimensions 
      if(nrow!=dim(reftab)[1])
        {
          stop("Error is scaling, files of different length")
        }
      else
        { 
          tmp <- numMat

          tmp2 <- sweep(tmp,1,reftab[,"median"], FUN="-")
          ##Pb: deal with iqr==0!!
          ##Test if Inf values don't crash boxplot
          tmp <- sweep(tmp2,1,reftab[,"iqr"],FUN="/")
           
          #for(j in 1:ncol)
          #  for(i in 1:nrow)
          #  {
          #    if(reftab[i,"iqr"]!=0)
          #      tmp[i,j] <- (as.numeric(tmp[i,j]) - as.numeric(reftab[i,"median"]))/
          # as.numeric(reftab[i,"iqr"])
          #    else
          #      {
          #        print("One of the ranges = 0")
          #        tmp[i,j] <- as.numeric(tmp[i,j]) - as.numeric(reftab[i,"median"])
          #      }              
          #  }
          
          return(tmp)
        }
    }
}


################################################
## HTML report
# Read in names of plots
# suppose directory contains
# same number of qualPlot and diagPlot
# based on alphabetical order

# nbBelow is a matrix: for each slide: number of measure below range of good slides and total number of measures

quality2HTML <- function(fnames=NULL, path=".", DiagPlot=NULL, QCplot=NULL, resdir=".", nbBelow=NULL)
  {
    print("starting HTML")
    HTwrap <- function(x, tag = "TD", option="align", value="center") {
      if (option == "")
        {
          paste("<", tag, "\"",  ">", x, "</", tag, ">", sep = "")
        }
      else
        paste("<", tag," ", option, "=\"",value, "\"",  ">", x, "</", tag, ">", sep = "")
    }
    
    HTimg <- function(src){
      paste("<a href= \"",src, "\">",
            "<img width=\"300\", height=\"200\", aligh=\"center\", src= \"",
            src, " \"/></a>", sep="")
    }

    HTscore <- function(filename,src){
      paste(filename, "<br>",
            "Measures below range: ", src)
    }

    
    tableTag <- function(fnames,fullDiagp,fullQCp) 
      {
        
        tab <- ""
        tr <- ""
        
        for(i in 1:min(length(fullQCp), length(fullBoxp)))
          {
            td2 <- HTwrap(HTimg(fullDiagp[i]), tag="TD")
            td1 <- HTwrap(HTimg(fullQCp[i]), tag="TD")
            td3 <- HTwrap(HTscore(fnames[i],paste(nbBelow[i,1], nbBelow[i,2], sep="/")), tag="TD",
                          option="align", value="left") 
            
            tr <- HTwrap(paste(td1, td2, td3, sep="\n"), tag="TR")
            tab <- paste(tab,tr,sep="")
          }
        return(tab)
        
      }

    if(missing(QCplot) || is.null(QCplot))
      {
        QCp <- dir(path, pattern="QCPlot*")
        fullQCp <- file.path(path, QCp)
      }
    else {
      fullQCp <- QCplot
    }

    if(missing(DiagPlot) || is.null(DiagPlot))
      {
        boxp <- dir(path, pattern="qualPlot*")
        fullBoxp <- file.path(path,boxp)
      }
    else {
      fullBoxp <- DiagPlot
    }

    outputfile <- file(file.path(resdir,"qualityReport.html"),"w") 
    datadir <- system.file("gprQCData", package="arrayQuality")
    html <- paste(readLines(file.path(datadir, "index.html")), "\n", collapse="")

    split <- unlist(strsplit(html, split="<a name=\"table\"></a>"))

    tab <- tableTag(fnames,fullQCp, fullBoxp)
    
    cat(split[1], tab,split[2], file=outputfile)     
    close(outputfile)
    print("End HTML")
  }

#slidequality is the result of slideQuality for ONE slide
qualityScore <- function(slidequality, organism=c("Mm", "Hs"), reference=NULL)
  {
    organism <- organism[1]
    slidequality <- as.vector(slidequality)

    if(is.null(reference))
      {
        if(organism == "Mm")
          {
            if (!("MmReferenceDB" %in% ls(1)))
              data(MmReferenceDB)
            reference <- MmReferenceDB
          }
        
        else
          {
            if(!("HsReferenceDB" %in% ls(1)))
              data(HsReferenceDB)
            reference <- data(HsReferenceDB)
          }
      }

    score <- matrix(0,nrow=length(slidequality), ncol=1)

    for(i in 1:length(slidequality))
      {
        vect <- reference[i,]
        score[i] <- (length(vect[vect < slidequality[i]])/length(vect))*100
      }
    return(score)

  }

##############################################
## Jean: Sep 21, 2004 : make it more general by allowing different input source
##Reads in gpr files
# returns matrix of QC measures
globalQuality <- function(fnames = NULL, path = ".",
                          organism=c("Mm", "Hs"),
                          output=FALSE,
                          resdir=".",
                          DEBUG = FALSE,
                          inputsource = "readGPR",
                          controlId="ID",
                          ...)
  {
    # Check input arguments
    if (DEBUG) print("Starting globalQuality")
    opt <- list(...)
    
    if (missing(fnames) | is.null(fnames))
      {
        if(inputsource == "readGPR") fnames <- dir(path, pattern = ".*\\.gpr$")
        if(inputsource == "readAgilent") fnames <- dir(path, pattern = ".*\\.txt$")
        if(inputsource == "readSpot") fnames <- dir(path, pattern = ".*\\.spot$")
      }
    
    organism <- organism[1]
        
    # Prepares results
    quality <- c()
    
    # Call to slideQuality for each gpr file

    for (i in 1:length(fnames))
      {
        if (DEBUG) print("In the loop ")
        f <- fnames[i]
        gp <- do.call(inputsource, args=list(fnames=f, path=path,controlId=controlId))
        defs <- c(list(gprData = gp), opt)
        SQ.args <- maDotsMatch(defs, formals(args("slideQuality")))
        restmp <- do.call(slideQuality, SQ.args)
        quality <- cbind(quality, restmp[,1])
        meas <- rownames(restmp)

        ## Was:
        ##restmp <- slideQuality(gp,...)
        ##quality <- cbind(quality, restmp[,1])
        ##meas <- rownames(restmp)
      }
    
    colnames(quality) <- fnames
    rownames(quality) <- meas
       
    # Results
    if (output)
      write.table(quality, "quality.txt",sep="\t", col.names=NA)
    
    return(quality)
  }
  
#################################
## Plot function

# 1. Plot the boxplot
# 2. SuperImpose value for slides of interest (1 or more)
# arrayQuality and reference are results from
# slideQuality and globalQuality respectively


qualBoxplot <- function(arrayQuality=NULL,  reference=NULL, organism=c("Mm", "Hs"), DEBUG=FALSE,...)
  {
    if (is.null(arrayQuality) || missing(arrayQuality))
      stop("No data to plot")
    
    # Reference = output of globalQuality for ref slides
    # if NULL, reads in matrix store as RData
    organism<-organism[1]
    
    score <- qualityScore(arrayQuality)
    if(is.null(reference))
      {
        if(organism == "Mm")
          {
            if (!("MmReferenceDB" %in% ls(1)))
              data(MmReferenceDB)
            reference <- MmReferenceDB
          }
        
        else
          {
            if (!("HsReferenceDB" %in% ls(1)))
              data(HsReferenceDB)
            reference <- HsReferenceDB            
        }
      }

    scalref <- arrayScal(reference, reference=reference)    
    scalarray <- as.matrix(arrayScal(arrayQuality, reference=reference))
    
    if(is.null(dim(scalref))|nrow(arrayQuality)!=nrow(reference))
      stop("Input must be a matrix resulting from slideQuality.R")
    else
      {
        #Boxplot of reference arrays quality measure

        nr <- nrow(scalref)

        ##goodLim <- matrix(0,nrow=nr,ncol=1)
        ##pb, what if arrayQuality = more than 1 col!
        goodLim <- matrix(0, nrow=nr, ncol=ncol(arrayQuality))

        lim <- range(as.numeric(scalarray),as.numeric(scalref),na.rm=TRUE, is.finite=TRUE)
        plot(0:(nr+1),0:(nr+1),xlim=lim,type="n", axes=FALSE,ylab="",xlab="", xaxt="n",
             main="Array Quality Control Comparison")

        axis(2, at=1:nr, labels=rownames(arrayQuality), cex.axis=0.8, las=2)
        tmp <- c(paste(as.character(round(score)), "(", as.character(round(arrayQuality,1)), ")"), "% (value)")
        axis(4, at=1:(nr+1), labels=, tmp, cex.axis=0.8, las=2)
        axis(1, at=c(lim[1]+0.5, lim[2]-0.5), labels= c("Problematic", "Good"))

        ##No pb with Na's
        for(i in 1:nr)
          {
            if(!is.na(min(as.numeric(scalref[i,]))))  ## new line Sept, 2004
              {
                bp <- boxplot(as.numeric(scalref[i,]), at=i,
                              add=TRUE, horizontal=TRUE, axes=FALSE)
                ##goodLim[i,1] <- bp$stats[1]  ## pb if more than 1 col
                ## AP: this was not the min of the distribution
               goodLim[i,1] <- min(as.numeric(scalref[i,]),na.rm=T)
              }
            else
              {
              goodLim[i, 1] <- NA
              }
          
            ## not ploting if NA
            tmp <- round(quantile(as.numeric(reference[i,]),
                                  probs=c(0.75, 0.25), na.rm=TRUE),1)
            text(quantile(as.numeric(scalref[i,]), probs=c(0.8, 0.2), na.rm=TRUE),rep((i+0.3),2),
                 as.character(tmp), cex=0.7, col="blue")
          }

        
        #Line for tested arrays
        #Number of measure below criteria
        nc <- ncol(scalarray)
        col <- rainbow(nc)

        isBelowLim <- matrix(FALSE, ncol=nc, nrow=nr)
        
        for(i in 1:nc)
          {
            lines(scalarray[,i], 1:nr, col=col[i], lty=2)
            points(scalarray[,i],1:nr, col=col[i], pch=15, cex=1.5)
            missingdata <- as.vector(is.na(scalarray[,i]))
            if(length(missingdata[missingdata]) > 0)
              {
                text(rep(lim[1]+ 1,length(missingdata[missingdata])),
                     c(1:nr)[missingdata],
                     rep("NA", length(missingdata[missingdata])),
                     col="green", cex=0.8)
              }
            
            for(j in 1:nr)
              {
                if(!is.na(goodLim[j,1]))
                  {
                    if(as.numeric(scalarray[j,i]) < goodLim[j,1] || is.na(scalarray[j,i]))
                      isBelowLim[j,i] <- TRUE
                  }
                else
                  {
                    isBelowLim[j,i] <- NA
                  }
              }
          }
        box()
        #legend
        leg.txt <- colnames(arrayQuality)
        legend(lim[1],nr+1,leg.txt,lty=1,col=col, cex=0.7)

        res <- character(0)
        for(i in 1:nc)
          res <- c(res, length(isBelowLim[isBelowLim[,i],i]))
        return(cbind(res, nr))
      }
  }

########################################################
## Write normalized data to .txt file
## By default, background subtraction IS performed
########################################################

outputNormData <- function(mraw=NULL, DEBUG = FALSE, val=c("maM", "maA"),...)
  {
    print("In outputNormData")
    print(val)
    opt <- list(...)   
    norm.defs <- maDotsMatch(maDotsDefaults(opt, list(norm="p")),formals(args(maNorm)))

    if (DEBUG) cat("Using normalization method:  ", norm.defs$norm, "\n")
    if (DEBUG) print("No background subtraction")
    tmp <- mraw
    maRb(tmp) <- maGb(tmp) <- matrix(0,0,0)
    mnorm <- do.call(maNorm, c(list(tmp), norm.defs))
    write.marray(mnorm, "NormalizedData.xls", val=val)
  }


readcontrolCode <- function(file = "SpotTypes.txt", path = NULL, sep = "\t", check.names = FALSE, controlId=c("ID", "Name"), ...) 
  {
    controlId <- controlId[1]
    spotTypes <- readSpotTypes(file=file, path=path, sep=sep, check.names=check.names, ...)
    controlCode <- spotTypes[, c(grep(controlId, colnames(spotTypes)), 1)]
    colnames(controlCode) <- c("Pattern", "Name")
    return(controlCode)
  }

#########################################################
## Agnes: 03/23/2008 adding qcScore

qcScore <- function(arrayQuality, reference)
  {
    Lowlimit <- apply(reference, 1, range)[1,]
    ##res <- apply(sweep(arrayQuality, 2, Lowlimit, "<="), 2, sum) AP: Gives a warning
    res <- apply(arrayQuality,2,function(x){sum(x<Lowlimit,na.rm=T)})
    return(res)
  }

##############################################################
## Wrapper function for HEEBO QC
## Date: 06/18/2006
## Author: Agnes
##############################################################

##source("C:/MyDoc/Projects/madman/Rpacks/arrayQuality/R/heeboQuality.R")
##heeboQuality(spikeTypeFile="DopingTypeFile2.txt",DEBUG=TRUE, norm="n")

heeboQuality <- function(fnames = NULL, path = ".",
                         galfile=NULL,
                         source="genepix.median",
                         other.columns = c("Flags"),
                         controlMatrix = HeeboSpotTypes, 
                         controlId = c("ID", "Name"),
                         DOPING=TRUE,
                         heeboSetQC=TRUE,
                         SpotTypeFile=NULL,
                         SpikeTypeFile=NULL,
                         cy3col="Cy3_ng",
                         cy5col="Cy5_ng",
                         id="SeqID",
                         namecol=c("Symbol","Name"),
                         annot=NULL,
                         bgMethod="none",
                         normMethod="p",
                         diagnosticPlot=TRUE,
                         output=TRUE,
                         resdir = ".", 
                         dev = "png",
                         organism="Hs",
                         DEBUG = FALSE, ...)
  {
    print("Staring heeboQuality")
    require(HEEBOdata)
    ## Check input arguments
    if (missing(path) | is.null(path))
      path <- "."
    
    if (missing(fnames) | is.null(fnames))
      fnames <- dir(path, pattern = ".*\\.gpr$")

    if(!DOPING)
      print("Spike-in QC plots won't be generated")
    else
      {
        if (missing(SpikeTypeFile) | is.null(SpikeTypeFile))
          {
            print("Missing doping control information")
            print("Spike-in QC plots will not be generated")
            DOPING <- FALSE
          }
      }
       
    if (DEBUG) print(paste("DOPING=",DOPING,sep=""))
    if(!heeboSetQC)
      {
        print("HEEBO set quality control plots will not be generated")
      }
    if(DEBUG) print(paste("heeboSetQC = ",heeboSetQC,sep=""))
    if(DEBUG) print(paste("diagnosticPlot = ",diagnosticPlot,sep=""))
    
    controlId <- controlId[1]
    if (DEBUG) print(controlId) 
    opt <- list(...)

    ## Load required R objects
    if(is.null(annot))
      {
        if(!("HEEBOset" %in% ls(1)))
          data(HEEBOset)
        annot=HEEBOset
      }

    if(DOPING)
      {
        if(DEBUG) print("Parsing Spike Type File")
        spike.defs <- list(file=SpikeTypeFile,path=path,cy5col=cy5col,cy3col=cy3col)
        spike.args <- maDotsMatch(maDotsMatch(opt, spike.defs), formals(args("readSpikeTypes")))
        SpikeList <- do.call(readSpikeTypes,spike.args)
        spike.args <- maDotsMatch(maDotsMatch(opt, spike.defs), formals(args("readSpotTypes")))
        HeeboSpikeTypes <- do.call(readSpotTypes,spike.args)
        if(length(namecol)>1)
          namecol=namecol[1]

      }

    ## Reading data in
    if (!is.null(galfile))
      {
        if(DEBUG) print("Reading Galfile ... ")
        gal.defs <- list(galfile = galfile, path=path, fill=TRUE)        
        gal.args <- maDotsMatch(maDotsMatch(opt, gal.defs), formals(args("readGAL")))
        gal.args <- maDotsMatch(maDotsDefaults(opt, gal.defs), formals(args("readGAL")))
        gal <- do.call(readGAL, gal.args)

        gpr.defs <- list(files=fnames, path=path,source=source,other.columns=other.columns)
        gpr.args <- maDotsMatch(maDotsMatch(opt,gpr.defs),formals(args(read.maimages)))
        
        RG <- do.call(read.maimages,gpr.args)
        RG$genes <- gal
        RG$printer <- getLayout(RG$genes)
      }
    else
      {
        if (DEBUG) print("Reading .gpr ...")
        gpr.defs <- list(files=fnames, path=path,source=source,other.columns=other.columns)
        gpr.args <- maDotsMatch(maDotsMatch(opt,gpr.defs),formals(args(read.maimages)))     
        RG <- do.call(read.maimages,gpr.args)
        RG$printer <- getLayout(RG$genes)
      }

    ## Set control status
    if(DEBUG) print("Setting up control status")
    if(!is.null(SpotTypeFile))
      {
        spot.defs <- list(file=SpotTypeFile)
        spot.args <- maDotsMatch(maDotsMatch(opt,spot.defs),formals(args(read.maimages)))     
        controlMatrix <- do.call(readSpotTypes,spot.args)
      }
    RG$genes$Status <- controlStatus(controlMatrix,RG,regexpcol=controlId, verbose=FALSE)
    if(DEBUG) print(table(RG$genes$Status))

    ## Don't forget to set up rownames==ID
    rownames(RG$R) <- rownames(RG$G) <- RG$genes[,controlId]

    ##############################################################
    ## Pre-processing: Bg subtraction, normalization

    ## Bg subtraction
    bg.defs <- list(method=bgMethod, RG=RG)
    bg.args <- maDotsMatch(maDotsMatch(opt,bg.defs),formals(args(backgroundCorrect)))
    RGsub <- do.call(backgroundCorrect,bg.args)
    rownames(RGsub$R) <- rownames(RGsub$G) <- RG$genes[,controlId]

    ## Normalization
    norm.defs <- list(method=normMethod, object=RGsub)
    norm.args <- maDotsMatch(opt,norm.defs)
    MA <- do.call(normalizeWithinArrays,norm.args)
    ## need to set up rownames for MA$M and MA$A
    rownames(MA$A) <- rownames(MA$M) <- RG$genes[,controlId]
    
    ## Set up output device
    if (DEBUG) print("Setting up default output device")
    plotdef <- switch(dev,
                      "bmp" = list(dev=list(width=800, height=600, bg="white"), suffix="bmp"),
                      "jpeg" = list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      "postscript" = list(dev=list( bg="white"), suffix="ps"),
                      "png" =  list(dev=list(width=800, height=600, bg="white"), suffix="png"),
                      list(dev=list(width=800, height=600,bg="white"), suffix="png"))
    
    if(!is.element(dev, c("bmp", "jpeg","png","postscript")))
      {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

    ## Switch do result directory if needed
    if (DEBUG) print("Switching to result directory")
    if (!file.exists(resdir))
      dir.create(resdir)
    curdir <- getwd()
    setwd(resdir)

    ###############################################################
    ## Generate diagnostic plots
    if(diagnosticPlot)
      {
        print("Starting heeboQualityPlots")
        qp.defs <-list(mrawObj=RG,controlId=controlId,DEBUG=DEBUG,
                       dev=dev,norm=normMethod, organism=organism)
        qp.args <- maDotsDefaults(opt, qp.defs)
        do.call(heeboQualityPlots, qp.args)
      }

    ###############################################################
    ## Write normalizaed data to file

    if (output)
      {
        print("Printing results to file")
        ##colnames(mraw@maGnames@maInfo) <- c("Name", "ID")
        ## do.call("outputNormData", c(list(mraw=RG, val=val), norm.defs))
        tmp <- c()
        cnames <- c()
        for(i in 1:ncol(MA$A))
          {
            tmp <- cbind(tmp, MA$M[,i],MA$A[,i])
            cnames <- c(cnames, paste("M",colnames(MA$M)[i],sep="_"),
                        paste("A", colnames(MA$A)[i],sep="_"))
          }
        colnames(tmp) <- cnames
        write.table(cbind(Block=MA$genes$Block,
                          Column=MA$genes$Column, Row=MA$genes$Row,
                          Name=MA$genes$Name, ID=MA$genes$ID,
                          tmp),file="NormalizedData.xls",
                    sep="\t",quote=FALSE,row.names=FALSE)
        rm(cnames,tmp)
      }

    ##########################################################
    ## Specific individual control plots
    if(heeboSetQC)
      {
        if(DEBUG) print("Starting specific control plots...")
    
        ## Loading controls
        if(DEBUG) print("Loading mismatch control and binding energy info")
        
        if(!("HEEBOctrl" %in% ls(1)))
          data(HEEBOctrl)

        if(!("HEEBOtilingres" %in% ls(1)))
          data(HEEBOtilingres)
        
        for(i in 1:dim(MA)[2])
          {
            if (DEBUG) print(i)
            
            ## Mismatch plot
            if(DEBUG) print("qpMisMatchPlot")
            plotname <- paste("Mismatch",colnames(MA$A)[i],plotdef$suffix,sep=".")
            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname,width=1600,height=1200),
                                                             plotdef$dev)),
                                       formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                       formals(args(dev))))
            par(mfrow=c(3,4), cex=1.5, cex.axis=0.8, cex.main=1.2,mar=c(2,2,2,2),oma=c(3,3,3,3))
            qpMisMatchPlot(MA[,i],ctrllist=HEEBOctrl,organism=organism,DEBUG=DEBUG)
            title(paste("Mismatch plot for", colnames(MA$A)[i],sep=" "),outer=TRUE,cex=1.2)
            dev.off()
            
            ## Binding Energy ------------------------ 
            
            if(DEBUG) print("qpBEPlot")
            plotname <- paste("BindingEnergy",colnames(MA$A)[i],plotdef$suffix,sep=".")
            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname),
                                                             plotdef$dev)),
                                       formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                       formals(args(dev))))
            par(mar=c(5,5,5,5))
            qpBEplot.linear(RGsub[,i], ctrllist=HEEBOctrl,DEBUG=DEBUG)
            dev.off()                           
            ##-------------------------------------------------------------
            
            ## Titling controls
            if(DEBUG) print("qpTiling")
            plotname <- paste("Tiling",colnames(MA$A)[i],plotdef$suffix,sep=".")
            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname,width=1500,height=1200),
                                                             plotdef$dev)),formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                       formals(args(dev))))
            par(mfcol=c(3,4), cex=1.3, cex.axis=1, mar=c(3,4,3,2),oma=c(2,2,4,2))
            qpTiling(RGsub[,i], tilingres=HEEBOtilingres,organism=organism,DEBUG=DEBUG)
            title(paste("Raw signal vs. 3' distance:",colnames(MA$A)[i],sep=" "),
                  cex=2,outer=TRUE)
            dev.off()
            
            if(DEBUG) print("End of Heebo set QC")
          }
      }

        ##-------------------------------------------------------------       
        ## Spike-ins
        
        if(DOPING)
          {
            for(i in 1:dim(MA)[2])
              {
                
                if(DEBUG) print("Starting QC plots for doping controls")
                ## Cy3 vs Cy5 raw signal
                if(DEBUG) print("Spike.Cy5vsCy3")
                spike.defs <- list(rawobj=RGsub[,i],spikesTypes=HeeboSpikeTypes,id=id,annot=annot,
                                   gnames=RGsub$genes[,controlId],cy5col=cy5col,cy3col=cy3col)
                spike.args <- maDotsDefaults(maDotsMatch(opt, spike.defs),formals(args(Spike.Cy5vsCy3)))

                plotname <- paste("Spike.Cy5vsCy3",colnames(MA$A)[i],plotdef$suffix,sep=".")
                if(plotdef$suffix != "ps")
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname,width=800,height=800),
                                                                 plotdef$dev)),formals(args(dev))))
                else
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                           formals(args(dev))))
                
                if(DEBUG) print(names(spike.args))
                par(mar=c(5,5,5,5))
                do.call(Spike.Cy5vsCy3,spike.args)
                dev.off()
                
                ## MMplot obserevd vs. expected
                spike.defs <- list(mval=MA$M[,i],spikeList=SpikeList,id=id,annot=annot,
                                   gnames=MA$genes[,controlId],namecol=namecol,cy5col=cy5col,cy3col=cy3col)
                spike.args <- maDotsMatch(maDotsDefaults(opt,spike.defs),formals(args(Spike.MMplot)))
                
                ## Will generate 2 plots/spike type
                ntypes <- length(SpikeList)
                
                ## Spike.MMplot
                if(DEBUG) print("Spike.MMplot")
                plotname <- paste("Spike.MMplot",colnames(MA$A)[i],plotdef$suffix,sep=".")
                if(plotdef$suffix != "ps")
                  do.call(dev, maDotsMatch(maDotsDefaults(opt,c(list(filename=plotname,width=800,height=500*ntypes),
                                                                plotdef$dev)),formals(args(dev))))
                else
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                           formals(args(dev))))
                par(mfrow=c(ntypes,2),cex.main=2,cex.lab=1.5,oma=c(7,3,3,3))
                do.call(Spike.MMplot,spike.args)
                title(paste("Observed and expected ratios for",colnames(MA$A)[i],sep=" "),cex=2.5,outer=TRUE)
                dev.off()
                
                ##Observed ratio/expected ratio scattered
                
                if(DEBUG) print("Spike.MM.Scatter")
                plotname <- paste("Spike.MM.Scatter",colnames(MA$A)[i],plotdef$suffix,sep=".")
                if(plotdef$suffix != "ps")
                  do.call(dev, maDotsMatch(maDotsDefaults(opt,c(list(filename=plotname,width=600,height=500*ntypes),
                                                                plotdef$dev)),formals(args(dev))))
                else
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                           formals(args(dev))))
                par(mfrow=c(ntypes,1),oma=c(1,3,3,3),mar=c(7,3,3,3))
                spike.args <-  maDotsMatch(maDotsDefaults(opt,spike.defs),formals(args(Spike.MM.Scatter)))
                do.call(Spike.MM.Scatter,spike.args)
                title(paste("Observed and expected ratios for",colnames(MA$A)[i],sep=" "),cex=2.5,outer=TRUE)
                dev.off()
                
                ## Spike-in sensitivity
                
                if(DEBUG) print("Spike Sensitivity")            
                spike.defs <- list(rawobj=RGsub[,i],spikeList=SpikeList,id=id,annot=annot,ctllist=HEEBOctrl,
                                   gnames=RGsub$genes[,controlId],namecol=namecol,cy5col=cy5col,cy3col=cy3col)
                spike.args <- maDotsMatch(maDotsDefaults(opt,spike.defs),formals(args(Spike.Sensitivity)))
                
                plotname <- paste("Spike.Sensitivity",colnames(MA$A)[i],plotdef$suffix,sep=".")
                if(plotdef$suffix != "ps")
                  do.call(dev, maDotsMatch(maDotsDefaults(opt,c(list(filename=plotname,width=800,height=400*ntypes),
                                                                plotdef$dev)),formals(args(dev))))
                else
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                           formals(args(dev))))
                
                par(mfrow=c(ntypes,2),oma=c(3,3,3,3),cex.lab=1.2,cex.axis=1.2)
                do.call(Spike.Sensitivity,spike.args)
                title(paste("Sensitivity", colnames(MA$A)[i],sep=" "),outer=TRUE,cex=2.5)
                dev.off()
                
                if(DEBUG) print("Spike Sensitivity, individual spikes plots")            
                
                ##Spike.Individual.Sensitivity
                
                plotname <- paste("Spike.Sensitivity.Indi",colnames(MA$A)[i],plotdef$suffix,sep=".")
                if(plotdef$suffix != "ps")
                  do.call(dev, maDotsMatch(maDotsDefaults(opt,c(list(filename=plotname,width=1000,height=400*ntypes),
                                                                plotdef$dev)),formals(args(dev))))
                else
                  do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)),
                                           formals(args(dev))))
                par(mfrow=c(ntypes,2),oma=c(3,3,3,3),cex.lab=1.2,cex.axis=1.2)
                spike.defs <- list(rawobj=RGsub[,i],spikeList=SpikeList,id=id,annot=annot,ctllist=HEEBOctrl,
                                   gnames=RGsub$genes[,controlId],namecol=namecol,cy5col=cy5col,cy3col=cy3col)
                spike.args <- maDotsMatch(maDotsDefaults(opt,spike.defs),
                                          formals(args(Spike.Individual.Sensitivity)))
                do.call(Spike.Individual.Sensitivity,spike.args)
                title(paste("Sensitivity", colnames(MA$A)[i],sep=" "),outer=TRUE,cex=2.5)
                dev.off()
              }
          }

     ## Go back to previous directory
    
    if(DEBUG) print("End of heeboQuality")
    setwd(curdir)
    return(MA)
  }

#########################################################
## Set of functions written to assess quality
## of MEEBO set arrays
## Using MEEBO/HEEBO compatible functions
## Author: Agnes Paquet
## Date:   07/03/2006
## source("C:/MyDoc/Projects/madman/Rpacks/arrayQuality/R/qpMeeboFunc.R")
## Using R 2.3.1, arrayQuality 1.9.2
##########################################################

## Set up controlCode for Meebo
controlCodeMeebo <-
  structure(c("mMC", "mCP", "mCN", "EMPTY", "mCD",
            "Mouse mMC", "Positive", "Negative", "Empty", "Doping"),
            .Dim = c(5, 2),
            .Dimnames = list(c("1", "2", "3", "4","5"),
              c("Pattern", "Name")))

MeeboSpotTypes <-
  structure(c("probes","Mouse mMC", "Positive", "Negative", "Empty", "Doping",
              "*","mMC*", "mCP*", "mCN*", "EMPTY*", "mCD*",
            rep("*",6),
            "black","green","red","blue","cyan","yellow"),
            .Dim = c(6, 4),
            .Dimnames = list(c("1", "2", "3", "4","5","6"),
              c("SpotType","ID","Name","Color")))

## Boxplot for each type of controls

qpBoxplotMeebo <- function(mdata, xvar="maA", id="ID", colcode=1,meeboAnnot=MEEBOset,...)
  {

    newdata <- eval(call(xvar, mdata))
    xlim <- range(newdata, na.rm=TRUE)
    Ctl <- cbind(maInfo(maGnames(mdata)), maControls(mdata), row.names=NULL)
    IDindex <- grep(id, colnames(Ctl))  ## Set ID columns
    y <- split(Ctl, Ctl[,ncol(Ctl)])  ## The last column of Ctl is the control status
    y <- y[names(y)!="probes"]
    
    ylim <- c(0,(length(names(y))+1))
    par(mar=c(4,7,3,2), cex=1) 
    plot(1,1,type="n", xlim=xlim, ylim=ylim, axes=FALSE, xlab=xvar, ylab="",...)

    for(i in 1:length(names(y)))
        {
          boxplot(newdata[as.integer(row.names(y[[i]]))], add=TRUE,horizontal=TRUE,
                  at=i,col=colcode[names(y)[i]])
        }
    axis(2, at=1:length(names(y)), labels=as.character(names(y)), las=2)
    axis(1)
  }


#qpBoxplotMeebo.old
#<- function(mdata, xvar="maA", id="ID", colcode=1,meeboAnnot=MEEBOset,...)
#  {

   # newdata <- eval(call(xvar, mdata))
   # xlim <- range(newdata, na.rm=TRUE)
   # Ctl <- cbind(maInfo(maGnames(mdata)), maControls(mdata), row.names=NULL)

    #IDindex <- grep(id, colnames(Ctl))  ## Set ID columns
    #y <- split(Ctl, Ctl[,ncol(Ctl)])  ## The last column of Ctl is the control status
    
    #ylim <- c(0,length(names(y))+1)
    #par(mar=c(4,7,3,2), cex=1) 
    #plot(1,1,type="n", xlim=xlim, ylim=ylim, axes=FALSE, xlab=xvar, ylab="",...)

    ##y <- y[names(y)!="probes"]
    #for(i in 1:length(names(y)))
    #    {
    #      boxplot(newdata[as.integer(row.names(y[[i]]))], add=TRUE,horizontal=TRUE,
    #              at=i,col=colcode[names(y)[i]])
    #    }
    #axis(2, at=1:length(names(y)), labels=as.character(names(y)), las=2)
    #axis(1)
  #}

qpDotPlotsMeebo <- function(mdata,  xvar="maA", id="SeqID", colcode=1, nrep=3, pch=18, meeboAnnot=MEEBOset,...)
  {
    newdata <- eval(call(xvar, mdata))
    xlim <- range(newdata, na.rm=TRUE)
    Cindex <- maControls(mdata) != "probes"

    ## Get ordered sequence id
    matchIds <- match(maGeneTable(mdata)[,"ID"], meeboAnnot[,"uniqID"])
    
    Ctl <- cbind(maInfo(maGnames(mdata)), SeqID=meeboAnnot[matchIds,id],maControls(mdata),row.names=NULL)

    IDindex <- grep(id, colnames(Ctl))  ## Set ID columns
    y <- split(Ctl, Ctl[,ncol(Ctl)])  ## The last column of Ctl is the control status
    
    if(length(y[(names(y) != "probes") & (names(y) != "Doping") & (names(y) != "Mouse")]) != 0)
      ## check that there exist control spots
      {
        ## There are control spots
        exty <- lapply(y[(names(y) != "probes") & (names(y) != "Doping")& (names(y) != "Mouse")],
                       function(x){
                         ##ext <- split(x, x[, IDindex])
                         ext <- split(x,x[,IDindex],drop=TRUE)
                         extid <- lapply(ext, function(xx){as.integer(row.names(xx))})
                         extid[lapply(extid, length) > nrep]
                       })
        exty <- exty[lapply(exty, length) != 0]
        ## plot replicated controls and boxplot for other types (negative/empty) if any
        numplots <- 0
        plotnames <- c()
        if(("Negative" %in% names(y)) & !("Negative" %in% names(exty)))
          {
            numplots <- numplots+1
            plotnames <- c(plotnames,"Negative")
          }
        if(("Empty" %in% names(y)) & !("Empty" %in% names(exty)))
          {
            numplots <- numplots+1
            plotnames <- c(plotnames, "Empty")
          }
        if(("EMPTY" %in% names(y)) & !("EMPTY" %in% names(exty)))
          {
            numplots <- numplots+1
            plotnames <- c(plotnames, "EMPTY")
          }
        
        ylim <- c(1, (sum(unlist(lapply(exty, length)))+numplots))

        par(mar=c(4,7,3,2), cex=1)  ## A wide left side to allow for gene names
        plot(1,1, type="n", xlim=xlim, ylim=ylim, axes=FALSE, xlab=xvar, ylab="",...)
        ii <- 1
        for(i in 1:length(exty))
          for(j in 1:length(exty[[i]]))
            {
              ind <- exty[[i]][[j]]
              boxplot(newdata[ind], add=TRUE,horizontal=TRUE,
                      at=ii,col=colcode[names(exty)[i]])
              ii <- ii + 1
            }
        labs <- c()
        if(numplots>0)
          {
            for(k in 1:numplots)
              {
                boxplot(newdata[as.integer(row.names(y[[plotnames[k]]]))], add=TRUE,horizontal=TRUE,
                        at=ii,col=colcode[plotnames[k]])
                ii <- ii+1
                labs <- c(labs,paste(plotnames[k], "(n=",length(row.names(y[[plotnames[k]]])), ") ",sep=""))
              }
          }
        axis(1)

        #posSymbol <- as.character(MEEBOset[match(names(exty[["Positive"]]), as.character(MEEBOset[,"SeqID"])),"Symbol"])

        ##lab=c(paste("EMPTY (n=",length(row.names(y[["Empty"]])), ")", sep=""),
#        labs <- c(paste(unlist(lapply(exty, names)), " (n=",unlist(lapply(exty, lapply, length)), ") ", sep=""),labs)

        labstmp <- unlist(lapply(exty,names))
        ## Replace sequence ids by symbols if necessary
        labstmp[grep("mSQ", labstmp)] <- 
          as.character(MEEBOset[match(labstmp[grep("mSQ", labstmp)], as.character(MEEBOset[,"SeqID"])),"Symbol"])

        labsnum <- unlist(lapply(exty, lapply, length))
        labs <- c(paste(labstmp, " (n=", labsnum, ") ",sep=""), labs)
      
        axis(2, at=1:ylim[2], labels=labs, las=2, cex.axis=0.8)
        box()

      } else
    {
         ## There are NO control spots
      plot(1, 1, axes=FALSE, xlab="", ylab="", type="n")
      text(1, 1, "No Control Genes")
      box()
    }
    return()
  }

qpS2Nmeebo <- function(mdata, channel=c("red", "green"), colcode=1, ...)
  {
    ##Same as qpS2N, but using only mMC probes for histogram
    mmc <- grep("mMC", maGeneTable(mdata)[,"ID"])

    if(channel == "red"){
      if(length(maRb(mdata))!=0)
        S2N <- as.vector(log.na(maRf(mdata),2) - log.na(maRb(mdata),2))
      else
        S2N <- as.vector(log.na(maRf(mdata),2))}

    if(channel == "green"){
      if(length(maGb(mdata))!=0)
        S2N <- as.vector(log.na(maGf(mdata),2) - log.na(maGb(mdata),2))
      else
        S2N <- as.vector(log.na(maGf(mdata),2))}

    lab <- paste("S2N : ","mean:", round(mean(rm.na(S2N[mmc])), 2)," : ", "var:",
                 round(var(rm.na(S2N[mmc])), 2))
    hist(rm.na(S2N[mmc]), main=lab, col=channel, nclass=50, freq=FALSE, ylim=c(0,1.1));

    if(length(maControls(mdata))!=0)
      {
        tmp <- split(S2N, maControls(mdata))
        bw <- sd(rm.na(S2N)/4)
        tmp2 <- lapply(tmp, function(x){density(rm.na(x), bw=bw)})
        for(i in 1:length(tmp2))
          lines(tmp2[[i]], lwd=2, col=colcode[names(tmp2)[i]])
        xrange <- range(rm.na(S2N))
        xcood <- xrange[1] + (xrange[2]-xrange[1]) * 0.7
        legend(xcood, 1, names(tmp), lty=1, lwd=2, col=colcode[names(tmp)], cex=1.2)
      }
  }

 
meeboQualityPlots <-  function(mrawObj, headerInfo="",
                               save = TRUE,
                               dev = "png",  #set default to be png
                               col=NULL, badspotfunction=NULL,
                               controlId=c("ID", "Name"),
                               seqId="SeqID",
                               organism="Mm",
                               DEBUG=FALSE, ...)
{
  require(MEEBOdata)
  if (DEBUG) print("function starting")
  controlId <- controlId[1]

  if(!("MEEBOset" %in% ls(1)))
    data(MEEBOset)

  #Convert RGList to mraw if needed

  if (setequal(class(mrawObj), "RGList"))
      {
        mrawTmp <- as(mrawObj, "marrayRaw")
        maControls(mrawTmp) <- mrawObj$genes$Status
        rownames(maRf(mrawTmp)) <- rownames(maGf(mrawTmp)) <- rownames(mrawObj$R)
        rownames(maRb(mrawTmp)) <- rownames(maGb(mrawTmp)) <- rownames(mrawObj$R)
        mrawObj <- mrawTmp
        rm(mrawTmp)
      }
  
  if(DEBUG) print(dim(mrawObj))
  for(i in 1:dim(mrawObj)[2])
    {
      mraw <- mrawObj[,i]
      opt <- list(...)

      ## re-evaluate W
      if (DEBUG) print("Re-evaluate Weight")
      if(missing(badspotfunction)||is.null(badspotfunction))
        {
          tmp <- do.call(gpFlagWt, list(mraw@maW))
          mraw@maW <- tmp 
        }
      else
        if(!is.null(badspotfunction))
          mraw@maW <- do.call(badspotfunction, list(mraw@maW))

      ## setting controls cols
       ifelse(missing(col), colcode<- setCtlCol(mraw) , colcode <- col)

      ## To be fixed: using controlCode to generate maControls, not MeeboSPotTypes
      ## gives character, but colcode is integer
      #if(DEBUG) print("Set up color")
      #if(missing(col))
      #  {
      #    if(length(grep("Color",colnames(MeeboSpotTypes)))>0)
      #       colcode <- MeeboSpotTypes[,"Color"]
      #    else
      #      colcode <- setCtlCol(mraw)
      #  }
      #else
      #  colcode <- col
      
      if(DEBUG) cat("check Control color code", colcode, "\n")

      ## Set up no backgroud data and normalization
      if (DEBUG) print("Set up data and normalization")
      nbgraw <- mraw;
      if(length(mraw@maGb) != 0)
        nbgraw@maGb <- nbgraw@maRb <- matrix(0,0,0)

      if (DEBUG) print("Reading normalization parameters")
      if (DEBUG) print(opt)
      defs <- list(norm="p")
      norm.defs <- maDotsMatch(maDotsDefaults(opt, defs), formals(args("maNorm")))

      if (DEBUG) cat("Using normalization method:  ", norm.defs$norm, "\n")

      mnorm <- do.call(maNorm, c(list(nbgraw), norm.defs))

      ## Set up output name
      if (DEBUG) print("Name the output file")
      tmp <- unlist(strsplit(colnames(mraw@maGf), "/"))
      tmp3 <- unlist(strsplit(tmp[length(tmp)], "\\."))
      tmp2 <-  sub("/", "", tmp3)

      if(length(tmp2) > 1)
        fstart <- paste(tmp2[-length(tmp2)], collapse=".")
      else
        fstart <- tmp2

      if (DEBUG) print(fstart)


  ###################
  ## Setting up output device
  ###################
      if (DEBUG) print("Name of output device")
      plotdef <- switch(dev,
                        "bmp" = list(dev=list(width=1600, height=1200, bg="white"), suffix="bmp"),
                        "jpeg" = list(dev=list(quality=100, width=1600, height=1200, bg="white"), suffix="jpeg"),
                        ##"postscript" = list(dev=list(paper="special", width=32.0, height=24.0, bg="white"), suffix="ps"),
                        "postscript" = list(dev=list( bg="white"), suffix="ps"),
                        "png" =  list(dev=list(width=1600, height=1200, bg="white"), suffix="png"),
                        list(dev=list(width=1600, height=1200,bg="white"), suffix="png"))
      if(!is.element(dev, c("bmp", "jpeg","png","postscript")))
              {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

      fname <- paste("diagPlot", fstart,  plotdef$suffix, sep=".")
      if (DEBUG) print(fname)
      plotdef <- c(plotdef, list(main=paste(fname, ": Qualitative Diagnostic Plots")))

      ###################
      ## Plot
      ###################
      ## Match args and calls function
      ## Start device and layout
      if(DEBUG) print("start layout")

      if(save)
        {
          if(plotdef$suffix != "ps")
            do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=fname), plotdef$dev)), formals(args(dev))))
          else
            do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=fname), plotdef$dev)), formals(args(dev))))
        }

      
      ## Feb 23, 2005: JYH
      ## Modified width from 1.5 to 2 for the color bar.  This stops the error
      ## Figure margins too large when dev="postscript".  It was not a problem
      ## for any other dev setting. 
      
      ##      layout(matrix(c(14, 1,2,2, 14,0,3,3, 14,4,6,6, 14, 5, 7, 7, 14, 8, 10, 11,
      ##                      14, 9, 10, 11, 14, 12, 13, 13), 4, 7),
      ##             height=c(1, 10, 5, 5), width = c(11, 2, 5, 1.5 ,5, 1.5, 7))
      layout(matrix(c(14, 1,2,2, 14,0,3,3, 14,4,6,6, 14, 5, 7, 7, 14, 8, 10, 11,
                      14, 9, 10, 11, 14, 12, 13, 13), 4, 7),
             height=c(1, 10, 5, 5), width = c(11, 2, 5, 2 ,5, 2, 7))

      
      ## 1) Split MA-plot (Before Normalization)
      if(DEBUG) print("start 1")
      qpMAPlots(nbgraw, addp=TRUE, main="MA-Plot :: raw", ...)
      if(!is.null(opt$norm))
        {
          if(opt$norm == "p")
            addLines(nbgraw)
        }
      else
        addLines(nbgraw)

      ## 2) HEXbin MA-plot (After Normalization)
      if(DEBUG) print("start 2")
      qpHexbin(mnorm, main="MA-Plot :: Norm")

      ## 3 & 4) maM (Before Normalizaton)
      if(DEBUG) print("start 3, 4")
      qpImage(nbgraw, xvar="maM", main="Spatial: Rank(M-Raw)")

      ## 5 & 6) maM (After Normalization)
      if(DEBUG) print("start 5 & 6")
      ov.sub <- as.vector(maW(mnorm)) < 0
      qpImage(mnorm, xvar="maM", main="Spatial: Rank(M-Norm)", overlay=ov.sub)

      ## 7 & 8) maA
      if(DEBUG) print("start 7 & 8")
      qpImage(nbgraw, xvar="maA", main="Spatial: A")

      ## 9 & 10  Red and Green Signal to Noise (background corrected)
      if(DEBUG) print("start 9 & 10")
      qpS2Neebo(mraw, channel="red", colcode=colcode, organism=organism, controlId=controlId)
      qpS2Neebo(mraw, channel="green", colcode=colcode, organism=organism,controlId=controlId)
      ##qpS2Nmeebo(mraw, channel="red", colcode=colcode)
      ##qpS2Nmeebo(mraw, channel="green", colcode=colcode)

      ## 11 maM Dot plot -- Replaced by controls boxplot
      if(DEBUG) print("start 11")
      if(length(maControls(mnorm))!=0)
        qpBoxplotMeebo(mraw,xvar="maA", col=colcode, main="Control A", cex.main=0.8, id=controlId,meeboAnnot=MEEBOset)
#        qpDtPlotsMeebo2(mnorm, xvar="maA", col=colcode,
#                   main="Control normalized M", cex.main=0.8, id=controlId)
#      title(main= "Controls normalized M")

      ## 12 maM Dot plot
      if(DEBUG) print("start 12")
      if(length(maControls(mraw))!=0)
        qpDotPlotsEEBO(mraw, xvar="maM", col=colcode, main="Control M", cex.main=0.8, id=seqId, meeboAnnot=MEEBOset)
       #title(main= "Controls A")

      if(DEBUG) print("start 13")
      ## 13
      layout(1)
      par(mar=c(2,2,4,2))
      mtext(plotdef$main, line=3)
      mtext(headerInfo, line=2, cex = 0.7)
      mtext(paste("Call:", maNormCall(mnorm)[3]), line=1, cex = 0.7)

      ## Finishing
      if(DEBUG) cat("Done...")
      if (save == TRUE) {
        cat(paste("save as", fname, "\n"))
        dev.off()
      }
    }
}

##########################################################3
## Quality control plots
##
## Author: Jean Yang, Agnes Paquet
## Modified Sept, 14, 2004
## source("~/Projects/madman/Rpacks/arrayQuality/R/qualityPlots.R")



##############################
## rm.na is in package marray


########################
## [Internal Function]
## Set control colors
########################

setCtlCol <- function(mdata)
  {
    colcode <- c(2:(length(unique(as.integer(maControls(mdata))))+1))
    tmp <- levels(maControls(mdata));  ctlcode <- c()
    if("Positive" %in% tmp) ctlcode <- c(ctlcode, "Positive")
    if("probes" %in% tmp) ctlcode <- c(ctlcode, "probes")
    if("Negative" %in% tmp) ctlcode <- c(ctlcode, "Negative")
    if("Empty" %in% tmp) ctlcode <- c(ctlcode, "Empty")
    names(colcode) <- c(ctlcode, setdiff(tmp, ctlcode))
    return(colcode)
  }

########################
## [Internal Function]
## Gene Pix reweighting
########################
gpFlagWt <- function(x)
{
  res <- rep(NA, length(x))
  res[x < -60] <- -100
  res[x == -50] <- 0
  res[x > -50] <- 100
  return(as.matrix(res))
}

##########################################################
## [Internal Function]
## Dot plot:  not really for general use [Internal Function]
##########################################################
qpDotPlots <- function(mdata,  xvar="maA", id="ID", colcode=1, nrep=3, pch=18, ...)
  {
    newdata <- eval(call(xvar, mdata))
    xlim <- range(newdata, na.rm=TRUE)
    Cindex <- maControls(mdata) != "probes"
    #Ctl <- cbind(maInfo(maGnames(mdata)), maControls(mdata))
    ## combined control status and name

    ##Ctl <- cbind(maInfo(maGnames(mdata)), maControls(mdata), row.names=NULL)
    Ctl <- cbind(Index=c(1:length(maControls(mdata))),maInfo(maGnames(mdata)), maControls(mdata),
                 row.names=NULL)
    IDindex <- grep(id, colnames(Ctl))  ## Set ID columns
    y <- split(Ctl, Ctl[,ncol(Ctl)])  ## The last column of Ctl is the control status

    if(length(y[names(y) != "probes"]) != 0)  ## check that there exist control spots
      {
        ## There are control spots
        exty <- lapply(y[names(y) != "probes"], function(x){
          ext <- split(x, x[, IDindex])
          ##extid <- lapply(ext, function(xx){as.integer(row.names(xx))})
          extid <- lapply(ext,function(xx){as.integer(xx[,"Index"])})
          extid[lapply(extid, length) > nrep]
        })
        exty <- exty[lapply(exty, length) != 0]
        ylim <- c(1, sum(unlist(lapply(exty, length))))

        par(mar=c(4,7,3,2), cex=1)  ## A wide left side to allow for gene names
        plot(1,1, type="n", xlim=xlim, ylim=ylim, axes=FALSE, xlab=xvar, ylab="",...)
        ii <- 1
        for(i in 1:length(exty))
          for(j in 1:length(exty[[i]]))
            {
              ind <- exty[[i]][[j]]
              points(newdata[ind], rep(ii, length(newdata[ind])), pch=pch, col=colcode[names(exty)[i]])
              points(median(newdata[ind], na.rm=TRUE), ii, pch=18, col="black")
              ii <- ii + 1
            }
        axis(1)
        lab <- paste(unlist(lapply(exty, names)), " (n=",unlist(lapply(exty, lapply, length)), ") ", sep="")
        axis(2, at=1:ylim[2], labels=lab, las=2, cex.axis=0.6)
        box()
        
      } else
    {
         ## There are NO control spots
      plot(1, 1, axes=FALSE, xlab="", ylab="", type="n")
      text(1, 1, "No Control Genes")
      box()
    }
    return()
  }


##########################################################
## [Internal Function]
## Hexbin Plots
##########################################################

## This is the old function
## qpHexbin <-  function(mdata, main="", ...)
##{
##  par(mar=c(5,4,3,2))
##  y <- maM(mdata)
##  x <- maA(mdata)
##  nalim <- !is.na(x) & !is.na(y)
##  bin <- hexbin(x[nalim],y[nalim])
##  col <- BTY
##  maxcnt  <-  max(bin$cnt)
##  colorcut <-  seq(0, 1, length = min(17,maxcnt))
##
##  yrange <- c(min(maM(mdata), na.rm=TRUE), max(maM(mdata), na.rm=TRUE) + 1)
##  plot(bin$xbnds, bin$ybnds, type = "n", xlab="A", ylab="M", ylim=yrange, main=main)
##  hexagons(bin, colramp = col, colorcut = colorcut, maxcnt = maxcnt)

##  par(mar=c(2,1,2,1))
##  plot(seq(-0, 4, length=11),  -1:9, type="n", axes=FALSE, xlab="", ylab="")
##  hex.legend(legend=4, ysize=8, lcex=1, inner=1,  maxcnt = maxcnt,
##             colorcut= colorcut, colramp = col)
##}

## New version of qpHexbin from Paul Murrell
qpHexbin <- function (mdata, main = "", ...)
{
  y <- maM(mdata)
  x <- maA(mdata)
  nalim <- !is.na(x) & !is.na(y)
  bin <- hexbin(x[nalim], y[nalim])
  col <- BTY
  maxcnt <- max(bin@count)
  colorcut <- seq(0, 1, length = min(17, maxcnt))
  yrange <- c(min(maM(mdata), na.rm = TRUE), max(maM(mdata),
                                na.rm = TRUE) + 1)
  ## move to next traditional graphics plot region
  frame()
  ## Set up grid viewports that correspond to the
  ## current traditional figure region
  vps <- baseViewports()
  pushViewport(vps$inner, vps$figure)
  pushViewport(viewport(gp=gpar(cex=0.6)))
  ## draw a complete hexbin plot with legend
  plot(bin, xlab = "A", ylab = "M",
       ## ylim = yrange,
       main = main, colramp = col, colorcut = colorcut, maxcnt = maxcnt,
       legend = 1,
       lcex = 1,
       ## ysize = 8,
       ## inner = 1)
       newpage=FALSE)
  upViewport(3)
  ## move to next traditional graphics plot region
  ## i.e., skip over region that used to be used for hexbin legend
  frame()
}


##########################################################
## [Internal Function]
## MA-Plots with bad spots highlighted
##########################################################

qpMAPlots <-  function(mdata, addp=TRUE, main="", ...)
{
  opt <- list(...)
  par(mar=c(5,4,3,2), cex=0.6)
  y <- max(maM(mdata), na.rm=TRUE) + 2
  x <- min(maA(mdata), na.rm=TRUE)
  defs <- maDotsDefaults(opt, maDefaultPar(mdata, x="maA", y="maM", z="maPrintTip"))
  plot(mdata, lines.func=NULL, legend.func=NULL, col="gray",
       ylim=c(min(maM(mdata), na.rm=TRUE),y),  main=main) ## took xlim=c(0,16) out
  abline(h=0,col="blue",lwd=2.5, lty=2)
  legend.func <- do.call(maLegendLines, defs$def.legend)
  legend.func(x, y)
  ## HARD CODE red represents bad spots
  if(addp) points(mdata, subset = maW(mdata) < 0, col="red", pch=18, cex=0.6)
  par(mar=c(5,4,4,2) + 0.1)
}


##########################################################
## [Internal Function]
## Print-tip split loess plots
## Modified from Gordon's code
##########################################################

qpPTLoess <- function(mdata, span=0.4) {
  y <- maM(mdata)
  x <- maA(mdata)
  tmp <- coplot(y~x|factor(maGridCol(mdata)) * factor(maNgr(mdata) - maGridRow(mdata) +1),
                xlab=c("A","Tip Column"),  ylab=c("M","Tip Row"),  pch=".",
                span=span,  show.given=FALSE,  panel=panel.smooth)
  invisible()
}


##########################################################
## [Internal Function]
## Spatial plots
##########################################################

qpImage <- function(mdata, xvar="maM", main="", overlay=NULL, ...)
{
  par(mar=c(2,3,5,2))
  #convert marrayRaw into marrayNorm, needed for assignment
  if(xvar == "maM")
    {
      tmpNorm <- mdata
      if(!is(mdata, "marrayNorm"))
        tmpNorm <- as(mdata, "marrayNorm")
      tmpNorm@maM <- as.matrix(rank(as.numeric(eval(call(xvar, mdata)))))
      tmp <- image(tmpNorm, xvar="maM", main=main, bar=FALSE, overlay=overlay, colorinfo = TRUE, ...)
    }
  else
    tmp <- image(mdata, xvar=xvar, main=main, bar=FALSE, zlim=c(0,16), overlay=overlay, colorinfo=TRUE, ...)
  par(mar=c(2,1, 5,4))
  maColorBar(tmp$x.bar, horizontal = FALSE, col = tmp$x.col,  main = "")
  par(mar=c(5,4,4,2) + 0.1) ## set back to default
}


##########################################################
## [Internal Function]
## Signal to Noise
##########################################################

qpS2N <- function(mdata, channel=c("red", "green"), colcode=1, ...)
  {

    if(channel == "red"){
      if(length(maRb(mdata))!=0)
        S2N <- as.vector(log(maRf(mdata),2) - log(maRb(mdata),2))
      else
        S2N <- as.vector(log(maRf(mdata),2))}

    if(channel == "green"){
      if(length(maGb(mdata))!=0)
        S2N <- as.vector(log(maGf(mdata),2) - log(maGb(mdata),2))
      else
        S2N <- as.vector(log(maGf(mdata),2))}

    lab <- paste("S2N : ","mean:", round(mean(rm.na(S2N)), 2)," : ", "var:", round(var(rm.na(S2N)), 2))
    hist(rm.na(S2N), main=lab, col=channel, nclass=50, freq=FALSE, ylim=c(0,1.1));

    if(length(maControls(mdata))!=0)
      {
        tmp <- split(S2N, maControls(mdata))
        bw <- sd(rm.na(S2N)/4)
        tmp2 <- lapply(tmp, function(x){density(rm.na(x), bw=bw)})
        for(i in 1:length(tmp2))
          lines(tmp2[[i]], lwd=2, col=colcode[names(tmp2)[i]])
        xrange <- range(rm.na(S2N))
        xcood <- xrange[1] + (xrange[2]-xrange[1]) * 0.7
        legend(xcood, 1, names(tmp), lty=1, lwd=2, col=colcode[names(tmp)], cex=0.8)
      }
  }


## mraw == marrayRaw object
## mrawheader == Heading information
maQualityPlots <-  function(mrawObj, headerInfo="",
                            save = TRUE,
                            dev = "png",  #set default to be png
                            col=NULL, badspotfunction=NULL,
                            controlId=c("ID", "Name"),
                            DEBUG=FALSE, ...)
{
  if (DEBUG) print("function starting")
  controlId <- controlId[1]

  #Convert RGList to mraw if needed

  if (setequal(class(mrawObj), "RGList"))
      {
        mrawTmp <- as(mrawObj, "marrayRaw")
        mrawObj <- mrawTmp
        rm(mrawTmp)
      }

  if(DEBUG) print(dim(mrawObj))
  for(i in 1:dim(mrawObj)[2])
    {
      mraw <- mrawObj[,i]
      opt <- list(...)

      ## re-evaluate W
      if (DEBUG) print("Re-evaluate Weight")
      if(missing(badspotfunction)||is.null(badspotfunction))
        {
          tmp <- do.call(gpFlagWt, list(mraw@maW))
          mraw@maW <- tmp 
        }
      else
        if(!is.null(badspotfunction))
          mraw@maW <- do.call(badspotfunction, list(mraw@maW))

      ## setting controls cols
      ifelse(missing(col), colcode<- setCtlCol(mraw) , colcode <- col)
      if(DEBUG) cat("check Control color code", colcode, "\n")

      ## Set up no backgroud data and normalization
      if (DEBUG) print("Set up data and normalization")
      nbgraw <- mraw;
      if(length(mraw@maGb) != 0)
        nbgraw@maGb <- nbgraw@maRb <- matrix(0,0,0)

      if (DEBUG) print("Reading normalization parameters")
      if (DEBUG) print(opt)
      defs <- list(norm="p")
      norm.defs <- maDotsMatch(maDotsDefaults(opt, defs), formals(args("maNorm")))

      if (DEBUG) cat("Using normalization method:  ", norm.defs$norm, "\n")

      mnorm <- do.call(maNorm, c(list(nbgraw), norm.defs))

      ## Set up output name
      if (DEBUG) print("Name the output file")
      tmp <- unlist(strsplit(colnames(mraw@maGf), "/"))
      tmp3 <- unlist(strsplit(tmp[length(tmp)], "\\."))
      tmp2 <-  sub("/", "", tmp3)

      if(length(tmp2) > 1)
        fstart <- paste(tmp2[-length(tmp2)], collapse=".")
      else
        fstart <- tmp2

      if (DEBUG) print(fstart)


  ###################
  ## Setting up output device
  ###################
      if (DEBUG) print("Name of output device")
      plotdef <- switch(dev,
                        "bmp" = list(dev=list(width=1600, height=1200, bg="white"), suffix="bmp"),
                        "jpeg" = list(dev=list(quality=100, width=1600, height=1200, bg="white"), suffix="jpeg"),
                        ##"postscript" = list(dev=list(paper="special", width=32.0, height=24.0, bg="white"), suffix="ps"),
                        "postscript" = list(dev=list( bg="white"), suffix="ps"),
                        "png" =  list(dev=list(width=1600, height=1200, bg="white"), suffix="png"),
                        list(dev=list(width=1600, height=1200,bg="white"), suffix="png"))
      if(!is.element(dev, c("bmp", "jpeg","png","postscript")))
              {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

      fname <- paste("diagPlot", fstart,  plotdef$suffix, sep=".")
      if (DEBUG) print(fname)
      plotdef <- c(plotdef, list(main=paste(fname, ": Qualitative Diagnostic Plots")))

      ###################
      ## Plot
      ###################
      ## Match args and calls function
      ## Start device and layout
      if(DEBUG) print("start layout")


      if(save)
#<<<<<<< .mine
        #do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=fname), plotdef$dev)), formals(args(dev))))
##      do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=fname), plotdef$dev)), formals(args(dev))))
#=======
        {
          if(plotdef$suffix != "ps")
            do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=fname), plotdef$dev)), formals(args(dev))))
          else
            do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=fname), plotdef$dev)), formals(args(dev))))
        }
#>>>>>>> .r11253
      
      ## Feb 23, 2005: JYH
      ## Modified width from 1.5 to 2 for the color bar.  This stops the error
      ## Figure margins too large when dev="postscript".  It was not a problem
      ## for any other dev setting. 
      
      ##      layout(matrix(c(14, 1,2,2, 14,0,3,3, 14,4,6,6, 14, 5, 7, 7, 14, 8, 10, 11,
      ##                      14, 9, 10, 11, 14, 12, 13, 13), 4, 7),
      ##             height=c(1, 10, 5, 5), width = c(11, 2, 5, 1.5 ,5, 1.5, 7))
      layout(matrix(c(14, 1,2,2, 14,0,3,3, 14,4,6,6, 14, 5, 7, 7, 14, 8, 10, 11,
                      14, 9, 10, 11, 14, 12, 13, 13), 4, 7),
             height=c(1, 10, 5, 5), width = c(11, 2, 5, 2 ,5, 2, 7))

      
      ## 1) Split MA-plot (Before Normalization)
      if(DEBUG) print("start 1")
      qpMAPlots(nbgraw, addp=TRUE, main="MA-Plot :: raw", ...)
      if(!is.null(opt$norm))
        {
          if(opt$norm == "p")
            addLines(nbgraw)
        }
      else
        addLines(nbgraw)

      ## 2) HEXbin MA-plot (After Normalization)
      if(DEBUG) print("start 2")
      qpHexbin(mnorm, main="MA-Plot :: Norm")

      ## 3 & 4) maM (Before Normalizaton)
      if(DEBUG) print("start 3, 4")
      qpImage(nbgraw, xvar="maM", main="Spatial: Rank(M-Raw)")

      ## 5 & 6) maM (After Normalization)
      if(DEBUG) print("start 5 & 6")
      ov.sub <- as.vector(maW(mnorm)) < 0
      qpImage(mnorm, xvar="maM", main="Spatial: Rank(M-Norm)", overlay=ov.sub)

      ## 7 & 8) maA
      if(DEBUG) print("start 7 & 8")
      qpImage(nbgraw, xvar="maA", main="Spatial: A")

      ## 9 & 10  Red and Green Signal to Noise (background corrected)
      if(DEBUG) print("start 9 & 10")
      qpS2N(mraw, channel="red", colcode=colcode)
      qpS2N(mraw, channel="green", colcode=colcode)

      ## 11 maM Dot plot
      if(DEBUG) print("start 11")
      if(length(maControls(mnorm))!=0)
        qpDotPlots(mnorm, xvar="maM", col=colcode,
                   main="Control normalized M", cex.main=0.8, id=controlId)
#      title(main= "Controls normalized M")

      ## 12 maM Dot plot
      if(DEBUG) print("start 12")
      if(length(maControls(mraw))!=0)
        qpDotPlots(mraw, xvar="maA", col=colcode, main="Control A", cex.main=0.8, id=controlId)
       #title(main= "Controls A")

      if(DEBUG) print("start 13")
      ## 13
      layout(1)
      par(mar=c(2,2,4,2))
      mtext(plotdef$main, line=3)
      mtext(headerInfo, line=2, cex = 0.7)
      mtext(paste("Call:", maNormCall(mnorm)[3]), line=1, cex = 0.7)

      ## Finishing
      if(DEBUG) cat("Done...")
      if (save == TRUE) {
        cat(paste("save as", fname, "\n"))
        dev.off()
      }
    }
}

#################################################
## Separate control plot functions for HEEBO set
## Author: Agnes
## Date modified: 06/27/2006
#################################################

## source("C:/MyDoc/Projects/Statistics/MEEBO/Ash/Oct31/qpMeeboPlotsOct31_limma.R")
## source("C:/MyDoc/Projects/Statistics/MEEBO/01Nov5/qpMeeboPlotsOct31_limma.R")
## load("C:/MyDoc/Projects/Statistics/MEEBO/Ash/MEEBOctrl.RData")

## Mismatch controls plots
## A values vs. %mismatch
## Includes anchored MM, distributed MM and PM
## Work on marrayNorm object containing only 1 array
## Need to set up rownames of A and M to oligo id before
## rownames(mnorm$M) <- rownames(maA(mnorm)) <-
##   make.names(as.vector(maGeneTable(mraw)[,"ID"]),unique=TRUE)

qpMisMatchPlot <- function(mnorm, ctrllist=HEEBOctrl, organism=c("Mm","Hs"),DEBUG=FALSE)
  {
    if (DEBUG) print("In qpMisMatchPlot")
    
    ##Set up y-axis range (samef or all plots)
    yrange <- c(2,16)  ##!!!Needs to be think about more

    if(missing(organism))
      organism <- "Mm"
    else
      organism <- organism[1]
    if(DEBUG) print(paste("Organism selected = ", organism,sep=""))
    print(organism)
    
    if(organism == "Mm")
      {
        coreCollection <- grep("mMC", rownames(mnorm$A)) #24958
        print(length(coreCollection))
        if(length(coreCollection) == 0)
              stop("Organism argument doesn't match your array")
        ##negCtl <- grep("mCN", rownames(raw$G))
      }
    else
      {
        if(organism == "Hs")
          {
            coreCollection <- grep("hHC", rownames(mnorm$A))
            print(length(coreCollection))
                if (length(coreCollection) == 0)
                  {
                    stop("Organism argument doesn't match your array")
                  }
           ## negCtl <- grep("hCN", rownames(raw$G))
          }
        else
          stop("The input organism does not match MEEBO or HEEBO oligo sets")
      }
    
   ## coreCollectionA <- (log.na(raw$G,2)[coreCollection,1] +  log.na(raw$R,2)[coreCollection,1])/2

    
    ## Get all "normal"  genes for axis set-up
    ##hHC <- grep("hHC", rownames(mnorm$A)) #24958
    
    #HEEBO set includes 10 unique PM and coresponding MM
    if (DEBUG) print(paste("length ctrllist = ", length(ctrllist), sep=""))
    
    for(i in 1:10)
      {
        if (DEBUG) print(i)
        
        ## Takes control matrix corresponding to PM i
        ctl <- ctrllist[[i]]
        pmid <- as.character(ctl[1, "uniqID"])

        ## Get plot title
        if(nchar(as.character(ctl[1, "Symbol"]))>2)
          mtitle <- as.character(ctl[1, "Symbol"])
        else
          mtitle <- as.character(ctl[1, "Probe_Name"])

        idremove <- function(x,y)
          {
            return(is.na(x) | is.na(y) | !is.finite(x) | !is.finite(y))
          }

         ## Plot results for Anchored MM present on array ONLY
        
        hma <- grep("a", as.character(ctl[,"MismatchType"]))
        goodHma <- hma[!is.na(match(ctl[hma,"uniqID"],rownames(mnorm$A)))]
        
        plot(as.numeric(ctl[goodHma,"NumberMM"])*100/70,
             mnorm$A[as.vector(ctl[goodHma, "uniqID"]),1],
             col="blue",pch=18,
             xlab="% MisMatch", ylab="A value",
             ylim=yrange, xlim=c(-10,105),
             main=mtitle, yaxt="n", axes=FALSE
             )

        ## Plot results for Distributed MM
        hmd <- grep("d", as.character(ctl[,"MismatchType"]))
        goodHmd <- hmd[!is.na(match(ctl[hmd,"uniqID"],rownames(mnorm$A)))]
        points(as.numeric(ctl[goodHmd,"NumberMM"])*100/70,
              mnorm$A[as.vector(ctl[goodHmd, "uniqID"]),1],
              col="green",pch=18)

        ## Boxplot for WT
        wt <- grep("WT", as.character(ctl[,"MismatchType"]))
        goodwt <- wt[!is.na(match(ctl[wt,"uniqID"],rownames(mnorm$A)))]
        boxplot(mnorm$A[as.vector(ctl[goodwt, "uniqID"]),1], width=15, boxwex=3,
                at=-10, add=TRUE, na.rm=TRUE, axes=FALSE, col="red", outline=FALSE,
                medpch=NA, medlty="blank")
      
        ## Boxplot for negative controls
#        boxplot(mnorm$A[ctrllist[[11]],1], width=10, boxwex=1.2,outline=FALSE,
#                at=100, add=TRUE, na.rm=TRUE, axes=FALSE, col="red",
#                medpch=NA, medlty="blank")
        goodNC <- ctrllist[[11]][!is.na(match(ctrllist[[11]],rownames(mnorm$A)))]
        boxplot(mnorm$A[goodNC,1],outline=FALSE,width=15, boxwex=3,
                at=100, add=TRUE, na.rm=TRUE, axes=FALSE, col="red",
                medpch=NA, medlty="blank")
        
 
        goodid <- !idremove(as.numeric(ctl[goodHma,"NumberMM"])*100/70,
                            mnorm$A[as.vector(ctl[goodHma, "uniqID"]),1])      
        lines(lowess(as.numeric(ctl[goodHma,"NumberMM"])[goodid]*100/70,
                     mnorm$A[as.vector(ctl[goodHma, "uniqID"]),1][goodid]), col="blue")

        goodid <- !idremove(as.numeric(ctl[goodHmd,"NumberMM"])*100/70,
                            mnorm$A[as.vector(ctl[goodHmd, "uniqID"]),1])      
        lines(lowess(as.numeric(ctl[goodHmd,"NumberMM"])[goodid]*100/70,
                     mnorm$A[as.vector(ctl[goodHmd, "uniqID"]),1][goodid]), col="green")
        
        abline(h=median(mnorm$A[goodNC,1], na.rm=TRUE),
               col="black", lty=2)
        abline(h=quantile(mnorm$A[coreCollection,1],c(0.25,0.75,0.9),na.rm=TRUE), col="red", lty=2)
        axis(1, at=seq(0,90,10), label=seq(0,90,10))
        axis(1, at=c(-10,100), label=c("WT", "Neg ctl"))
        axis(2, at=seq(yrange[1], yrange[2],2), las=2)
        axis(4, at=quantile(mnorm$A[coreCollection,1], c(0.25,0.75,0.9,1), na.rm=TRUE),
             label=c(0.25,0.75,0.9,1), las= 2)
        box()
      }
    ##Plot legend in 11th plot
    if(DEBUG) print("Plotting legend")
    plot(1:10,1:10,axes=FALSE,xlab="",ylab="",type="n")
    leg.txt <- c("Anchored MM", "Distributed MM",
                 "Median neg. ctl", "% A")
    legend(1,9,leg.txt, col=c("blue", "green", "black", "red"),
           lty=c(1,1,2,2),lwd=3,bty="n")
  }


## Binding Energy boxplot
## Create bins for histogram in BEbin

## Remove controls with low signal:
## set limit to be 75% of negative controls?

## Last element of MEEBOctrl contains Neg Ctrl ids
## One array at a time!!
## Work on marrayNorm object containing only 1 array
## Need to set up rownames of A and M to oligo id before
## Same, but using linear R+G instead of A

BEbin.linear<- function(mraw, ctrllist, DEBUG=FALSE)
  {
    ## take first slide only
    if(dim(mraw)[2]>1)
      mraw <- mraw[,1]

    Anc <- c()
    Dist <- c()
    WT <- c()
    Rc <- mraw$R
    Rc[Rc < 0] <- 0
    Gc <- mraw$G
    Gc[Gc < 0] <- 0

    Int <- mraw$R +mraw$G
    rownames(Int) <- mraw$genes[,"ID"]

    Alim <- quantile(Int, 0.75, na.rm=TRUE)
 
    if (DEBUG) print(paste("Alim = ", Alim, sep=""))
          
    for(i in 1:(length(ctrllist)-1))
      {
        ctlmat <- ctrllist[[i]]
        hma <- grep("a", as.character(ctlmat[,"MismatchType"]))
        hma <- hma[!is.na(match(ctlmat[hma,"uniqID"],rownames(Int)))]
        hmd <- grep("d", as.character(ctlmat[,"MismatchType"]))
        hmd <- hmd[!is.na(match(ctlmat[hmd,"uniqID"],rownames(Int)))]
        wt <- grep("WT", as.character(ctlmat[,"MismatchType"]))
        wt <- wt[!is.na(match(ctlmat[wt,"uniqID"],rownames(Int)))]
        wtInt <- Int[as.vector(ctlmat[wt,"uniqID"]),]

        ##Normalization : divide by median A for WT
        ##normFactor <- median(mnorm$A[as.vector(ctlmat[wt,"uniqID"]),1], na.rm=TRUE)
        normFactor <- median(as.numeric(wtInt), na.rm=TRUE)
        if (DEBUG) print(paste("Normfactor = ", normFactor,sep=""))

        if( normFactor > Alim)
          {            
            Anc <- rbind(Anc,
                         cbind(Int[as.vector(ctlmat[hma,"uniqID"]),1]/normFactor,
                               round(as.numeric(ctlmat[hma, "BE_PerfectMatch"])/5)*5))
            Dist <- rbind(Dist,
                          cbind(Int[as.vector(ctlmat[hmd,"uniqID"]),1]/normFactor,
                                round(as.numeric(ctlmat[hmd, "BE_PerfectMatch"])/5)*5))
            WT <- rbind(WT,
                        cbind(Int[as.vector(ctlmat[wt,"uniqID"]),1]/normFactor,
                              round(as.numeric(ctlmat[wt, "BE_PerfectMatch"])/5)*5))
          }
      }
    return(list(hma=Anc, hmd=Dist, WT=WT)) 
  }

## Wrapper function
qpBEplot.linear <- function(mraw, ctrllist=MEEBOctrl,DEBUG=FALSE)
  {
    test <- BEbin.linear(mraw=mraw, ctrllist=ctrllist, DEBUG=DEBUG)
    tmp <- split(test$WT[,1], -test$WT[,2]+2)
    tmp2 <- split(test$hma[,1], -test$hma[,2])
    tmp3 <- split(test$hmd[,1], -test$hmd[,2]+1)

    yrange <- range(c(test$WT[,1], test$hma[,1], test$hmd[,1]), na.rm=TRUE)
    plot(seq(-50,120,1),seq(-50,120,1),
         ylim=yrange,
         type="n", axes=FALSE,
         xlab="Binding energy", ylab="Normalized signal intensity",
         main=paste("Normalized A vs. Binding Energy",
           colnames(mraw$R), sep=" "))
    
    boxplot(tmp, add=TRUE, at=as.numeric(names(tmp)),
            col="red",axes=FALSE, outline=FALSE)
    boxplot(tmp2, add=TRUE, at=as.numeric(names(tmp2)),
            col="blue", axes=FALSE, outline=FALSE)
    boxplot(tmp3, add=TRUE, at=as.numeric(names(tmp3)),
            col="green", axes=FALSE, outline=FALSE)
    abline(h=1, lty=2)
    points(names(tmp),lapply(tmp, median, na.rm=TRUE), pch=15, cex=0.8)
    points(names(tmp2),lapply(tmp2, median, na.rm=TRUE), pch=15, cex=0.8)
    points(names(tmp3),lapply(tmp3, median, na.rm=TRUE), pch=15, cex=0.8)
    lines(lowess(-test$hma[,2], test$hma[,1]), col="blue", lwd=2)
    lines(lowess(-test$hmd[,2]+1, test$hmd[,1]), col="darkgreen", lwd=2)
    
    axis(1, at=seq(-50,120,10), label=seq(50,-120,-10))
    axis(2, las=2)
    box()
    legend(-50, yrange[2], c("Wild-Type", "Anchored", "Distributed", "Median"),
           col=c("red", "blue", "green", "black"), pch=15)
  }


## 3' distance plost (tiling controls)
## 11 controls stored in tilingres object (MEEBOTiling.RData)
## Work on marrayRaw object
## Need to assign oligoIds to rownames for maRf and maGf
## rownames(maRf(raw)) <- rownames(maGf(raw)) <-
##   make.names(as.vector(maGeneTable(raw)[,"ID"]),unique=TRUE)

qpTiling <- function(raw, tilingres=MEEBOtilingres, DEBUG=FALSE, organism=c("Mm", "Hs"))
  {

    if(DEBUG) print("In qpTiling")
    ##Set up y-axis range (samef or all plots)
    ##yrange <- c(2,16)  ##!!!Needs to be think about more
    if(missing(organism))
      organism <- "Mm"
    else
      organism <- organism[1]
    if(DEBUG) print(paste("Organism selected = ", organism,sep=""))

    if(organism == "Mm")
      {
        coreCollection <- grep("mMC", rownames(raw$G)) #24958
        if(length(coreCollection) == 0)
              stop("Organism argument doesn't match your array")
        negCtl <- grep("mCN", rownames(raw$G))
      }
    else
      {
        if(organism == "Hs")
          {
            coreCollection <- grep("hHC", rownames(raw$G))
            
                if (length(coreCollection) == 0)
                  {
                    stop("Organism argument doesn't match your array")
                  }
            negCtl <- grep("hCN", rownames(raw$G))
          }
        else
          stop("The input organism does not match MEEBO or HEEBO oligo sets")
      }
    
    coreCollectionA <- (log.na(raw$G,2)[coreCollection,1] +  log.na(raw$R,2)[coreCollection,1])/2
    AnegCt <- (log.na(raw$G,2)[negCtl,1] +  log.na(raw$R,2)[negCtl,1])/2

    for(i in 1:11)
      {
        tilingInfo <- tilingres[[i]]
        spotIds <- !is.na(match(names(tilingInfo),rownames(raw$G)))
        ##r<-log(ifelse(r>0, r, NA),2)
        Gf <- log.na(raw$G,2)[names(tilingInfo)[spotIds],1]
        Rf <- log.na(raw$R,2)[names(tilingInfo)[spotIds],1]
        distance <- tilingInfo[spotIds]
        
        plot(-as.numeric(distance), Gf,col="darkgreen",pch=18,
             xlab="3' distance", ylab="Log Intensity",
             main=names(tilingres[i]), ylim=c(2, 16),
             yaxt="n", axes=FALSE)
        points(-as.numeric(distance), Rf,col="red",pch=18)
        
        abline(h=median(AnegCt, na.rm=TRUE),
               col="black", lty=2,lwd=2)
        
        axis(1, at=unique(sort(-as.numeric(distance))),
             label=rev(unique(sort(as.numeric(distance)))))
        ##axis(4, at=quantile(mMC, seq(0.5,1, 0.1), na.rm=TRUE),
                                        ##label=seq(0.5,1,0.1), las= 2)
        axis(2, at=seq(2,16,2), las=2) ##to fix, only on left side
        box()
        
        idremove <- function(x,y)
          {
            return(is.na(x) | is.na(y) | !is.finite(x) | !is.finite(y))
          }
        
        goodid <- !idremove(-as.numeric(distance), Gf)
        lines(lowess(-as.numeric(distance)[goodid], Gf[goodid]),
              col="darkgreen", lwd=2)
        goodid <- !idremove(-as.numeric(distance), Rf)
        lines(lowess(-as.numeric(distance)[goodid], Rf[goodid]),
              col="red", lwd=2)
      }
    plot(-as.numeric(distance), Gf,  ylim=c(4, 16),type="n",
         yaxt="n", axes=FALSE, ylab="", xlab="")
    legend(min(-as.numeric(distance)), 12, c("Cy5", "Cy3", "Median Neg ctl"),
           col=c("red", "darkgreen", "black"), lty=c(1,1,2), lwd=3,
           bty="n")
   }


## Example of use for the QC plots

#png("BEplots.png", width=2500, height=600)
#par(mfrow=c(1,5))
#for(i in 1:5)
#  {
#    print(i)
    #plot(1:5, 1:5)
#    qpBEplot(mnorm[,i], MEEBOctrl=MEEBOctrl,DEBUG=FALSE)
#  }
#dev.off()

#png("Tiling_meebo-P1-258.png", width=800, height=2000)
#par(mfcol=c(3,4), cex=1.5, cex.axis=1.2, mar=c(4,4,3,3))
#qpTiling(mraw[,5], tilingres=tilingres)
#dev.off()

##png("Tiling_meebo-14MmnoF5.png", width=1500, height=1200)
##par(mfcol=c(3,4), cex=1.3, cex.axis=1, mar=c(3,4,3,2),oma=c(2,2,4,2))
##qpTiling(RGsub, tilingres=tilingres)
##dev.off()

#png("MMplots.png", width=1200, height=2000)
#par(mfrow=c(5,2), cex=1.5, cex.axis=0.8, mar=c(3,5,3,5))
#qpMMPlots()
#dev.off()

qpHexbin <- function (mdata, main = "", ...)
{
  y <- maM(mdata)
  x <- maA(mdata)
  nalim <- !is.na(x) & !is.na(y)
  bin <- hexbin(x[nalim], y[nalim])
  col <- BTY
  maxcnt <- max(bin@count)
##  print(maxcnt)
  colorcut <- seq(0, 1, length = min(17, maxcnt))
  yrange <- c(min(maM(mdata), na.rm = TRUE), max(maM(mdata),
                                na.rm = TRUE) + 1)
  ## move to next traditional graphics plot region
  frame()
  ## Set up grid viewports that correspond to the
  ## current traditional figure region
  vps <- baseViewports()
  pushViewport(vps$inner, vps$figure)
  pushViewport(viewport(gp=gpar(cex=0.6)))
  ## draw a complete hexbin plot with legend
  plot(bin, xlab = "A", ylab = "M",
       ## ylim = yrange,
       main = main, colramp = col, colorcut = colorcut, maxcnt = maxcnt,
       legend = 1,
       lcex = 1,
       ## ysize = 8,
       ## inner = 1)
       newpage=FALSE)
  upViewport(3)
  ## move to next traditional graphics plot region
  ## i.e., skip over region that used to be used for hexbin legend
  frame()
}

qpHexbin <- function (mdata, main = "", ...)
{
  par(mar = c(5, 4, 3, 2))
  y <- maM(mdata)
  x <- maA(mdata)
  nalim <- !is.na(x) & !is.na(y)
  bin <- hexbin(x[nalim], y[nalim])
  col <- BTY
  maxcnt <- max(bin@count)
  ##print(maxcnt)
  colorcut <- seq(0, 1, length = min(17, maxcnt))
  yrange <- c(min(maM(mdata), na.rm = TRUE), max(maM(mdata),
                                na.rm = TRUE) + 1)
  print("1")
  plot(bin@xbnds, bin@ybnds, type = "n", xlab = "A", ylab = "M",
       ylim = yrange, main = main)
  ## set up grid viewports that correspond to the current
  ## traditional plot region
  vps <- baseViewports()
  print("2")
  pushViewport(vps$inner, vps$figure, vps$plot)
  print("3")
  grid.hexagons(bin, colramp = col, colorcut = colorcut, maxcnt = maxcnt)
  print("4")
  upViewport(3)
  print("5")
  par(mar = c(2, 1, 2, 1))
  plot(seq(0, 4, length = 11), -1:9, type = "n", axes = FALSE,
       xlab = "", ylab = "")
  print("6")
  ## set up grid viewports that correspond to the current
  ## traditional plot region
  vps <- baseViewports()
  print("7")
  pushViewport(vps$inner, vps$figure, vps$plot)
  print("9")
  grid.hexlegend(legend = 4, ysize = 8, lcex = 0.8, inner = 1, maxcnt = maxcnt,
                 colorcut = colorcut, colramp = col)
  print("10")
  upViewport(3)
}

#####################################################
## Set of function written to estimate
## quality of microarray slides
##
## Author: Agnes Paquet
## Modified: 04/16/2004
##           09/21/2004
##           09/24/2004
##           02/02/2005
##           04/10/2005 
## source("~/Projects/madman/Rpacks/arrayQuality/R/readGPR.R")
## source("~/Projects/madman/Rpacks/arrayQuality/R/gpQuality.R")

###################################################
## READ .gpr file, returns a list of measures
## extracted from the .gpr file
###################################################

## No background substraction
## No normalization
## Suppose that fnames is a .gpr file.
## Returns a list of data needed for quality
## Combines read.marrayRaw, maQualityMain, gpTools
## One slide only!!!

## returns a list of vector containing info from grp file column
readGPR <- function (fnames = NULL, path= ".", DEBUG=FALSE, skip = 0,
                     sep ="\t", quote= "\"", controlId="ID",...)
  {
    if (DEBUG) print("Starting readGPR")
    if (DEBUG) print(path)
    # Test if input data is OK
    if (is.null(path))
      path <- "."
 
    if (missing(fnames) | is.null(fnames)) 
      fnames <- dir(path, pattern = ".*\\.gpr$")
    fullfnames <- file.path(path, fnames)
    f <- fullfnames[1]
    opt <- list(...)
    
    # Search in the gpr file where are the colums starting
    y <- readLines(fullfnames[1], n = 100)
    skip <- grep("F635 Median", y)[1] - 1
    if (DEBUG) print(skip)
  
    # Read data in       
    name <- id <- c()
    block <- column <- row <- c()
    Date <- PMTR <- PMTG <- normMethod <- normCoef <- c()
    Gfmedian <- Gfmean <- Gfsd <- c()
    Gbmedian <- Gbmean <- Gbsd <- c()
    Rfmedian <- Rfmean <- Rfsd <- c()
    Rbmedian <- Rbmean <- Rbsd <- c()
    Gfsat <- Rfsat <- c()
    spotDia <- spotFArea <- spotBArea <- c()
    Flags <- c()
    
    tmp <- readLines(f, n = 40)
    if (length(grep("DateTime", tmp)) != 0) 
      Date <- gsub("\"", "",
                   strsplit(tmp[grep("DateTime", tmp)], split = "=")[[1]][2])
    if (length(grep("PMT", tmp)) != 0) {
      PMT <- gsub("\"", "",
                   strsplit(tmp[grep("PMT", tmp)], split = "=")[[1]][2])
      PMT <- strsplit(PMT, split="\t")
      PMTR <- PMT[[1]][1]
      PMTG <- PMT[[1]][2]

    }
    if (length(grep("NormalizationMethod", tmp)) != 0)
      normMethod <- gsub("\"", "",
                         strsplit(tmp[grep("NormalizationMethod",tmp)],
                                  split = "=")[[1]][2])
    if (length(grep("NormalizationFactor", tmp)) != 0)
      {
        normCoef1 <- gsub("\"", "",
                          strsplit(tmp[grep("NormalizationFactor", tmp)],
                                   split = "=")[[1]][2])
        normCoef <- gsub("\t", ",", normCoef1)
      }

    if (DEBUG) print(paste("Reading", f))
    h <- strsplit(readLines(f, n = skip + 1), split = sep)
    h <- as.list(unlist(h[[length(h)]]))
    names(h) <- gsub("\"", "", unlist(h))
    dat <- scan(f, quiet = TRUE, what = h, sep = sep, skip = skip + 
                1, quote = quote, ...)

    block <- cbind(block, as.numeric(dat[["Block"]]))
    column <- cbind(column, as.numeric(dat[["Column"]]))
    row <- cbind(row, as.numeric(dat[["Row"]]))
    name <- cbind(name, dat[["Name"]])
    ## was    id <- cbind(id, dat[["ID"]])
    ## does not work if identifier not =IS
    id <- cbind(id, dat[[controlId]])
    
    Gfmedian <- cbind(Gfmedian, as.numeric(dat[["F532 Median"]]))
    Gfmean <- cbind(Gfmean, as.numeric(dat[["F532 Mean"]]))        
    Gfsd <- cbind(Gfsd, as.numeric(dat[["F532 SD"]]))
    Gbmedian <- cbind(Gbmedian, as.numeric(dat[["B532 Median"]]))
    Gbmean <- cbind(Gbmean, as.numeric(dat[["B532 Mean"]]))        
    Gbsd <- cbind(Gbsd, as.numeric(dat[["B532 SD"]]))
    Rfmedian <- cbind(Rfmedian, as.numeric(dat[["F635 Median"]]))
    Rfmean <- cbind(Rfmean, as.numeric(dat[["F635 Mean"]]))
    Rfsd <- cbind(Rfsd, as.numeric(dat[["F635 SD"]]))
    Rbmedian <- cbind(Rbmedian, as.numeric(dat[["B635 Median"]]))
    Rbmean <- cbind(Rbmean, as.numeric(dat[["B635 Mean"]]))
    Rbsd <- cbind(Rbsd, as.numeric(dat[["B635 SD"]]))        
    Gfsat <- cbind(Gfsat, as.numeric(dat[["F532 % Sat."]]))
    Rfsat <- cbind(Rfsat, as.numeric(dat[["F635 % Sat."]]))
    spotDia <- cbind(spotDia, as.numeric(dat[["Dia."]]))
    spotFArea <- cbind(spotFArea, as.numeric(dat[["F Pixels"]]))
    spotBArea <- cbind(spotBArea, as.numeric(dat[["B Pixels"]]))
    Flags <- cbind(Flags,as.numeric(dat[["Flags"]]))

    gprData <- list(File = fnames[1], Date = Date, PmtR = PMTR, PmtG = PMTG,
                    Normalization = normMethod, NormCoefficent = normCoef,
                    Name = name, ID = id,
                    Block = block, Column = column, Row = row,
                    GfMedian = Gfmedian, GfMean = Gfmean, GfSD = Gfsd,
                    GbMedian = Gbmedian, GbMean = Gbmean, GbSD = Gbsd,
                    RfMedian = Rfmedian, RfMean = Rfmean, RfSD = Rfsd,
                    RbMedian = Rbmedian, RbMean = Rbmean, RbSD = Rbsd,
                    GfSaturation = Gfsat, RfSaturation = Rfsat,
                    SpotDiameter = spotDia, spotArea = spotFArea,
                    bgArea = spotBArea, Flags = Flags)
    
    # Result
    return(gprData)
  }


###################################################
## Given a gpr files
## Computes needed statistics to assess quality
###################################################

## Takes all .gpr file into acccount
## Plot quality boxplot and diagnostic plots
## creates html report
## if output: writes quality and normalized data to file
## return quality measure and marrayRaw object in a list

#############
## Example:
## test <- gpQuality(path="C:/Mydoc/Projects/quality/DemoA/", resdir="QualPlot")

## Reference = output from globalQuality
## Must be run on the same gpr files
gpQuality <- function(fnames = NULL, path = ".",
                      organism=c("Mm", "Hs"),
                      compBoxplot = TRUE,
                      reference=NULL,
                      controlMatrix = controlCode,
                      controlId = c("ID", "Name"),
                      output=FALSE,
                      resdir=".",
                      dev="png", #set default to be png
                      val=c("maM", "maA"),
                      DEBUG = FALSE,...)
{

    print("Starting gpQuality...")
    
    # Check input arguments
    if (missing(path) | is.null(path))
      path <- "."
    
    if (missing(fnames) | is.null(fnames))
      fnames <- dir(path, pattern = ".*\\.gpr$")

    organism <- organism[1]
    controlId <- controlId[1]
    if (DEBUG) print(controlId)

    opt <- list(...)

    if (DEBUG) print(controlMatrix)
        
 ###################
 ## Setting up output device

    if (DEBUG) print("Name of output device")
    plotdef <- switch(dev,
                      "bmp" = list(dev=list(width=800, height=600, bg="white"), suffix="bmp"),
                      "jpeg" = list(dev=list(quality=100, width=800, height=600, bg="white"), suffix="jpeg"),
                      "postscript" = list(dev=list( bg="white"), suffix="ps"),
                      #"postscript" = list(dev=list(paper="special", width=8, height=6, bg="white"), suffix="ps"),
                      "png" =  list(dev=list(width=800, height=600, bg="white"), suffix="png"),
                      list(dev=list(width=800, height=600,bg="white"), suffix="png"))
    
    if(!is.element(dev, c("bmp", "jpeg","png","postscript")))
      {
        print("Format error, format will be set to PNG")
        dev = "png"
      }

    if (DEBUG) print(paste("compBoxplot = ",compBoxplot, sep=""))

    
    ##############################################################
    ## COMPBOXPLOT = TRUE
    ##############################################################
    
    if (compBoxplot)
      {
    
        # Prepares results
        quality <- c()
        #tmp <- c()
        QCp <- c()
        Dp <- c()
        
        curdir <- getwd()
        if (!file.exists(resdir))
          dir.create(resdir)
        if (DEBUG) print(getwd())
        
        #Allocation of matrix for marrayraw object

        if(DEBUG) print(path)
        if(DEBUG) print(resdir)

        #f <- fnames[1]
        #gp <- readGPR(fnames=f, path=path)
        #nrow <- length(gp[["RfMedian"]])
        #ncol <- length(fnames)
        #if(DEBUG) print("creating layout")
        #mlayout <- maCompLayout(as.matrix(cbind(gp[["Block"]],
        #                                        gp[["Row"]], gp[["Column"]])))
        #tmp <- new("marrayInfo", maInfo=data.frame(gp[["Name"]],gp[["ID"]]))
        #mlayout@maControls <- as.factor(maGenControls(tmp, controlcode = controlMatrix,
         #                                             id=controlId)) 
        #rm(f, gp)

        ## Read layout and allocation of matrix for marrayRaw

        if (DEBUG) print("call read.Galfile")
        galf <- read.Galfile(galfile = fnames[1], path = path)
        mlayout <- galf$layout

        gnames <- galf$gnames
        mlayout@maControls <- as.factor(maGenControls(gnames, controlcode = controlMatrix,
                                                      id=controlId))
        galOrder <- galf$neworder
        nb <- filenames <- c()
        numrow <- maNspots(galf$layout)
        numcol <- length(fnames)
        Rf <- Gf <- Rb <- Gb <- weight <- matrix(0,nrow=numrow, ncol=numcol)
        ##numrow <- nrow(gp@maRf)
        ##numcol <- length(fnames)
        
        ## Call to slideQuality for each gpr file

        for (i in 1:length(fnames))
          {
            if (DEBUG) print("In the loop ")
            f <- fnames[i]
            gp <- readGPR(fnames = f, path=path)
            restmp <- slideQuality(gp, controlMatrix = controlMatrix, DEBUG=DEBUG)
            
            ###start plot
            Gf[,i] <- gp[["GfMedian"]]; Gb[,i] <-gp[["GbMedian"]] 
            Rf[,i] <- gp[["RfMedian"]]; Rb[,i] <- gp[["RbMedian"]]
            weight[,i] <- gp[["Flags"]]
            filenames <- c(filenames, gp[["File"]])
        
            #qualBoxplot
            setwd(resdir)
            plotname <- paste("qualPlot",unlist(strsplit(f, ".gpr")), plotdef$suffix,sep=".")
            plotdef <- c(plotdef, list(main=paste(f, ": Quantitative Diagnostic Plots")))

            if(plotdef$suffix != "ps")
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)), formals(args(dev))))
            else
              do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(file=plotname), plotdef$dev)), formals(args(dev))))

            
            #do.call(dev, maDotsMatch(maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)),
             #                        formals(args(dev))))

            ## was: do.call(dev, maDotsDefaults(opt, c(list(filename=plotname), plotdef$dev)))
            par(mar=c(3,14,2,6))
            nbtmp <- qualBoxplot(restmp, reference=reference, organism=organism)
            dev.off()
            setwd(curdir)

            #nb = matrix ncol=2, nrow=length(fnames)
            nb <- rbind(nb, nbtmp)
            QCp <- c(QCp, plotname)
            if (DEBUG) print("End of plot")
            if (DEBUG) print(paste("save as ",plotname))
            if (DEBUG) print("Binding results")
            quality <- cbind(quality, restmp[,1])
            meas <- rownames(restmp)
          }
        
        print("Comparative plots done")
        
        #Create marrayRaw
        colnames(Gf) <- colnames(Gb) <- colnames(Rf) <- colnames(Rb) <- colnames(weight) <- filenames
        if (DEBUG) print("building mraw")

        ## Warning: all vectors must be reordered according to
        mraw <- new("marrayRaw", maRf=Rf, maGf=Gf, maRb=Rb,
                    maGb=Gb, maNotes="", maLayout=mlayout,
                    maW=weight, maGnames=gnames)

        mraw <- mraw[galf$neworder,]
        mraw@maLayout@maSub <- mlayout@maSub
 
        #maQualityPlots
        setwd(resdir)
        print("Starting maQualityPlots")
        
        defs <- list(norm="p")
        norm.defs <- maDotsDefaults(opt, defs)     
        
        do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId, DEBUG=DEBUG, dev=dev),
                                    norm.defs))
        
        #get diagnostic plots names
        tmpname <- sub(".gpr", "",colnames(mraw@maGf))
        pn <- paste("diagPlot", tmpname, sep=".")

        dirfiles <- dir(".")
        
        for(i in 1:length(pn))
          Dp <- c(Dp, dirfiles[grep(pn[i], dirfiles)[1]])
        
        if (DEBUG) print("After for loop")
        if (DEBUG) print(nb)
        quality2HTML(fnames=fnames,path=resdir, QCplot=QCp, DiagPlot=Dp,nbBelow=nb)
        
        colnames(quality) <- fnames
        rownames(quality) <- meas
        
        print("gpQuality done")
        
       ####### Results
        
        if (output)
          {
            print("Printing results to file")
            write.table(quality, "quality.txt",sep="\t", col.names=NA)
            #colnames(mraw@maGnames@maInfo) <- c("Name", "ID")
            do.call(outputNormData, c(list(mraw=mraw), norm.defs, val=val))
          }

        setwd(curdir)
        return(list(mraw=mraw, quality=quality))
      }

   else {
          
      ##############################################################
      ## COMPBOXPLOT = FALSE
      ##############################################################

     if (DEBUG) print("In compBoxplot=FALSE")
     curdir <- getwd()
     if (!file.exists(resdir))
       dir.create(resdir)
     if (DEBUG) print(getwd())

     ## JYH: (June 27, 2005) Fix: Adding layout information so that
     ## controlCode can be set correctly when COMPBOXPLOT = FALSE
     galf <- read.Galfile(galfile = fnames[1], path = path)
     mlayout <- galf$layout
     gnames <- galf$gnames
     if (DEBUG) print(controlId)

     mlayout@maControls <- as.factor(maGenControls(gnames, controlcode = controlMatrix,
                                                   id=controlId))

     mraw <- read.GenePix(fnames, path, layout=mlayout)
     colnames(maGf(mraw)) <- fnames
     print("Starting maQualityPlots")
     defs <- list(norm="p")
     norm.defs <- maDotsDefaults(opt, defs)     
     
     setwd(resdir)
     do.call(maQualityPlots, c(list(mrawObj=mraw, controlId=controlId, DEBUG=DEBUG, dev=dev),
                                 norm.defs))

     if (output)
       {
         print("Printing results to file")
         #colnames(mraw@maGnames@maInfo) <- c("Name", "ID")
         do.call(outputNormData, c(list(mraw=mraw, val=val), norm.defs))
       }

     setwd(curdir)
     return(list(mraw=mraw))     
   }
  }

arrayControls <- function (data = NULL, SFGHControlcode = controlCode, id = "ID") 
{
  if(missing(data)) stop("Missing input data")

  gId <- as.vector(data[[id]])
  
  Control <- rep("probes", length(gId))
  for (i in 1:nrow(SFGHControlcode)) {
    position <- grep(as.vector(SFGHControlcode[i, "Pattern"]), 
                     gId)
    if (length(position) > 0) 
      Control[position] <- as.vector(SFGHControlcode[i, "Name"])
    }
  
  return(Control)
}

arrayReplicates <- function(data=NULL, id="ID", cut=5)
  {
    if(missing(data)) stop("Missing input data")
    if(!is.element(id, names(data)))
      stop("Data type is not correct")

    geneList <- as.vector(data[[id]])
    y <- table(geneList)
    Replicates <- names(y)[y > cut]
    return(Replicates)
  }



replicatesAvariance <- function(slide = NULL, id="ID")
  {
    if(missing(slide)) stop("Missing input data")
    gprData <- readGPR(slide)

    if(!is.element(id, names(gprData)))
      stop("Can't identify the genes names")
    
    Replicates <- arrayReplicates(gprData)
    gId <- gprData[["ID"]]
    
    index <- c()
    for(r in Replicates){
      for(i in 1:length(gId)){
        if (r == gId[i]) index <- c(index,i)
      }
    }

    if(length(index) == 0)
      repA <- NA
    else
      {
        repA <- (log.na(gprData[["RfMedian"]][index],2) +
                 log.na(gprData[["GfMedian"]][index],2))/2
      }
    varRepA <- var(repA, na.rm=TRUE)
    return(varRepA)
  }

###################################################### 
## Print-run QC
## March 12, 2004
##
## Two functions: PRvQCHyb
####################################################### 

## PRvQCHyb(fnames="9mm.186.gpr", prname="9Mm", DEBUG=TRUE)
## PRvQCHyb(path="9Mm", prname="9Mm", DEBUG=TRUE)


PRvQCHyb<-  function(fnames,
                     path=".",
                     dev = "png",  #set default to be png
                     DEBUG=FALSE,
                     prargs=NULL,
                     samepr=TRUE,
                     prname="xMm",
                     save = TRUE,
                     col,
                     ...) 
{
  
  ## Setting defaults
  print("Starting PRvQCHyb")
  
  defs <- list(fill = TRUE, quote = "\"", check.names=FALSE, as.is=TRUE,
               name.Gf = "F532 Median", name.Rf = "F635 Median",
               name.Gb="B532 Median", name.Rb="B635 Median",
               name.W="Flags", comment.char="", sep="\t", header=TRUE)
  opt <- list(...)
  args <- maDotsMatch(opt, defs)

  ## Getting File names
 if (DEBUG) print("Getting File Names")
  if (missing(fnames))
    fnames <- file.path(path, dir(path, pattern = "*\\.gpr$"))
  
  if (is.null(path)) {
    fnames <- fnames
    resdir <- paste(prname, "PRQC", sep="")
  }else {
    resdir <- file.path(path, paste(prname,"PRQC", sep=""))    
  }

  if(!file.exists(resdir))
    dir.create(resdir)
  if(DEBUG) print(resdir)
  
  for(f in fnames)
    {
      
      ###################
      ## Set up output name
      if (DEBUG) print("Name the output file")
      tmp <- unlist(strsplit(f, "/"))
      fnopath <- tmp[length(tmp)]  ## filename without the path attached
      tmp <- unlist(strsplit(fnopath, "\\."))
      fstart <- paste(tmp[-length(tmp)], collapse=".")

      ###################
      ## marrayRaw
      read.args <- maDotsMatch(args, formals(args("read.GenePix")))
      read.args$fnames <- f
      #read.args$path <- NULL
      read.args$path <- path
      if(DEBUG) cat("Reading", read.args$file, "...\n")
      bgraw <- do.call(read.GenePix, read.args)
      GInfo <- maGeneTable(bgraw)
      mraw <- bgraw; mraw@maGb <- mraw@maRb <- matrix(0,0,0)

      ###################
      ## load existing DE genes

      if(length(grep("Mm",  prname)) == 1)
        {
          data(MmDEGenes)
          DEGenes <- MmDEGenes;
        }
             
      else
        {
          if(length(grep("Hs",  prname)) == 1)
            {
              stop("No previous DE results for Human yet")
              #data(HsDEGenes)
              #DEGenes <- HsDEGenes;
            }
          else
            {
              stop("No previous DE results for Human yet")
              print("No previous DE results")
            }

        }

      
      ###################
      ## Setting up output device
      ###################
      if (DEBUG) print("Name of output device")
      plotdef <- switch(dev,
                        "bmp" = list(dev=list(width=1600, height=1000, bg="white"), suffix="bmp"),
                        "jpeg" = list(dev=list(quality=100, width=1600, height=1000, bg="white"), suffix="jpeg"),
                        "jpg" =  list(dev=list(quality=100, width=1600, height=1000, bg="white"), suffix="jpeg"),
                        "postscript" = list(dev=list(paper="special", width=16, height=10, bg="white"), suffix="ps"),
                        "png" =  list(dev=list(width=1600, height=1000, bg="white"), suffix="png"),
                        list(dev=list(width=1600, height=1000,bg="white"), suffix="png"))
      if(!is.element(dev, c("bmp", "jpeg","png","postscript","jpg")))
        print("Format error, format will be set to PNG")

      ## Set up output name
      fname <- paste("QCHyb", fstart,  plotdef$suffix, sep=".")
      plotdef <- c(plotdef, list(main=paste(fname, ": QC Hyb")))
            
      ###################
      ## Plot
      if(DEBUG) print("start layout")
      if(save)  do.call(dev, maDotsDefaults(opt, c(list(filename=file.path(resdir, fname)), plotdef$dev)) ) 

 
      ## Layout 
      layout(matrix(c(11,1,1,2,11,3,3,7,11,4,4,7,11,5,5,7,11,6,6,7,11,8,9,10), 4, 6),
             height=c(0.5, 2, 2, 4), width = c(12,5.5,2,5.5,2,7)) 

      ## setting controls cols
      ifelse(missing(col), colcode<- setCtlCol(mraw) , colcode <- col)
      
      ##colcode <- unique(as.integer(maControls(mraw))+1)
      ##ctlcode <- levels(maControls(mraw))
      ##names(colcode) <- ctlcode

      ## 1) MA-plot (Before Normalization)
      if(DEBUG) print("start 1")
      qpMAPlots(mraw, addp=TRUE, main="MAPlot: Raw M", ...)
      addLines(mraw)

      ## 2) Boxplot split by Print-tip
      if(DEBUG) print("start 2")
      par(mar=c(5,5,5,3))
      boxplot(mraw, yvar="maM", ylab="M values", main="Boxplot: Raw M by print-tip groups")

      ## 3 & 4) maM (No Normalization)
      if(DEBUG) print("start 3 & 4")
      qpImage(mraw, xvar="maM", main="Spatial plot: Rank(M-raw)")

      ## 5 & 6) maA 
      if(DEBUG) print("start 5 & 6")
      qpImage(mraw, xvar="maA", main="Spatial plot: A")

      ## 7) Compare old and new
      if(DEBUG) print("start 7")
      par(mar=c(5,5,5,3))
      mnorm <- maNorm(mraw)
      rownames(mnorm@maM) <- as.vector(maGeneTable(mnorm)[,"ID"])
      slope <- lm(mnorm@maM[rownames(DEGenes),1] ~ DEGenes[,"Median"])$coef[2]
      if(slope > 0){
        plot(DEGenes[,"Median"],mnorm@maM[rownames(DEGenes),1],xlab="Past average M", ylab="current array", type="n",
             main="Known DE genes: comparison to past average M")
        text(DEGenes[,"Median"],mnorm@maM[rownames(DEGenes),1],DEGenes[,"Ref"])
        }
      else{
        plot(DEGenes[,"Median"],-mnorm@maM[rownames(DEGenes),1],xlab="Past average M", ylab="current array", type="n",
             main="Known DE genes: comparison to past average M")
        text(DEGenes[,"Median"],-mnorm@maM[rownames(DEGenes),1],DEGenes[,"Ref"])
      }
      abline(0, 1, lty=2, lwd=3, col="red")
      abline(-1, 1, lty=2, lwd=3, col="blue")
      abline(1, 1, lty=2, lwd=3, col="blue")

      ## 8 & 9  Red and Green Signal to Noise (background corrected)
      if(DEBUG) print("start 9 & 10")
      qpS2N(bgraw, channel="red", colcode=colcode)
      qpS2N(bgraw, channel="green", colcode=colcode)

      ## 10 Dot Plot
      if(DEBUG) print("start 10")
      if(length(maControls(mraw))!=0)
        qpDotPlots(mraw, x="maA",  col=colcode)
         
      
      ## 11 Title
      if(DEBUG) print("start 11")
      layout(1)
      par(mar=c(2,2,4,2))
      mtext(plotdef$main, line=3)
      mrawheader <- readGPRHeader(file.path(path,f))
      mtext(paste("Date: ",  mrawheader$DateTime, " :: PMT", mrawheader$PMTGain), line=2, cex=0.8)
      if(DEBUG) print("Done...")
      
      ## Finishing
      if (save == TRUE) {
        cat(paste("save as", fname, "\n"))
        dev.off()
      }
    } ## end for
}## end function

###################################################### 
## Print-run QC
## Feb 26, 2004
##
## Two functions: PRv9mers
##              : PRvQCHyb
####################################################### 

## TOUSE:
# PRv9mers(fnames="9Mm.28.gpr", path="09Mm", prname="09Mm", DEBUG=TRUE)
# PRv9mers(path="08Hs", prname="08Hs", DEBUG=TRUE)

PRv9mers<-  function(fnames,
                    path=".",
                    dev = "png",  #set default to be png
                    DEBUG=FALSE,
                    prargs=NULL,
                    samepr=TRUE,
                    prname="xMm",
                    save = TRUE,
                    ...) 
{
  ## Setting defaults
  defs <- list(fill = TRUE, name.Gf="F532 Median", name.Gb="B532 Median", check.names=FALSE, as.is=TRUE,
               comment.char="", sep="\t", header=TRUE, quote = "\"", name.W="Flags")
  opt <- list(...)
  Args <- maDotsMatch(opt, defs)
  estpMatrix <- signalMatrix<- c()
  
  if (DEBUG) print("Getting File Names")
  ## Getting File names
  if (missing(fnames))
#    fnames <- file.path(path, dir(path, pattern = ".*\\.gpr$"))
    fnames <- dir(path, pattern = ".*\\.gpr$")
  

  if (is.null(path)) {
    fnames <- fnames
    resdir <- paste(prname, "PRQC", sep="")
  }else {
    #fnames <- file.path(path, fnames)
    #print(fnames)
    resdir <- file.path(path, paste(prname,"PRQC", sep=""))
  }

  if(!file.exists(resdir))
    dir.create(resdir)
  
  print(resdir)
  
  for(f in fnames)
    {

      print("in the loop")
      print(f)
      ## Set up output name
      if (DEBUG) print("Name the output file")
      tmp <- unlist(strsplit(f, "/"))
      fnopath <- tmp[length(tmp)]  ## filename without the path attached
      tmp <- unlist(strsplit(fnopath, "\\."))
      fstart <- paste(tmp[-length(tmp)], collapse=".")

      ## Set up arguments
      read.args <- maDotsMatch(Args, formals(args("read.GenePix")))
      read.args$fnames <- f
      read.args$path <- read.args$name.Rf <- read.args$name.Rb <- c()

      read.args$path <- path
      read.args <- c(read.args, list(name.Rf=NULL, name.Rb=NULL))
      
      if(DEBUG) cat("Reading", read.args$fnames, "...\n")
      mraw <- do.call(read.GenePix, read.args) 
      GInfo <- maGeneTable(mraw)

      ###################
      ## EmAlgorithm split
      if(DEBUG) print("start EM")
      fg <- log(mraw@maGf, 2)
      cutoff <- quantile(log(mraw@maGb,2), prob=0.8, na.rm=TRUE)
      estp <- EMSplit(vect=fg, cutoff=cutoff)
      if(samepr){
        signalMatrix <- cbind(signalMatrix, fg)
        estpMatrix <- cbind(estpMatrix, estp)}
      else
        {
          tmp <- GInfo[,"ID"]
          write.table(cbind(tmp, estp), file=file.path(resdir, paste(fnopath, ".9mer.xls", sep="")),
                      row.names=FALSE, sep="\t")
        }
      if(DEBUG) print("Done...EM")

      
      ###################
      ## Setting up output device
      ###################
      if (DEBUG) print("Name of output device")
      plotdef <- switch(dev,
                        "bmp" = list(dev=list(width=1200, height=1000, bg="white"), suffix="bmp"),
                        "jpeg" = list(dev=list(quality=100, width=1200, height=1000, bg="white"), suffix="jpeg"),
                        "jpg" =  list(dev=list(quality=100, width=1200, height=1000, bg="white"), suffix="jpeg"),
                        "postscript" = list(dev=list(paper="special", width=12, height=10, bg="white"), suffix="ps"),
                        "png" =  list(dev=list(width=1200, height=1000, bg="white"), suffix="png"),
                        list(dev=list(width=1200, height=1000,bg="white"), suffix="png"))
      if(!is.element(dev, c("bmp", "jpeg","png","postscript","jpg")))
        print("Format error, format will be set to PNG")

      ## Names
      fname <- paste("P9mers", fstart,  plotdef$suffix, sep=".")
      plotdef <- c(plotdef, list(main=paste(fname, ": 9 mers QC")))
      
      ###################
      ## Plot
      if(DEBUG) print("start layout")
      if(save)  do.call(dev, maDotsDefaults(opt, c(list(filename=file.path(resdir, fname)), plotdef$dev)) ) 

      ## Layout 
      layout(matrix(c(7,1,2,7,3,3,7,4,4,7,5,6), 3, 4), height=c(0.5, 4, 4), width = c(12, 5, 2, 7))
        
      ## 1) Boxplot split by Plate
      if(DEBUG) print("start 1")
      par(mar=c(5, 4, 4, 2) + 0.1)
      boxplot(mraw, xvar="maPlate", yvar="maLG", ylab="Log Intensity", las=2,
              main="Boxplot by plates")
      
      ## 2) Boxplot split by Print-tip
      if(DEBUG) print("start 2")
      boxplot(mraw, yvar="maLG", ylab="Log Intensity",
              main="Boxplot by print-tip groups")
      

      ## 3,4) maGf
      if(DEBUG) print("start 3/4")
      qpImage(mraw, xvar="maLG", main="Spatial: Log Green")
      
      ## 5) Density Plot
      if(DEBUG) print("start 5")
      xrange <- range(log(as.numeric(c(mraw@maGf, mraw@maGb)),2), na.rm=TRUE, finite=TRUE)
      tmp <- log(mraw@maGf,2)  ## Make sure there is no inf 
      Gfden <- density(tmp[is.finite(tmp)]) ## doesn't handle inf values
      plot(Gfden, main="Foreground", xlim=xrange)
      if(!is.null(GInfo[,"ID"]))  ## make sure you there is a column name "ID"
        {
          yrange <- range(Gfden$y, na.rm=TRUE, finite=TRUE)
          tmpid <- maControls(mraw)
          tmp <- estp[tmpid == "probes"]
          text(xrange[2] - 3, yrange[2] - 0.1, paste("Probes Only", length(tmp)), cex=1.5,col=4)
          text(xrange[2] - 3, max(0, yrange[2] - 0.2), paste("Missing: ", sum(tmp <= 0.5)), cex=1.5, col=6)
        }
      
      ## 6) Density Plot Background
      if(DEBUG) print("start 6")
      tmp <- log(mraw@maGb,2)
      plot(density(tmp[is.finite(tmp)]), main="Background", xlim=xrange)
    
      ## 7) Title
      if(DEBUG) print("start 7")
      layout(1)
      par(mar=c(2,2,4,2))
      mtext(plotdef$main, line=3)
      mrawheader <- readGPRHeader(file.path(path,f))
      mtext(paste("Date: ",  mrawheader$DateTime, " :: PMT", mrawheader$PMTGain), line=2, cex=0.8)
    
      
      if(DEBUG) print("Done...")
      ## Finishing
      if (save == TRUE) {
        cat(paste("save as", fname, "\n"))
        dev.off()
      }
    } ## end for

  if(samepr)
    {
      cat("Extracting missing probes \n")
      colnames(estpMatrix) <- fnames
      estpMatrixAve <- apply(estpMatrix, 1, median, na.rm=TRUE)
      signalMatrixAve <- apply(signalMatrix, 1, median, na.rm=TRUE)
      if(!is.null(GInfo[,"ID"]))
         {
           Info <- cbind(ID=GInfo[,"ID"], Name=GInfo[,"Name"],
                         estpMatrix, average=round(estpMatrixAve,3), Signal = signalMatrixAve)
           write.table(Info,file=file.path(resdir, paste(prname,"9mer.xls", sep="")), row.names=FALSE, sep="\t")
           tmpid <- maControls(mraw)
           write.table(Info[((tmpid == "probes") & (estpMatrixAve <=0.5)),],
                       file=file.path(resdir, paste(prname,"Missing.xls", sep="")), row.names=FALSE, sep="\t")
           write(as.vector(Info[,1]),
                 file=file.path(resdir, paste(prname, "QuickList.txt", sep="")), ncolumns=1)
         }
      cat("Done \n")
    }
}## end function


EMSplit <- function(vect, cutoff=9)
  {
    require(mclust)
    meV.na <- function(data, cutoff=9)
      {
        index <- (is.na(data) | !is.finite(data))
        y <- data[!index]
        testy <- me("V", y, cbind(y < cutoff, y > cutoff))
        p <- rep(NA, length(data))
        p[!index] <- testy$z[,2]
        return(p)
      }
    res <- meV.na(vect, cutoff=cutoff)
    return(res)
  }

\name{PRvQCHyb}
\alias{PRvQCHyb}

\title{Print run Quality version Quality Control Hybridization}
\description{
    Qualitative diagnostic plots looking at print-run quality.  This
  component examine the QC hybridizations.
}

\usage{
PRvQCHyb(fnames, path=".", dev = "png", DEBUG=FALSE, prargs=NULL, samepr=TRUE, prname="xMm", save = TRUE, col,...)
}

\arguments{
  \item{fnames}{A "character" string naming the input files.}
  \item{path}{a character string representing the data directory. By
    default this is set to the current working directory (".").}
  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only.}
  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  \item{prargs}{A list with 4 components: Block, Row, Column and
    ncolumns. See Details for more information.}
  \item{samepr}{If 'TRUE', we assume everything in the directory are
    from the same print-run.}
  \item{prname}{A "character" string giving the name of the print-run.}
  \item{save}{If `TRUE', the figures will be saved to files.}
  \item{col}{color code for different control samples.}
  \item{\dots}{additional arguments.}
}

\details{
  The argument "prargs" is used to calculate the layout information
  about a print-run.  Components Block, Row and Columns denote the
  column names from the input data representing the print-tip location.
  The component "ncolumns" is an integer representing the number of
  print-tip columns in the data.  If the arguement is set to NULL,
  the the following default will be used.  list(Block="Block",
  Row="Row", Column="Column", ncolumns=4)
}

\value{
  Files of diagnostic plots.
}

\author{Jean Yee Hwa Yang}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
PRvQCHyb(fnames="9Mm137.gpr", path=datadir, prname="9Mm")
}
\keyword{hplot}% at least one, from doc/KEYWORDS

\name{maQualityPlots}
\alias{maQualityPlots}

\title{Qualitative diagnostic plot for general hybridization}

\description{
  This function generates diagnostic plots for a qualitative assessment of
  slide quality.  
}

\usage{
maQualityPlots(mrawObj, headerInfo = "", save = TRUE, dev = "png", col=NULL,
badspotfunction=NULL, controlId = c("ID", "Name"), DEBUG = FALSE, ...)
}

\arguments{
  \item{mrawObj}{\code{marrayRaw}  or \code{RGList} object representing
    the slides to be tested.}

  \item{headerInfo}{Text to be used as header in the diagnostic plot.}

  \item{save}{Logical. If 'TRUE', the plot is saved to a file.}

  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only. By default, dev is set
    to "png".}

  \item{col}{Vector of colors to use to describe different
    categories of spots.}

  \item{badspotfunction}{Function to use for bad spots on the array.}

  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls (or provides the name of the probes).}

  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  
  \item{\dots}{additional arguments}
}

\author{Jean Yang}

\examples{
# Example uses swirl dataset...

}

\keyword{hplot}

\name{heeboQualityPlots}
\alias{heeboQualityPlots}

\title{Qualitative diagnostic plot for general hybridization, specific
  to HEEBO set.}

\description{
  This function generates diagnostic plots for a qualitative assessment of
  slide quality.  
}
\usage{
heeboQualityPlots(mrawObj, headerInfo = "", save = TRUE, dev = "png",
col = NULL, badspotfunction = NULL, controlId = c("ID", "Name"), seqId =
"SeqID", organism = "Hs", DEBUG = FALSE, ...)
}

\arguments{
  \item{mrawObj}{\code{marrayRaw}  or \code{RGList} object representing
    the slides to be tested.}

  \item{headerInfo}{Text to be used as header in the diagnostic plot.}

  \item{save}{Logical. If 'TRUE', the plot is saved to a file.}

  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only. By default, dev is set
    to "png".}

  \item{col}{Vector of colors to use to describe different
    categories of spots.}

  \item{badspotfunction}{Function to use for bad spots on the array.}

  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls (or provides the name of the probes).}

  \item{seqId}{A "character" string naming the column of the MEEBO
    annotation to use to retrieve replicated sequences.}

  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Hs". It is used to retrieve the corresponding Oligo set annotations.}
  
  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  
  \item{\dots}{additional arguments}
}

\details{
The right panels of the diagnostic plot contain boxplots of the various
controls in the set, like positive or negative controls, as set in the
marrayRaw of RGlist object. Replicated controls are recognized based on
their HEEBO sequence id.
}

\author{Agnes Paquet}

\seealso{\code{\link{heeboQuality}}, \code{\link{gpQuality}},
  \code{\link{maQualityPlots}},\code{\link{HeeboSpotTypes}},
  \code{\link{controlCodeHeebo}}}

\examples{
if (interactive())
{
require(HEEBOdata)
datadir <- system.file("Heebo", package="HEEBOdata")
gal <- readGAL("hoc.gal", path=datadir)
RG <-
read.maimages(files=c("63421.gpr"), path=datadir, source="genepix.median",other.columns="Flags")
RG$genes <- gal
RG$printer <- getLayout(RG$genes)
RG$genes$Status <- controlStatus(HeeboSpotTypes,RG,verbose=TRUE)
rownames(RG$R) <- rownames(RG$G) <- RG$genes[,"ID"]
heeboQualityPlots(RG)
}
}
\keyword{hplot}

\name{readGPR}
\alias{readGPR}

\title{Reading GenePix gpr file}

\description{This component reads a GenePix file (.gpr) and returns
  columns used for quality control.
}

\usage{
readGPR(fnames = NULL, path= ".", DEBUG=FALSE, skip = 0, sep ="\t",
quote="\"", controlId="ID",...)
}

\arguments{
  \item{fnames}{A "character" string naming the input file.}
  
  \item{path}{a "character" string representing the data directory.  By
    default this is set to the current working directory (".").}
  
  \item{DEBUG}{If 'TRUE', debug statements are printed.}

  \item{skip}{Number of lines to skip in the gpr files.}

  \item{sep}{A "character" string defining the type of separation for
    the columns in the gpr files.}

  \item{quote}{A "character" string defining the type of quote in the
    gpr files.}
  
  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls.}
  
  \item{\dots}{additional arguments.}
}

\value{A list of vectors containing information extracted from the
  GenePix file}

\author{Agnes Paquet}

\seealso{
  \code{\link{slideQuality}}, \code{\link{gpQuality}}, \code{\link{globalQuality}}
}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
gprData <- readGPR(fnames="9Mm137.gpr", path=datadir)
}

\keyword{programming}

\name{qualBoxplot}
\alias{qualBoxplot}

\title{Comparative boxplot for general hybridization Quality Control}

\description{This functions allows you to graphically compare your slide
  quality measures to results obtained for a database of 'good quality'
  slides.}

\usage{
qualBoxplot(arrayQuality = NULL, reference = NULL, organism = c("Mm", "Hs"), DEBUG=FALSE,...)
}

\arguments{
  \item{arrayQuality}{Matrix of quality results from \code{slideQuality}
    or \code{globalQuality}.}

  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to "organism" will be used. See details for more information.}
  
  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference
    tables.}

  \item{DEBUG}{If 'TRUE', debug statements are printed.}

  \item{\dots}{additional arguments}

}

\details{
  You can use your own set of references created
  using \code{globalQuality} passed
  in the arguments "reference", or use
  the reference QC values stored in the datasets \code{MmReferenceDB}.}
 
\value{
  Returns a score vector containing, for each column in "arrayQuality",
  the number of quality measures below the range of "reference". The
  last element of the score vector is the total number of quality
  measures tested.
}

\author{Agnes Paquet}

\seealso{\code{\link{globalQuality}}, \code{\link{gpQuality}},
  \code{\link{spotQuality}}, \code{\link{agQuality}}}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if(interactive())
{
gprData <- readGPR(fnames="9Mm137.gpr", path=datadir)
arrayQuality <- slideQuality(gprData, organism="Mm")
qualBoxplot(arrayQuality)}
}

\keyword{hplot}

\name{MmDEGenes}
\alias{MmDEGenes}

\title{Known DE genes for Mouse quality hybridizations.}

\description{
  MmDEGenes contains information about probes known to be DE from
  previous quality hybridizations. It is used to verify reproducibility
  of print-runs.
}

\source{These data were provided by members of the UCSF Shared
  functional genomics core lab.}

\keyword{datasets}

\name{agQuality}
\alias{agQuality}
\alias{agcontrolCode}
\title{Diagnostic plots and comparative boxplots for general
  hybridization, Agilent format}
\description{
  This component provides qualitative diagnostic plots and quantitative
  measures for assessing general hybridization quality. All results are
  displayed in a HTML report. Agilent format only.}
\usage{
agQuality(fnames = NULL, path = ".", organism = c("Mm", "Hs"),
compBoxplot = TRUE, reference = NULL, controlMatrix = agcontrolCode,
controlId = c("ProbeName"), output = FALSE, resdir = ".", dev= "png", DEBUG = FALSE,...)
}
\arguments{ 
  \item{fnames}{A "character" string naming the input files.}
  \item{path}{A "character" string representing the data directory. By
    default this is set to the current working directory (".").}
  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference tables.}
  \item{compBoxplot}{Logical. If set to 'FALSE', only qualitative
    diagnostic plots will be plotted. agQuality ouput will be limited to
    a diagnostic plot by file and a marrayRaw object.}
  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to organism will be used. See details for more information.}
  \item{controlMatrix}{A character matrix of n by 2 columns. The first
    column contains a few regular expression of spotted probe sequences
    and the second column contains the corresponding control status. By
    default, is it set to be agcontrolCode.}
  \item{controlId}{Character string. Name of the column of the file used
    to define controls.}
  \item{output}{Logical. If 'TRUE', normalized M values corresponding to
    the input Agilent files and quality measures are printed to a file.}
  \item{resdir}{A "character" string representing the directory where
    the results will be saved. By default, this is set to the current
    working directory (".").}
  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only. By default, dev is set to "png".}
  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  \item{\dots}{Additional arguments.}
}
\details{
  agQuality returns 2 plots for each Agilent files passed as argument. The
  first one is a qualitative diagnostic plot, a quick visual way to assess
  slide quality. The second one is a comparative boxplot: each quality
  control measure is compared to the range obtained for a database of 'good'
  slides used as reference. You can use your own set of references created
  using \code{globalQuality} passed in the arguments "reference", or use
  the reference QC values stored in the datasets \code{MmReferenceDB} and
  \code{HsReferenceDB}. All results and quality scores are gathered in a
  HTML report. For more details about the QC measures and the plots,
  please refer to the online manual.
}
\value{
  A list of 2 elements:
  \item{mraw}{A marrayRaw object created from the input files.}
  \item{quality}{A matrix containing Quality Control measures for all slides.}
}
\author{Agnes Paquet}
\seealso{
  \code{\link{globalQuality}}, \code{\link{qualBoxplot}},
  \code{\link{readAgilent}}
}
\examples{ example}
\keyword{hplot}

\name{Internal functions}
\alias{arrayScal}
\alias{quality2HTML}
\alias{EMSplit}
\alias{qpS2N}
\alias{qpPTLoess}
\alias{qpImage}
\alias{qpHexbin}
\alias{gpFlagWt}
\alias{qpDotPlots}
\alias{qpMAPlots}
\alias{setCtlCol}
\alias{arrayControls}
\alias{replicatesAvariance}
\alias{arrayReplicates}
\alias{outputNormData}

\alias{qpS2Nmeebo}
\alias{qpDotPlotsMeebo}
\alias{qpDotPlotsMeebo2}
\alias{qpBoxplotMeebo}
\alias{controlCodeMeebo}
\alias{qpMisMatchPlot}
\alias{BEbin.linear}
\alias{qpBEplot.linear}
\alias{qpTiling}
\alias{getSpikeIds}
\alias{getSpikeIndex}
\alias{readAllSpikes}
\alias{Spike.MMplot}
\alias{Spike.Sensitivity}
\alias{Spike.Individual.Sensitivity}
\alias{Spike.MM.Scatter}
\alias{Spike.Cy5vsCy3}
\alias{MeeboSpotTypes}

\alias{qpDotPlotsEEBO}
\alias{qpS2Neebo}
\alias{controlCodeHeebo}
\alias{HeeboSpotTypes}


\title{Internal arrayQuality functions}
 
\description{Internal arrayQuality functions}
 
\details{These are not to be called by the user.}

\keyword{methods}

\name{qcScore}
\alias{qcScore}

\title{Quality Control score for general hybridization}

\description{This function returns, for each quality measure, the
  number of qc measures of the tested slides which are below the
  reference slides boundaries. 
}

\usage{qcScore(arrayQuality,reference)
}

\arguments{

  \item{arrayQuality}{Matrix of quality results from \code{slideQuality}
    or \code{globalQuality}.}

  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to organism will be used. See details for more
    information.}
  
}

\value{qcScore returns the number of qc measures under the
  lower limits of the reference values.}

\author{Agnes Paquet}

\keyword{programming}

\name{globalQuality}
\alias{globalQuality}

\title{Quality measures for general hybridization.}

\description{
  This function provides Quality Control measures for GenePix, Spot and
  Agilent format files. It is used to create a table of measures to be used as
  reference in gpQuality, spotQuality or agQuality.
}

\usage{
globalQuality(fnames = NULL, path = ".", organism = c("Mm", "Hs"),
output = FALSE, resdir = ".", DEBUG = FALSE, inputsource = "readGPR", controlId="ID",...)
}

\arguments{
  \item{fnames}{A "character" string naming the input files.}
  
  \item{path}{a "character" string representing the data directory.  By
    default this is set to the current working directory (".").}
  
  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference tables.}

  \item{output}{Logical. If 'TRUE', the quality measures are printed to
    a file.
  }

  \item{resdir}{A "character" string representing the directory where
    the results will be saved. By default, this is set to the current
    working directory ("."). }

  \item{DEBUG}{If 'TRUE', debug statements are printed.}

  \item{inputsource}{A "character" string providing the name of the function to
    use to read the input files. It should be inputsource = "readGPR"
    for GenePix format files, inputsource = "readSpot" for Spot files, or
    inputsource = "readAgilent" for Agilent format. By default,
    'inputsource' is set to "readGPR".}
  
  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls.}

  \item{\dots}{additional arguments}
}

\value{
  A matrix of Quality Control measures, each column representing a
  different input slide. 
}

\author{Agnes Paquet}

\seealso{\code{\link{gpQuality}}, \code{\link{slideQuality}},
  \code{\link{MmReferenceDB}}, \code{\link{readGPR}},
  \code{\link{readSpot}}, \code{\link{readAgilent}}
}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
reference <- globalQuality(fnames="9Mm137.gpr", path=datadir, organism="Mm")
}

\keyword{programming}

\name{heeboQuality}
\alias{heeboQuality}

\title{Diagnostics plots designed for HEEBO set controls}
\description{
  This component generates several exploratory plots customized to the
  various types of controls provided in the HEEBO set. All results are
  saved as an image. Tested on GenePix format only (06-29-2006). For
  more details about the plots, please refer to the HTML description.
}
\usage{
heeboQuality(fnames = NULL, path = ".", galfile = NULL, source
="genepix.median", other.columns =
c("Flags"), controlMatrix=HeeboSpotTypes,controlId = c("ID", "Name"), 
DOPING = TRUE, heeboSetQC = TRUE, SpotTypeFile = NULL, SpikeTypeFile =
NULL, cy3col = "Cy3_ng", cy5col = "Cy5_ng", id = "SeqID", namecol =
c("Symbol", "Name"), annot = NULL, bgMethod = "none", normMethod = "p",
diagnosticPlot = TRUE, output = TRUE, resdir = ".", dev = "png",
organism = "Hs", DEBUG = FALSE, ...)
}

%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fnames}{A "character" string naming the input files.}

  \item{path}{A "character" string representing the data directory.  By
    default this is set to the current working directory (".").}
  
  \item{galfile}{A "character" string naming the file descrining the
    layout of the array. If missing, meeboQuality will read the layour
    from the gpr file.}
  
  \item{source}{A "character" string specifing the image analysis program
    which produced the output files. See ?read.maimages in package limma
    for more details.}
  
  \item{other.columns}{See ?read.maimages in package limma for more
    details.}

  \item{controlMatrix}{A character matrix of n by 2 or more
    columns. One column should contain a few regular expression of
    spotted probe sequences and another column should contain the
    corresponding control status. By default, controlMatrix is set to
    HeeboSpotTypes.}
  
  \item{controlId}{Character string. Name of the column of the gpr
    file (or gal file) used to define controls.}
  
  \item{DOPING}{Logical. If 'TRUE', doping controls quality plots are
    generated.}
  
  \item{heeboSetQC}{Logical. If 'TRUE', mismatch and tiling controls
    quality plots are generated.}
  
  \item{SpotTypeFile}{A "character" string representing the name of the
    file containing spot type description for the array.}
  
  \item{SpikeTypeFile}{A "character" string representing the name of the
    file containing doping control information. See HTML description for
    more details.}
  
  \item{cy3col}{A "character" string representing the name of the column
    of the SpiketypeFile containing the quantity of each control spiked
    in the Cy3 channel.}
  
  \item{cy5col}{A "character" string representing the name of the column
    of the SpiketypeFile containing the quantity of each control spiked
    in the Cy5 channel.}
  
  \item{id}{A "character" string describing which column of the MEEBO
    annotation should be used to retrieve replicated oligos,
    e.g. "SeqID".}
  
  \item{namecol}{A "character" string describing which column of the
    SpiketypeFile should be used in the legend.}
  
  \item{annot}{A "character" string describing which R object should be
    used to look-up probes annotations. By default, it will be set to
    HEEBOset.}
  
  \item{bgMethod}{Character string specifying which background
    correction method to use. See ?backgroundCorrect in package limma
    for more details.}
  
  \item{normMethod}{Character string specifying which normalization
    method should be used. See ?normalizeWithinArrays in package limma
    for more details.}
  
  \item{diagnosticPlot}{Logical. If 'TRUE', a quality diagnostic plot
    will be generated.}

  \item{output}{Logical. If 'TRUE', normalized M values and A values
    corresponding to the input GenePix files and additionnal quality
    measures are printed to a file.}

  \item{resdir}{A "character" string representing the directory where
    the results will be saved. By default, this is set to the current
    working directory ("."). }
  
  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only. By default, dev is set
    to "png".}

  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Hs". It is used to retrieve the corresponding Oligo set
    annotations.}

  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  
  \item{\dots}{Additional arguments}
}

\details{
heeboQuality returns 3 types of quality control plots, specifically
designed for the various controls offered by the HEEBO set.
To assess the global performance of an hybridization, users can generate
a diagnostic plot summarizing several graphs and statictics by setting'diagnosticPlot=TRUE'. Then, the performance of the HEEBO set can beanalyzed by looking specifically at the mismatch and the tiling controls
('heeboSetQC=TRUE').

Finally, we are also providing several exploratory tools to assess the performance of the doping-controls
('DOPING=TRUE');these plots should be used only if a spike-in mixture
was added to the hybridization solution.
}

\value{
  heeboquality will produce several graphs, saved in an image file
  format. Please refer to the HTML description for more details. The
  function will also return the MAList object describing your tested slides.
  }

\author{Agnes Paquet}

\seealso{ \code{\link{heeboQualityPlots}}, \code{\link{gpQuality}},
  \code{\link{meeboQuality}}}

\examples{
if (interactive())
{
require(HEEBOdata)
datadir <- system.file("Heebo", package="HEEBOdata")
MA <-
heeboQuality(fnames="63421.gpr",galfile="hoc.gal",path=datadir,SpikeTypeFile="DCV2.0June06.txt",cy5col="Cy5_ng",cy3col="Cy3_ng",diagnosticPlot=TRUE, 
DOPING=TRUE, heeboSetQC=TRUE, namecol="Name", resdir="HeeboQC", DEBUG=TRUE)
}
}

\keyword{dynamic}

\name{scaleRefTable}
\alias{scaleRefTable}

\title{General hybridization quality scaling}

\description{This function helps you scale quality measures in order
  to compare them on the same plot. It is used on reference slides to
  create a look-up table, which will be used to scale other slides.}

\usage{scaleRefTable(reference=NULL, organism=c("Mm", "Hs"))}

\arguments{

  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference
    tables.}

  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to organism will be used.}
}

\value{A matrix containing median and iqr for each quality measure for
  tested slides.}

\author{Agnes Paquet}

\seealso{\code{\link{gpQuality}}, \code{\link{globalQuality}},
  \code{\link{qualBoxplot}}}

\keyword{programming}

\name{gpQuality}
\alias{gpQuality}

\title{Diagnostic plots and comparative boxplots for general hybridization}
 
\description{
  This component provides qualitative diagnostic plots and quantitative
  measures for assessing general hybridization quality. All results are
  displayed in a HTML report. GenePix format only.
}

\usage{

gpQuality(fnames = NULL, path = ".", organism = c("Mm", "Hs"),
compBoxplot = TRUE, reference = NULL, controlMatrix = controlCode,
controlId = c("ID", "Name"), output = FALSE, resdir = ".", dev= "png",
val=c("maM", "maA"),DEBUG = FALSE,...)
}

\arguments{
  
  \item{fnames}{A "character" string naming the input files.}
  
  \item{path}{A "character" string representing the data directory.  By
    default this is set to the current working directory (".").}
  
  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference
    tables.}

  \item{compBoxplot}{Logical. If set to 'FALSE', only qualitative
    diagnostic plots will be plotted. gpQuality ouput will be limited to
    a diagnostic plot by gpr file and a marrayRaw object.}

  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to organism will be used. See details for more information.}
  
 
  \item{controlMatrix}{A character matrix of n by 2 columns. The first
    column contains a few regular expression of spotted probe sequences
    and the second column contains the corresponding control status. By
    default, controlMatrix is set to controlCode.}

  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls.}

  \item{output}{Logical. If 'TRUE', normalized M values corresponding to
    the input GenePix files and quality measures are printed to a file.}

  \item{resdir}{A "character" string representing the directory where
    the results will be saved. By default, this is set to the current
    working directory ("."). }

  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only. By default, dev is set
    to "png".}

  \item{val}{A "character" string representing the slotNames to be
    written in the output file.}
  
  \item{DEBUG}{If 'TRUE', debug statements are printed.}

  \item{\dots}{additional arguments}
}


\details{
gpQuality returns 2 plots for each GenePix files passed as argument. The
first one is a qualitative diagnostic plot, a quick visual way to assess
slide quality. The second one is a comparative boxplot: each quality
control measure is compared to the range obtained for a database of 'good'
slides used as reference. You can use your own set of references created
using \code{globalQuality} and \code{qualRefTable} passed
in the arguments "reference" and "scalingTable", or use
the reference QC values stored in the datasets \code{MmReferenceDB} and
\code{MmScalingTable}. All results and quality scores are gathered in a
HTML report. For more details about the QC measures and the plots, please refer to the online manual.
}

\value{
  A list of 2 elements:

  \item{mraw}{A marrayRaw object created from the input files.}
  \item{quality}{A matrix containing Quality Control measures for all slides.}
}

\author{Agnes Paquet}

\seealso{\code{\link{globalQuality}}, \code{\link{qualBoxplot}},
  \code{\link{scaleRefTable}}
}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
results <- gpQuality(fnames="9Mm137.gpr", path=datadir, organism="Mm")
}

\keyword{hplot}

\name{slideQuality}
\alias{slideQuality}

\title{Quality Control statistics for general hybridization}

\description{This component uses data extracted from GenePix file to
  provide quality control statistics.}

\usage{
slideQuality(gprData = NULL, controlMatrix = controlCode, controlId = c("ID", "Name"), DEBUG = FALSE,...)
}

\arguments{
  \item{gprData}{A list of vector, results from \code{readGPR},
    containing information extracted from the gpr file.}

  \item{controlMatrix}{A matrix defining control status information.}

  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls.}

  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  
  \item{\dots}{additional arguments}
}

\value{
  A matrix of numbers.}

\author{Agnes Paquet}

\seealso{\code{\link{gpQuality}}, \code{\link{globalQuality}},
  \code{\link{readGPR}}
}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
{
gprdata <- readGPR(fnames="9Mm137.gpr", path=datadir)
results <- slideQuality(gprdata)
}
}

\keyword{programming}

\name{readSpot}
\alias{readSpot}

\title{Extraction of measures from Spot (.spot) files.}

\description{This component reads a Spot file (.spot) and returns
  columns used for quality control.
}

\usage{
readSpot(fnames = NULL, path= ".", galfile=NULL,DEBUG=FALSE, skip = 0, sep ="\t",quote="\"",controlId="ID", ...)
}

\arguments{
  \item{fnames}{A "character" string naming the input file.}
  
  \item{path}{a "character" string representing the data directory.  By
    default this is set to the current working directory (".").}

  \item{galfile}{ A "character" string naming the galfile associated
    with the input file. If galfile = NULL, readSpot will use the first
    .gal file found in the working directory.}
  
  \item{DEBUG}{If 'TRUE', debug statements are printed.}

  \item{skip}{Number of lines to skip in the gpr files.}

  \item{sep}{A "character" string defining the type of separation for
    the columns in the gpr files.}

  \item{quote}{A "character" string defining the type of quote in the
    gpr files.}
  
  \item{controlId}{Character string. Name of the column of the Spot
    file used to define controls.}

  \item{\dots}{additional arguments.}
}

\value{A list of vectors containing information extracted from the
  Agilent file}

\author{Agnes Paquet}

\seealso{
  \code{\link{slideQuality}}, \code{\link{agQuality}}, \code{\link{globalQuality}}
}


\keyword{programming}

\name{PRv9mers}
\alias{PRv9mers}

\title{Print Run Quality version 9mers}
\description{
  Qualitative diagnostic plots looking at print-run quality.  This
  component examine the 9mers hybridizations.
}
\usage{
PRv9mers(fnames, path = ".", dev = "png", DEBUG = FALSE, prargs = NULL, samepr = TRUE, prname = "xMm", save = TRUE, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{

  \item{fnames}{A "character" string naming the input files.}
  \item{path}{A "character" string representing the data directory. By
          default this is set to the current working directory (".").}
  \item{dev}{A "character" string naming the graphics device. This will
    take arguments "png", "jpeg" and "ps" only.}
  \item{DEBUG}{If 'TRUE', debug statements are printed.}
  \item{prargs}{A list with 4 components: Block, Row, Column and
    ncolumns. See Details for more information.}
  \item{samepr}{If 'TRUE', we assume everything in the directory are
    from the same print-run.}
  \item{prname}{A "character" string giving the name of the print-run.}
  \item{save}{If `TRUE', the figures will be saved to files.}
  \item{\dots}{additional arguments}
}
\details{
  The argument "prargs" is used to calculate the layout information
  about a print-run.  Components Block, Row and Columns denote the
  column names from the input data representing the print-tip location.
  The component "ncolumns" is an integer representing the number of
  print-tip columns in the data.  If the argument is set to NULL,
  the the following default will be used:  list(Block="Block",
  Row="Row", Column="Column", ncolumns=4). 
}
\value{
  Files of diagnostic plots and  excel files containings probe IDs of
  problematic probes.
}

\author{Jean Yee Hwa Yang}

\examples{
datadir <- system.file("gprQCData", package="arrayQuality")
if (interactive())
PRv9mers(fnames="12Mm250.gpr", path=datadir, prname="12Mm")
}
\keyword{hplot}% at least one, from doc/KEYWORDS

\name{readSpikeTypes}
\alias{readSpikeTypes}

\title{Read Spike Types File}

\description{
  Read a table containing information about the doping control mixture used in
  the hybridization.
}

\usage{
readSpikeTypes(file = "DopingTypeFile2.txt", path = NULL, cy5col = "MassCy5", cy3col = "MassCy3", ...)
}

\arguments{
  \item{file}{A "character" string giving the name of the file specifying
    the doping controls used.}

  \item{path}{A "character" string giving the directory containing the
    file. By default this is set to the current working directory
    (".").}
  
  \item{cy5col}{A "character" string describing the name of the column
    corresponding to the controls labelled with Cy5.}
  
  \item{cy3col}{A "character" string describing the name of the column
    corresponding to the controls labelled with Cy3.}
  
  \item{\dots}{Additional arguments passed to "readSpotTypes"}
}

\details{
   The file is a text file with rows corresponding to doping controls
   and columns describing various experimental conditions. It must
   contain an oligo sequence identifier for each control, the spike type
   (e.g. Ambion or MJ) and the mass of each oligo spiked in each
   channel. By default, this function assumes that the mass unit are the same.
}

\value{
  A list of n matrices, each matrix containing information about a unique
  type of spiked controls.  
}

\author{Agnes Paquet}



\examples{
datadir <- system.file("Meebo", package="arrayQuality")
if (interactive())
{
spikes <-
readSpikeTypes(file="StanfordDCV1.7complete.txt",path=datadir,cy5col="CY5.ng._MjDC_V1.7",cy3col="CY3.ng._MjDC_V1.7")
}
}
\keyword{data}% at least one, from doc/KEYWORDS

\name{readcontrolCode}
\alias{readcontrolCode}

\title{Control status information}
 
\description{
  This component reads spot type information from a tab delimited text
  file to a matrix.}

\usage{
readcontrolCode(file = "SpotTypes.txt", path = NULL, sep = "\t", check.names = FALSE, controlId=c("ID", "Name"), ...) 
}

\arguments{
  
  \item{file}{Character string giving the name of the file specifying the
    spot types.}
  
  \item{path}{Character string giving the directory containing the file.
    Can be omitted if the file is in the current working directory.}
  
  \item{sep}{the field separator character.}
  
  \item{check.names}{Logical, if 'FALSE' column names will not be converted to
    valid variable names, for example spaces in column names will not be left as is.}

  \item{controlId}{Character string. Name of the column of the gpr
    file used to define controls.}

  \item{\dots}{additional arguments}
}

\value{
  A 2 column matrix named controlCode.
  }

\author{Jean Yee Hwa Yang, Agnes Paquet}


\keyword{hplot}

\name{gprDB}
\alias{MmReferenceDB}
\alias{index.html}
\alias{HsReferenceDB}

\title{Reference slides for Mouse oligos hybridizations}

\description{
MmReferenceDB, HsReferenceDB: quality matrix compiling results from a pool of
good hybridization slides for Mouse and Human genomes respectively.

MmScalingTable, HsScalingTable: matrix of means and iqr calculated from the pool of good
hybridization slides for Mouse and Human genomes respectively, for each quality measure. It is used to scale
other arrays quality results.

index.html: HTML file used for quality report.
}

\source{These data were provided by members of the UCSF Shared
  functional genomics core lab.}

\keyword{datasets}

\name{prdata}
\alias{9Mm137.gpr}
\alias{12Mm250.gpr}
\title{Example GPR files}

\description{
  9Mm137.gpr is QCHyb from 9Mm printrun.
  
  12Mm250.gpr is a 9mers hybridization from 12Mm printrun.
}

\source{These data were provided by members of the UCSF Shared
  Functional Genomics Core Facility.}

\keyword{datasets}

\name{qualityScore}
\alias{qualityScore}

\title{Quality Control score for general hybridization}

\description{This function returns, for each quality measure, the
  percentage of reference slides measures which are below the tested
  slide values. For more details on this score, refer to the online
  manual.
}

\usage{qualityScore(slidequality, organism = c("Mm", "Hs"), reference =
NULL)
}

\arguments{
  \item{slidequality}{A quality matrix from slideQuality.}

  \item{reference}{A matrix resulting from globalQuality, to be used as
    reference table to compare slides. If 'NULL', the default table
    corresponding to organism will be used. See details for more
    information.}
  
  \item{organism}{A "character" string naming the organism genome
    printed on the array, either "Mm" or "Hs". By default, organism is
    set to "Mm". It is used to retrieve the corresponding reference tables.}
}


\value{QualityScore returns a matrix of percentages of qc measures under
  the lower limit of the reference values.}

\author{Agnes Paquet}

\keyword{programming}
